// AudioStream.h

#ifndef _INC_AUDIOSTREAM
#define _INC_AUDIOSTREAM

#include <dsound.h>

// Constants
#ifndef SUCCESS
#define SUCCESS TRUE        // Error returns for all member functions
#define FAILURE FALSE
#endif // SUCCESS


// Classes

// AudioStreamServices
//
// DirectSound apportions services on a per-window basis to allow
// sound from background windows to be muted. The AudioStreamServices
// class encapsulates the initialization of DirectSound services.
//
// Each window that wants to create AudioStream objects must
// first create and initialize an AudioStreamServices object. 
// All AudioStream objects must be destroyed before the associated 
// AudioStreamServices object is destroyed.

class AudioStreamServices
{
public:
    AudioStreamServices(HWND hwnd) : m_pdsb(NULL), m_pds(NULL), m_hwnd(hwnd) {};
    ~AudioStreamServices();
    BOOL Initialize();
	BOOL CreateBuffer();
    LPDIRECTSOUND GetPDS() { return m_pds; }
protected:
    HWND m_hwnd;
    LPDIRECTSOUND m_pds;
    LPDIRECTSOUNDBUFFER m_pdsb;    // sound buffer
	DSBUFFERDESC m_dsbd;
};

#endif // _INC_AUDIOSTREAM 