// **************************************************************************
// **           COME BACK 64 - A FREEWARE COMMODORE 64 EMULATOR            **
// **          WWW.CLASSICGAMING.COM/CB64       JHF@FAIRLIGHT.TO           **
// **************************************************************************
// ** MAIN PROGRAMMERS      : JOHAN FITI AND BRAD MARTIN                  **
// ** ROUTINE CONTRIBUTORS  : STEVEN H. DON - SOME SOUND FIXES             **
// **                         MASSIMILIANO AGOSTINELLI - CARTRIDGE LOADER  **
// ** SUPPORT               : PONTUS BERG (BACCHUS/FAIRLIGHT)              **
// **                         MARKO MAKELA (AUTHOR OF VARIOUS C64 DOCS)    **
// **                         PER HAKAN SUNDELL (AUTHOR OF CCS64)          **
// **                         MICHAEL SCHWENDT (AUTHOR OF SIDPLAY)         **
// **                         WOLFGANG LORENZ (AUTHOR OF PC64)             **
// **                         JOE FORSTER (STA, AUTHOR OF STAR COMMANDER)  **
// **                         PAUL TOTH (AUTHOR OF CBM64)                  **
// **                         DAAN VAN YPEREN (DYPER)
// **************************************************************************
// **  THE SOURCE AND BINARY OF COME BACK 64 ARE FREELY DISTRIBUTABLE, AS  **
// ** LONG AS THEY ARE KEPT INTACT AND ARE NOT CHANGED. THE LATEST VERSION **
// **         IS AVAILABLE FROM HTTP://WWW.CLASSICGAMING.COM/CB64          **
// **************************************************************************
// ** IF YOU MAKE A LINK TO THE COME BACK 64 PAGE ON YOUR WEB-SITE, OR IF  **
// ** YOU WANT TO MIRROR CB 64, YOU HEREBY HAVE MY PERMISSION, AS LONG AS  **
// **          YOU INFORM ME ABOUT THE URL WHERE THE LINKS IS ON.          **
// **************************************************************************




// -------------------------------------------------------------------------
//  NEW IN 0.97  NEW IN 0.97  NEW IN 0.97  NEW IN 0.97 
//
//  -- Sped up 360x240 mode (almost as fast as 320x200 now)
//  -- Fixed directory listing filesizes (LOAD"$",8)
//  -- Border scanlines added (no open border/DYSP effects yet)
//  -- Added cartridge memory configuration (set readonly)
// -------------------------------------------------------------------------

#include <windows.h>
#include <io.h>

//#define DEBUG

#define SOUND

#define VERMAJ 0
#define VERMIN 9
#define VERMINTWO 7


#define DEFAULTEMULATEDJOYSTICK 1

#define DEFAULTGAMMA 1.0

#define DEFAULTSKIPRATE 1

#define DEFAULTGRAYSCALEON 0

#define DEFAULTILLEGALOPCODE 0

// ADD BY MAX
///////////////////////////////////////////////////////////////////////////
// CARTRIDGE STRUCTURE TYPEDEF AND SOME GLOBAL
///////////////////////////////////////////////////////////////////////////
typedef struct CRT_str {
	unsigned char C64CART[16];
	unsigned long headerlen;
	unsigned int version;
	unsigned int hardtype;
	unsigned char exromline;
	unsigned char gameline;
	unsigned char dummy[6];
	unsigned char name[20];
	unsigned char chip[4];
	unsigned long packlen;
	unsigned int chiptype;
	unsigned int bank;
	unsigned int address;
	unsigned int length;
} CARTRIDGE;

void loadcrt (unsigned char fname[80]);
CARTRIDGE cart;          // Cartridge structure
unsigned char Cartflg=0; // Used in function CLEARMEM for detect cart emulation
char CurrentCrt[80],donone=0;     // Current cartridge name
///////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
int SBver,SBbase,SBint,SBdma8,SBdma16,SBcurdmahalf;
unsigned char showsid=0,interlaceline=1,interlaced=0,dointro=0,interl_on=2;
int frameskip=0,sbaddr; unsigned char volume=13,showvol=0;
int g_nSelect=0,scroll=0; unsigned char emuid=1;
int g_nSelectcart=0,scrollcart=0; int currsprite=0;
unsigned char vidmode=1;

#include <dos.h>

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <conio.h>

#include "sound.h"

#include "keys.h"

//Flags
#define NEGATIVE 128
#define F_OVERFLOW 64
#define BREAK    16
#define DECIMAL  8
#define INT      4
#define ZERO     2
#define CARRY    1

#define NEG_OFF  127
#define OVER_OFF 191
#define BRK_OFF  239
#define DEC_OFF  247
#define INT_OFF  251
#define ZERO_OFF 253
#define CRRY_OFF 254

typedef union
{
	struct { unsigned char l,h; } B;
	unsigned int W;
} pair;

/////////////////////////////////////////////////////////////////////////////

#include "6510.H"

/////////////////////////////////////////////////////////////////////////////


unsigned char key_table[128][2], key_pressed[255];

unsigned char oldkeycolumn,joytoemu=DEFAULTEMULATEDJOYSTICK;

unsigned char grayscale=DEFAULTGRAYSCALEON,restart=0,illopc=DEFAULTILLEGALOPCODE;

unsigned int PPORT,reset; unsigned char PPORTACT=0;
int vic_ecm,vic_bmm,vic_mcm,vic_den,vic_x,vic_y,vic_rsel,vic_csel,vic_xscrl,
vic_yscrl,vic_vm,vic_cb,vic_rasirq;
char vic_ec,vic_b0c,vic_b1c,vic_b2c,vic_b3c;
unsigned char kflag,bflag,charrom=1,notenow=1; unsigned int vic_bank;
int skipper=DEFAULTSKIPRATE;
int go, IRQ=0, modeset=0,allocated=0,done,rawkey; float gamma=DEFAULTGAMMA;
unsigned long cyc_orig,cyc_last=0;

unsigned long cycles=0,time=0;

unsigned char *BasicPointer, *KernalPointer,*RAMPointer; int percent=0;
unsigned char VICRegs[0x2F],SIDRegs[0x1D],CIA1Regs[0x10],CIA2Regs[0x10],*ColorPointer;
unsigned char *CharPointer,*Virtualscreen; unsigned char opcodestring[40];

unsigned char NMI=0;unsigned char ICR1set=0, enable1a=0, enable1b=0,ICR2set=0, enable2a=0, enable2b=0,sidon=1;
unsigned char autoskip=1,bcolor[311];
int modex_page;

unsigned int latch1a=0, latch2a=0,latch1b=0,latch2b=0;

unsigned int t1a,t2a,t1b,t2b;char key[127]; unsigned char keysdown,scan,vicram;

/////////////////////////////////////////////////////////////////////////////



#define JOYPORT 0x201

#define ATNOR 1

#define CLKOR 2

#define INITOR 4

#define DATAOR 8

#define ATNAND 254

#define CLKAND 253

#define INITAND 251

#define DATAAND 247



void loadprg (unsigned char filename[80]);
void putcbmchar (unsigned int letter,int xp,int yp,int fore,int back);
void spriteinfo (void);
void help (void);
void Cleanup(unsigned char message[161]);

////////////////////////////////////////////////////////////////////////////


unsigned char joyemu (void)
{
	unsigned char up=1,down=1,left=1,right=1,fire=1,joyvalue;
	if (key[KB_kp_8]) {up=0;}
	if (key[KB_kp_5]) {down=0;}
	if (key[KB_kp_4]) {left=0;}
	if (key[KB_kp_6]) {right=0;}
	if (key[KB_kp_plus]) {fire=0;}
	joyvalue=(up)+(2*down)+(4*left)+(8*right)+(16*fire);
	return (joyvalue);
}

////////////////////////////////////////////////////////////////////////////


void Message (unsigned char text[41],unsigned int delayed);

unsigned char Peek(unsigned int address)
{
	unsigned char ret;
	static unsigned char emudetect=0xAA;
	
	if(address<0xA000)
		ret=RAMPointer[address];
	else if(address<0xC000)
	{
		if((RAMPointer[1]&3)==3)
			ret=BasicPointer[address&0x1FFF];
		else 	ret=RAMPointer[address];
	}
	else if(address<0xD000)
		ret=RAMPointer[address];
	else if(address<0xE000)
	{
		ret=RAMPointer[1];
		if(ret&3)
			if(ret&4)
			{
				//IO chips
				if(address<0xD400) //VIC
				{
					address&=0x3f;
					if(address<0x2f)
						ret=VICRegs[address];
					else 	ret=0xFF;
					switch(address)
					{
					case 0x11:	if(vic_y&0x100)
									ret|=0x80;
						else	ret&=0x7F;
						break;
					case 0x12:	ret=vic_y&0xFF;
						break;
					}
				}
				else if(address<0xD800) //SID
				{
					address&=0x1F;
					if(address<0x1d)
						ret=SIDRegs[address];
					else	ret=0xFF;
					if(address==0x1C)
						ret= (unsigned char) SNDvoices[2].envx>>23;
				}
				else if(address<0xDBE8) //ColorRAM
					ret=ColorPointer[address&0x3ff]&0xF;
				else if(address<0xDC00) //Nothing, I think
					ret=0xFF;
				else if(address<0xDD00) //CIA 1
				{
					address&=0xF;
					ret=CIA1Regs[address];
					switch(address)
					{
					case 0:	if(joytoemu==1)
								ret=(ret&224)+joyemu();
						break;
					case 1:	ret=key_pressed[255-CIA1Regs[0]];
						if(joytoemu==2&&ret==255)
							ret=(ret&224)+joyemu();
						break;
					case 13:IRQ=CIA1Regs[13]=0;
						break;
					}
				}
				else if(address<0xDE00) //CIA 2
				{
					address&=0xF;
					ret=CIA2Regs[address];
					switch(address)
					{
					case 0:	/*ret=inp(PPORT);*/ ret=0;
						if(ret&CLKOR)
							CIA2Regs[0]&=0xBF;
						else	CIA2Regs[0]|=0x40;
						if(ret&DATAOR)
						{
							CIA2Regs[0]&=0x7F;
							PPORTACT=1;
						}
						else	CIA2Regs[0]|=0x80;
						ret=CIA2Regs[0];
						break;
					case 13:CIA2Regs[13]=IRQ=0;
						break;
					}
				}
				else if(address<0xDFA0) //Nothing or CIA2 echoes, not sure
					ret=0xFF;
				else
				{ret=0;
				if (emuid==1) {
					switch(address)
					{
					case 0xdfa0: ret='C'; break;
					case 0xdfa1: ret='O'; break;
					case 0xdfa2: ret='M'; break;
					case 0xdfa3: ret='E'; break;
					case 0xdfa4: ret=' '; break;
					case 0xdfa5: ret='B'; break;
					case 0xdfa6: ret='A'; break;
					case 0xdfa7: ret='C'; break;
					case 0xdfa8: ret='K'; break;
					case 0xdfa9: ret=' '; break;
					case 0xdfaa: ret='6'; break;
					case 0xdfab: ret='4'; break;
					case 0xdfac: ret=','; break;
					case 0xdfad: ret=' '; break;
					case 0xdfae: ret='V'; break;
					case 0xdfaf: ret=VERMAJ+'0'; break;
					case 0xdfb0: ret='.'; break;
					case 0xdfb1: ret=VERMIN+'0'; break;
					case 0xdfb2: ret=VERMINTWO+'0'; break;
					case 0xdfb3: ret=0x0d; break;
					case 0xdfb4: ret='C'; break;
					case 0xdfb5: ret='O'; break;
					case 0xdfb6: ret='P'; break;
					case 0xdfb7: ret='Y'; break;
					case 0xdfb8: ret='R'; break;
					case 0xdfb9: ret='I'; break;
					case 0xdfba: ret='G'; break;
					case 0xdfbb: ret='H'; break;
					case 0xdfbc: ret='T'; break;
					case 0xdfbd: ret=' '; break;
					case 0xdfbe: ret='1'; break;
					case 0xdfbf: ret='9'; break;
					case 0xdfc0: ret='9'; break;
					case 0xdfc1: ret='8'; break;
					case 0xdfc2: ret=' '; break;
					case 0xdfc3: ret='B'; break;
					case 0xdfc4: ret='Y'; break;
					case 0xdfc5: ret=' '; break;
					case 0xdfc6: ret='J'; break;
					case 0xdfc7: ret='.'; break;
					case 0xdfc8: ret='F'; break;
					case 0xdfc9: ret='I'; break;
					case 0xdfca: ret='T'; break;
					case 0xdfcb: ret='I'; break;
					case 0xdfcc: ret='E'; break;
					case 0xdfcd: ret=' '; break;
					case 0xdfce: ret='A'; break;
					case 0xdfcf: ret='N'; break;
					case 0xdfd0: ret='D'; break;
					case 0xdfd1: ret=' '; break;
					case 0xdfd2: ret='B'; break;
					case 0xdfd3: ret='.'; break;
					case 0xdfd4: ret='M'; break;
					case 0xdfd5: ret='A'; break;
					case 0xdfd6: ret='R'; break;
					case 0xdfd7: ret='T'; break;
					case 0xdfd8: ret='I'; break;
					case 0xdfd9: ret='N'; break;
					case 0xdfda: ret=0x00; break;
					case 0xdffc: ret=VERMIN*0x10+VERMINTWO; break;
					case 0xdffd: ret=VERMAJ; break;
					case 0xdffe: ret='J'; break;
					case 0xdfff: {ret=emudetect;emudetect=~emudetect;} break;
					}
				}
				}
			}
			else	ret=CharPointer[address&0x0FFF];
			else	ret=RAMPointer[address];
	}
	else	if(RAMPointer[1]&2)
		ret=KernalPointer[address&0x1FFF];
	else	ret=RAMPointer[address];
	return(ret);
}

unsigned int Deek(unsigned int address)
{
	return (unsigned int)Peek(address)+((unsigned int)Peek(address+1)<<8);
}

void Poke(unsigned int address, unsigned char value)
{
	unsigned char ret;
	ret=value;
	
	// ADD BY MAX
	///////////////////////
	// IF ANY CARTRIDGE IN USE WE CANNOT TO PERFORM WRITE OPERATIONS
	// IN CARTRIDGE AREA (I THINK).
	if (Cartflg) {if (address>0x8000 && address<0x9FFF) return;}
	////////////////////////////////////////////////////////////
	
	if(address<0xD000)
	{
		if(address==1)
		{
			ret&=0x3F;
			RAMPointer[1]&=~RAMPointer[0];
			RAMPointer[1]|=ret&RAMPointer[0];
		}
		else RAMPointer[address]=ret;
	}
	else if(address<0xE000)
	{
		if((RAMPointer[1]&7)>4)	//Write to I/O
		{
			if(address<0xD400)	//VIC
			{
				address&=0x3F;
				switch(address)
				{
				case 0x11:      vic_ecm=ret&0x40;
					vic_bmm=ret&0x20;
					vic_den=ret&0x10;
					vic_rsel=ret&8;
					vic_yscrl=ret&7;
					if(ret&0x80)
						vic_rasirq|=0x100;
					else	vic_rasirq&=0xFF;
					break;
				case 0x12:	vic_rasirq=ret;
					if(VICRegs[0x11]&0x80)
						vic_rasirq|=0x100;
					break;
				case 0x16:	ret|=0xA0;
					vic_mcm=ret&0x10;
					vic_csel=ret&8;
					vic_xscrl=ret&7;
					break;
				case 0x18:      ret|=1;
					vic_vm=((int)ret&0xF0)<<6;
					vic_cb=((int)ret&0xE)<<10;
					break;
				case 0x19:      ret=~(ret&0xF)&VICRegs[0x19];
					if(!(ret&VICRegs[0x1A]&0xF)&&(ret&0x80))
					{
						IRQ=0;
						ret&=0x7f;
					}
					ret|=0x70;
					break;
				case 0x1A:	ret|=0xF0;
					break;
				case 0x20: 	vic_ec=ret&0xF;
					ret|=0xF0;
					break;
				case 0x21:	vic_b0c=ret&0xf;
					ret|=0xF0;
					break;
				case 0x22:	vic_b1c=ret&0xf;
					ret|=0xF0;
					break;
				case 0x23:	vic_b2c=ret&0xf;
					ret|=0xF0;
					break;
				case 0x24:	vic_b3c=ret&0xf;
					ret|=0xF0;
					break;
				}
				if(address<0x2f)
					VICRegs[address]=ret;
			}
			else if(address<0xD800) //SID
			{
				address&=0x1F;
				if(address<0x1d)
				{
					ret=SIDRegs[address];
					SIDRegs[address]=value;
				}
				switch(address)
				{
				case 4: if((ret^value)&0xF1)
							if(value&1)
								SNDNoteOn(0);
							else	SNDNoteOff(0);
							break;
				case 5: SNDvoices[0].ar=ret>>4;
					SNDvoices[0].dr=ret&0xF;
					break;
				case 6:	SNDvoices[0].sr=ret&0xf;
					SNDvoices[0].sl=ret>>4;
					break;
				case 11:if((ret^value)&0xF1)
							if(value&1)
								SNDNoteOn(1);
							else	SNDNoteOff(1);
							break;
				case 12:SNDvoices[1].ar=ret>>4;
					SNDvoices[1].dr=ret&0xF;
					break;
				case 13:SNDvoices[1].sr=ret&0xf;
					SNDvoices[1].sl=ret>>4;
					break;
				case 18:if((ret^value)&0xF1)
							if(value&1)
								SNDNoteOn(2);
							else	SNDNoteOff(2);
							break;
				case 19:SNDvoices[2].ar=ret>>4;
					SNDvoices[2].dr=ret&0xF;
					break;
				case 20:SNDvoices[2].sr=ret&0xf;
					SNDvoices[2].sl=ret>>4;
					break;
				}
			}
			else if(address<0xDBE8) //ColorRAM
				ColorPointer[address&0x3ff]=ret&0xF;
			else if(address<0xDC00); //Nothing, I think
			else if(address<0xDD00)	//CIA 1
			{
				address&=0xF;
				CIA1Regs[address]=ret;
				switch(address)
				{
				case 4:	latch1a&=0xFF00;
					latch1a|=value;
					break;
				case 5: latch1a&=0xFF;
					latch1a|=(unsigned int)value<<8;
					break;
				case 6:	latch1b&=0xFF00;
					latch1b|=value;
					break;
				case 7: latch1b&=0xFF;
					latch1b|=(unsigned int)value<<8;
				case 13:if(value&0x01)	if(value&0x80)	ICR1set|=1;
					else 		ICR1set&=254;
					if(value&0x02) 	if(value&0x80) 	ICR1set|=2;
					else 		ICR1set&=253;
					if(value&0x04) 	if(value&0x80) 	ICR1set|=4;
					else 		ICR1set&=251;
					if(value&0x08) 	if(value&0x80) 	ICR1set|=8;
					else 		ICR1set&=247;
					if(value&0x10) 	if(value&0x80) 	ICR1set|=16;
					else 		ICR1set&=239;
					break;
				case 14:if(value&0x10)
						{
							ret&=0xEF;
							t1a=CIA1Regs[4]=latch1a;
						}
					enable1a=ret&0x01;
					break;
				case 15:if(value&0x10)
						{
							ret&=0xEF;
							t1b=CIA1Regs[6]=latch1b;
						}
					enable1b=ret&0x1;
					break;
				}
			}
			else if(address<0xDE00)
			{
				address&=0xF;
				CIA2Regs[address]=ret;
				switch(address)
				{
				case 0:	vic_bank=(~value&3)<<14;
					ret=244;
					if(value&0x08)
						ret|=ATNOR;
					if(value&0x10)
						ret|=CLKOR;
					if(value&0x20)
					{
						ret|=DATAOR;
						PPORTACT=2;
					}
					/*outp(PPORT,ret);*/
					break;
				case 4:	latch2a&=0xFF00;
					latch2a|=value;
					break;
				case 5: latch2a&=0xFF;
					latch2a|=(unsigned int)value<<8;
					break;
				case 6:	latch2b&=0xFF00;
					latch2b|=value;
					break;
				case 7: latch2b&=0xFF;
					latch2b|=(unsigned int)value<<8;
				case 13:if(value&0x01) 	if(value&0x80) 	ICR2set|=1;
					else 		ICR2set&=254;
					if(value&0x02) 	if(value&0x80) 	ICR2set|=2;
					else 		ICR2set&=253;
					if(value&0x04) 	if(value&0x80) 	ICR2set|=4;
					else 		ICR2set&=251;
					if(value&0x08) 	if(value&0x80) 	ICR2set|=8;
					else 		ICR2set&=247;
					if(value&0x10) 	if(value&0x80) 	ICR2set|=16;
					else 		ICR2set&=239;
					break;
				case 14:if(value&0x10)
						{
							ret&=0xEF;
							t2a=CIA2Regs[4]=latch2a;
						}
					enable2a=ret&1;
					break;
				case 15:if(value&0x10)
						{
							ret&=0xEF;
							t2b=CIA2Regs[6]=latch2b;
						}
					enable2b=ret&1;
					break;
				}
			}
		}
		else RAMPointer[address]=ret;
	}
	else RAMPointer[address]=ret;
}


////////////////////////////////////////////////////////////////////////////

// FIXME:
//	Removed disk label functionality

unsigned int Basic2_ProgLoad (void)
{
	struct _finddata_t ffblk; 
	struct diskfree_t free;
	
	unsigned int filelen; 
	unsigned int kk;
	
	FILE *infile; 

	unsigned int loadat; 
	unsigned char data,quit=0;
	unsigned char filename[20]; 
	unsigned int memptr;
	unsigned char L,chr,ok,done;
	unsigned int A; 
	long avail; unsigned int available; 
	unsigned char label[80] = "Unnamed"; // Disk label
	unsigned char fltcounter=0,number,linenum;

	unsigned char flt[112] = {
		192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,
			176,192,174, 32,176,174, 32,176,178,174, 32,176,174,176,174, 32,
			221,173,219,192,219,219,192,179,171,219,192,179,173,179,173,174,
			221,176,219,189,221,221,171,179,221,221,221,221,221,221,171,189,
			221,221,221,221,221,221,221,221,221,221,221,221,221,221,171,174,
			173,189,173,192,177,177,189,173,177,219,174,171,177,177,192,189,
			192,192,192,192,192,192,192,192,192,173,192,189,192,192,192,192
	};
	
	unsigned int whatreturn=0xf5d2; // return value
	
	L=Peek(0x00b7);
	A=Deek(187);

	memset( filename, 0, 20 );

	int namelen = 0;

	for ( int i = 0; i < L; i++)
	{
		chr= _toupper( Peek(A+i) ); 
		ok=0;
		
		if (chr>='A'&&chr<='Z') 
			ok=1;
		
		if (chr>='0'&&chr<='9') 
			ok=1;
		
		if (chr=='-'||chr=='('||chr==')'||chr=='$'||chr=='*'||chr=='?') 
			ok=1;

		if (chr=='*'||chr=='?') 
			ok=1; // WILDCARDS
		
		if (ok==1) 
		{
			filename[namelen++] = chr; 
			ok=0;
		}
	}
	
	if ( namelen==0 ) whatreturn=0xf710; // MISSING FILE NAME
	
	filename[namelen] = 0;
	strcat( filename, ".PRG" );
	
	if ((infile=fopen(filename, "rb")) == NULL) 
	{
		filename[namelen] = 0;
		strcat( filename, ".P00" );
	} // IF NOT THEN ADD .P00
	
	if ((infile=fopen(filename, "rb")) == NULL) 
	{
		if ( namelen !=0 ) 
			whatreturn=0xf704; // FILE NOT FOUND
	} 
	else 
	{
		// Skip header if it's a P00
		// FIXME: will not work for files with no extension and 0 at end.

		if (filename[strlen(filename)-1]=='0') 
		{
			fseek(infile,0x1a,0);
		}
		
		loadat = fgetc(infile); 
		loadat += fgetc(infile)*256;
		
		do 
		{
			RAMPointer[loadat++]= fgetc(infile); 

			if (feof(infile)) quit=1;
			if (loadat==0xffff) quit=1;
		} while ( quit==0 );
		
		RAMPointer[0x2e]=RAMPointer[0x30]=RAMPointer[0x32]= (unsigned char) ((loadat-1)>>8);
		RAMPointer[0x2d]=loadat++-1; 
		RAMPointer[0x2f]=loadat++-1; 
		RAMPointer[0x31]=loadat++-1;
	}
	
	if (filename[0]=='$'&&filename[5]==0) // LOAD DIRECTORY OF FILES
	{
		memptr=0x0801;
		// FIRST LINE - HEADER
		RAMPointer[memptr]=  4; memptr++;   RAMPointer[memptr]=  4; memptr++;
		RAMPointer[memptr]=  0; memptr++;   RAMPointer[memptr]=  0; memptr++;
		RAMPointer[memptr]= 18; memptr++;   RAMPointer[memptr]= 34; memptr++;
		// FIRST LINE - DISK NAME
		for (ok=strlen(label);ok<79;ok++) {label[ok]=32;} label[16]=0;
		strcpy (filename,label);
		for (ok=0;ok<strlen(filename);ok++)
		{  RAMPointer[memptr]=filename[ok]; memptr++;  }
		// FIRST LINE - MIDDLE
		RAMPointer[memptr]= 34; memptr++;   RAMPointer[memptr]= 32; memptr++;
		// FIRST LINE - DISK ID
		strcpy (filename,"00 2A"); for (ok=0;ok<strlen(filename);ok++)
		{  RAMPointer[memptr]=filename[ok]; memptr++;  }
		// FIRST LINE - END
		RAMPointer[memptr]=  0; memptr++;
		
		// ----------- LIST PROGRAMS
		/* ======= .PRG LISTING ======== */
		done = _findfirst("*.PRG",&ffblk);
		if (done==0) {while (!done) {
			kk=((long)ffblk.fsize+253)/254; filelen=kk;
			strcpy (filename,ffblk.name);done = findnext(&ffblk);
			filename[strlen(filename)-4]=0;
			RAMPointer[memptr]=  4; memptr++; RAMPointer[memptr]=  4; memptr++;
			RAMPointer[memptr]=filelen%256; memptr++; RAMPointer[memptr]=filelen/256; memptr++;
			if (filelen<100) {RAMPointer[memptr]=' '; memptr++;}
			if (filelen<10) {RAMPointer[memptr]=' '; memptr++;}
			RAMPointer[memptr]=' '; memptr++;
			RAMPointer[memptr]= 34; memptr++;
			for (ok=0;ok<strlen(filename);ok++) {RAMPointer[memptr]=filename[ok]; memptr++;}
			RAMPointer[memptr]= 34; memptr++;
			for (ok=0;ok<17-strlen(filename);ok++) {RAMPointer[memptr]=32; memptr++;}
			RAMPointer[memptr]='P'; memptr++;    RAMPointer[memptr]='R'; memptr++;
			RAMPointer[memptr]='G'; memptr++;    RAMPointer[memptr]='<'; memptr++;
			RAMPointer[memptr]= 0; memptr++;
		}}
		/* ======= .P00 LISTING ======== */
		done = _findfirst("*.P00",&ffblk);
		if (done==0) {while (!done) {
			kk=((long)ffblk.ff_fsize+253-0x1c/*for header*/)/254; filelen=kk;
			strcpy (filename,ffblk.ff_name);done = findnext(&ffblk);
			filename[strlen(filename)-4]=0;
			RAMPointer[memptr]=  4; memptr++; RAMPointer[memptr]=  4; memptr++;
			RAMPointer[memptr]=filelen%256; memptr++; RAMPointer[memptr]=filelen/256; memptr++;
			if (filelen<100) {RAMPointer[memptr]=' '; memptr++;}
			if (filelen<10) {RAMPointer[memptr]=' '; memptr++;}
			RAMPointer[memptr]=' '; memptr++;
			RAMPointer[memptr]= 34; memptr++;
			for (ok=0;ok<strlen(filename);ok++) {RAMPointer[memptr]=filename[ok]; memptr++;}
			RAMPointer[memptr]= 34; memptr++;
			for (ok=0;ok<17-strlen(filename);ok++) {RAMPointer[memptr]=32; memptr++;}
			RAMPointer[memptr]='P'; memptr++;    RAMPointer[memptr]='R'; memptr++;
			RAMPointer[memptr]='G'; memptr++;    RAMPointer[memptr]='<'; memptr++;
			RAMPointer[memptr]= 0; memptr++;
		}}
		// ----------- SHOW FAIRLIGHT ENDING
		for (linenum=0;linenum<7;linenum++) {
			RAMPointer[memptr]=  4; memptr++; RAMPointer[memptr]=  4; memptr++;
			RAMPointer[memptr]=0; memptr++; RAMPointer[memptr]=0; memptr++; //Size (0)
			RAMPointer[memptr]=' '; memptr++; RAMPointer[memptr]=' '; memptr++; RAMPointer[memptr]=' '; memptr++; RAMPointer[memptr]=34; memptr++;
			for (number=0;number<16;number++) {RAMPointer[memptr]=flt[fltcounter]; memptr++; fltcounter++;}
			RAMPointer[memptr]=34; memptr++; RAMPointer[memptr]=' '; memptr++; RAMPointer[memptr]='D'; memptr++;
			RAMPointer[memptr]='E'; memptr++; RAMPointer[memptr]='L'; memptr++; RAMPointer[memptr]='<'; memptr++;RAMPointer[memptr]=0; memptr++; //End
		}
		// ----------- END OF LIST - GIVE FREE BLOCKS
		_dos_getdiskfree(0, &free);
		avail=(long)free.avail_clusters*(long)free.bytes_per_sector*(long)free.sectors_per_cluster;
		avail=avail/254; if (avail>65535) avail=65535; available=avail;
		RAMPointer[memptr]= 4; memptr++; RAMPointer[memptr]= 4; memptr++;
		RAMPointer[memptr]=available%256; memptr++;RAMPointer[memptr]=available/256; memptr++;
		strcpy (filename,"BLOCKS FREE.");
		for (ok=0;ok<strlen(filename);ok++)
		{  RAMPointer[memptr]=filename[ok]; memptr++;  }
		RAMPointer[memptr]= 0; memptr++; RAMPointer[memptr]= 0; memptr++; RAMPointer[memptr]= 0; memptr++;
		// ----------- END OF FREE BLOCKS
		RAMPointer[memptr]=0;RAMPointer[memptr+1]=0;RAMPointer[memptr+2]=0;
		RAMPointer[0x2e]=RAMPointer[0x30]=RAMPointer[0x32]=(unsigned char)((memptr-1)>>8);
		RAMPointer[0x2d]=memptr++-1; RAMPointer[0x2f]=memptr++-1; RAMPointer[0x31]=memptr++-1;
		whatreturn=0xf5d2; // LOADING
	}
	
	return (whatreturn);
}


////////////////////////////////////////////////////////////////////////////



void flip (void)
{
	
	int x,y,xp,yp,col; unsigned char clr; unsigned int colpos=0;
	void *Realscreen,*border=&bcolor[30];
	if (showvol)
	{
		showvol--;
		for (xp=0;xp<114;xp++) {
			for (yp=0;yp<14;yp++) {
				Virtualscreen[102+320*168+xp+320*yp]=100;
		} }
		for (x=7;x<122;x++) {
			Virtualscreen[53534+x]=111;
			Virtualscreen[58334+x]=111;
		}
		for (x=0;x<15;x++) {
			Virtualscreen[53861+x*320]=111;
			Virtualscreen[53975+x*320]=111;
		}
		for (x=0;x<16;x++)
		{
			if (volume>=x) {col=107;
			for (xp=0;xp<4;xp++) {
				for (yp=0;yp<10;yp++) {
					Virtualscreen[54504+x*7+xp+320*yp]=col;
			}}}
		}
	}
	
	if (PPORTACT==1) {putcbmchar ('R'-64,39,24,1,0); PPORTACT=0;}
	if (PPORTACT==2) {putcbmchar ('W'-64,39,24,1,0); PPORTACT=0;}
	
	if (vidmode!=1)
		_fmemcpy((void *)0xA0000000L,Virtualscreen,64000);
	else {
	/*for (x=20;x<340;x++) {
	_asm{  mov bx,x        }
	_asm{  mov cx,bx       }
	_asm{  shr bx,2        }
	_asm{  and cx,3        }
	_asm{  mov dx,0x3c4    }
	_asm{  mov ax,0x0102;  }
	_asm{  shl ah,cl       }
	_asm{  out dx,ax       }
	_asm{  mov dx,bx       }
	_asm{  mov cx,1800     }
	for (y=0;y<200;y++) {
	clr=Virtualscreen[colpos];
	_asm{  add colpos,320  }
	_asm{  mov bx,dx       }
	_asm{  add cx,90       }
	_asm{  add bx,cx       }
	_asm{  push 0xa000     }
	_asm{  pop es          }
	_asm{  mov al,clr      }
	_asm{  mov es:[bx],al  }
	}
	_asm{  sub colpos,63999}
	}*/
		if(modex_page)
		{
			modex_page=0;
			Realscreen=(void *)0xA0000000L;
		}
		else
		{
			modex_page++;
			Realscreen=(void *)0xA0005460L;
		}
		for(x=0;x<4;x++)
		{
			asm mov dx,0x3c4
				asm mov ax,0x0102
				asm mov cx,x
				asm shl ah,cl
				asm out dx,ax
				asm push es
				asm push ds
				asm les di,border
				asm add di,239
				asm mov cx,240
v360p:			asm mov al,[es:di]
				asm add al,100
				asm mov ah,al
				asm push ax
				asm dec di
				asm loop v360p
				asm les di,Realscreen
				asm lds si,Virtualscreen
				asm add si,x
				asm mov dx,20
v360bt:			asm pop ax
				asm mov cx,45
				asm rep stosw
				asm dec dx
				asm jne v360bt
				asm mov dx,200
v360line:		asm pop ax
				asm mov cx,5
				asm rep stosb
				asm push ax
				asm mov cx,20
v360l:			asm mov bl,[ds:si]
				asm add si,4
				asm mov bh,[ds:si]
				asm add si,4
				asm mov al,[ds:si]
				asm add si,4
				asm mov ah,[ds:si]
				asm add si,4
				asm db 0x66
				asm shl ax,16
				asm mov ax,bx
				asm db 0x66
				asm mov [es:di],ax
				asm add di,4
				asm loop v360l
				asm pop ax
				asm mov cx,5
				asm rep stosb
				asm dec dx
				asm jne v360line
				asm mov dx,20
v360bb:			asm pop ax
				asm mov cx,45
				asm rep stosw
				asm dec dx
				asm jne v360bb
				asm pop ds
				asm pop es
		}
		asm mov ax,WORD PTR Realscreen
			asm mov al,0x0C
			asm mov dx,0x3D4
			asm out dx,ax
			asm mov ah,BYTE PTR Realscreen
			asm inc al
			asm out dx,ax
 }
}



/////////////////////////////////////////////////////////////////////////////



void putcbmchar (unsigned int letter,int xp,int yp,int fore,int back)

{
	
	int x,y,o,pos,col; unsigned int place;
	
	place=xp*8+320*yp*8;
	
	for (y=0;y<8;y++) {o=CharPointer[letter*8+y]; pos=128;
	
	for (x=0;x<8;x++) {
		
		col=back; if (o>=pos) {o=o-pos; col=fore;}
		
		Virtualscreen[x+320*y+place]=100+col; pos=pos/2;
		
	} }
	
}


/////////////////////////////////////////////////////////////////////////////



void showpercent (void)

{
	
	unsigned char r1,r2,r3; unsigned int ps;
	
	r1=0;r2=0;r3=0;
	
	r1=percent/100;r2=percent/10-r1*10;r3=percent-r1*100-r2*10;
	
	putcbmchar ('S'-64,24,24,1,0);
	putcbmchar (':',25,24,1,0);
	putcbmchar ('0'+skipper/10,26,24,1,0);
	putcbmchar ('0'+skipper%10,27,24,1,0);
	putcbmchar (' ',28,24,1,0);
	putcbmchar ('-',29,24,1,0);
	putcbmchar (' ',30,24,1,0);
	
	if (RAMPointer[678]==0) {putcbmchar ('N'-64,31,24,1,0);putcbmchar ('T'-64,32,24,1,0);
	
	putcbmchar ('S'-64,33,24,1,0);putcbmchar ('C'-64,34,24,1,0);putcbmchar (' ',35,24,1,0);}
	
	if (RAMPointer[678]==1) {putcbmchar ('P'-64,32,24,1,0);putcbmchar ('A'-64,33,24,1,0);
	
	putcbmchar ('L'-64,34,24,1,0);putcbmchar (' ',35,24,1,0); putcbmchar (' ',31,24,1,0);}
	
	putcbmchar (r1+'0',36,24,1,0);
	
	putcbmchar (r2+'0',37,24,1,0);
	
	putcbmchar (r3+'0',38,24,1,0);
	
	putcbmchar ('%',39,24,1,0);
	
}



/////////////////////////////////////////////////////////////////////////////



void CIA (void);
void Processor_hung (int curr_loc, int op,int from)

{
	
	int x,y; unsigned char col,text[40],hex[16]; unsigned int old;
	
	old=curr_loc; for (x=-1;x<201;x++) {
		
		for (y=-1;y<51;y++) {
			
			col=100;
			
			if ((x==2||x==3)&&(y>1&&y<48)) {col=101;}
			
			if ((y==2||y==3)&&(x>1&&x<198)) {col=101;}
			
			if ((x==196||x==197)&&(y>1&&y<48)) {col=101;}
			
			if ((y==46||y==47)&&(x>1&&x<198)) {col=101;}
			
			Virtualscreen[(x+60)+320*(y+75)]=col;
			
	} }
	
	for (x=0;x<10;x++) {hex[x]='0'+x;} for (x=0;x<6;x++) {hex[10+x]='A'+x;}
	
	strcpy (text,"ILLEGAL OP xx AT xxxx");
	
	text[11]=hex[op>>4];text[12]=hex[op&0xF];
	
	text[17]=hex[(curr_loc>>12)&0xF];text[18]=hex[(curr_loc>>8)&0xF];
	text[19]=hex[(curr_loc>>4)&0xF];text[20]=hex[curr_loc&0xF];
	
	for (x=0;x<strlen(text);x++)
		
	{col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,9+x,11,7,0);}
	
	strcpy (text,"  JUMPED FROM xxxx  ");
	text[14]=hex[(from>>12)&0xF];text[15]=hex[(from>>8)&0xF];
	text[16]=hex[(from>>4)&0xF];text[17]=hex[from&0xF];
	for (x=0;x<strlen(text);x++)
	{
		col=text[x];
		if(col>64&&col<91)
			col=col-64;
		putcbmchar (col,10+x,13,7,0);
	}
	flip();
	curr_loc=old;
	
	while(!key[KB_space]&&!done)
		CIA(); //Keep us from getting into tight, unescapable loops
}

/////////////////////////////////////////////////////////////////////////////



void clearmem (void)

{
	unsigned int temp;
	for (temp=0;temp<65535;temp++)
	{
		if(temp&0x80)
			RAMPointer[temp]=0x66;
		else	RAMPointer[temp]=0x99;
	}
	for(temp=0;temp<1000;temp++)
		ColorPointer[temp]=0;
	for(temp=0;temp<0x2F;temp++)
		VICRegs[temp]=0;
	for(temp=0;temp<0x1D;temp++)
		SIDRegs[temp]=0;
	for(temp=0;temp<0x10;temp++)
		CIA1Regs[temp]=CIA2Regs[temp]=0;
	RAMPointer[0]=0x2F;
	RAMPointer[1]=0x37;
	enable1a=enable1b=enable2a=enable2b=vic_den=vic_ec=vic_b0c=0;
	
	// ADD BY MAX
	//////////////////////////////////////////
	if (Cartflg) {loadcrt(CurrentCrt);}
	//////////////////////////////////////////
	
}



/////////////////////////////////////////////////////////////////////////////

void waitretrace (void)
{
	_asm {mov dx,0x3DA}
l1:
	_asm {in al,dx; and al,0x08; jnz l1}
l2:
	_asm {in al,dx; and al,0x08; jz l2}
}

/////////////////////////////////////////////////////////////////////////////


void SetMode(char mode)

{
	
	waitretrace ();
	asm {mov AH,0;mov AL, (mode);int 0x10;}
	
	if (mode!=0x03){_asm {mov  ah, 1;mov  cx, 0x1400;int  0x10}}
	
	if (mode==0x13&&vidmode==1) { // THANKS TO PAUL TOTH
		_asm{   mov   ax, 0x13       }
		_asm{   int   0x10           }
		_asm{   mov   dx, 0x3C4      }        /* Sequencer Register */
		_asm{   mov   ax, 0x0604     }        /* Disable Chain 4 Mode */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x0100     }        /* (A)synchronous Reset */
		_asm{   out   dx, ax         }
		_asm{   mov   dx, 0x3C2      }        /* VGA Misc Register */
		_asm{   mov   al, 0xE7       }        /* Use 28Mhz Clock & 60Hz */
		_asm{   out   dx, al         }
		_asm{   mov   dx, 0x3C4      }        /* Sequencer Register */
		_asm{   mov   ax, 0x0300     }        /* Restart Sequencer */
		_asm{   out   dx, ax         }
		_asm{   mov   dx, 0x3D4      }        /* VGA CrtC Registers */
		_asm{   mov   al, 0x11       }        /* CrtC register 11h */
		_asm{   out   dx, al         }        /* Load current value */
		_asm{   inc   dx             }        /* Point to data */
		_asm{   in    al, dx         }        /* Get CrtC register 11h */
		_asm{   and   al, 0x7F       }        /* Mask out Write protect */
		_asm{   out   dx, al         }        /* and send it back */
		_asm{   mov   dx, 0x3D4      }        /* VGA CrtC Registers */
		_asm{   cld                  }        /* Forward block load */
		_asm{   mov   ax, 0x6B00     }        /* Horizontal total          */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x5901     }        /* Horizontal displayed      */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x5A02     }        /* Start horizontal blanking */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x8E03     }        /* 8E - end horizontal blanking   */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x5E04     }        /* Start H sync.             */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x8A05     }        /* 8A - end H sync.               */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x0D06     }        /* Vertical total            */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x3E07     }        /* Overflow 0011-1110        */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x4109     }        /* Cell height  0100-0001    */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0xEA10     }        /* V sync. start             */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0xAC11     }        /* V sync. end/Prot CR0 CR7  */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0xDF12     }        /* Vertical displayed        */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x2D13     }        /* 2D offset       5A->180 40->128 */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x0014     }        /* DWord mode off            */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0xE715     }        /* V Blank start             */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0x0616     }        /* V Blank end               */
		_asm{   out   dx, ax         }
		_asm{   mov   ax, 0xE317     }        /* Turn on Byte mode         */
		_asm{   out   dx, ax         }
		_asm{   mov   dx, 0x3D4      }        /* VGA CrtC Registers */
		_asm{   mov   al, 0x11       }        /* CrtC register 11h */
		_asm{   out   dx, al         }        /* Load current value */
		_asm{   inc   dx             }        /* Point to data */
		_asm{   in    al, dx         }        /* Get CrtC register 11h */
		_asm{   or    al, 0x80       }        /* Mask *in* Write protect */
		_asm{   out   dx, al         }        /* and send it back */
		_asm{   mov dx,0x3C4         }
		_asm{   mov ax,0x0F02        }
		_asm{   out dx,ax            }
		_asm{   mov ax,0x0000        }
		_asm{   push 0xa000          }
		_asm{   pop es               }
		_asm{   xor di,di            }
		_asm{   mov cx,64800         }
		_asm{   rep stosw            }
	}
	
}



/////////////////////////////////////////////////////////////////////////////


void Cleanup(unsigned char message[161])
{
	int a,b,c;
	struct dostime_t t; _dos_gettime(&t);
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	while(inp(0x64)&2);
	outp(0x60,0xED);
	while(inp(0x64)&1==0);
	while(inp(0x60)!=0xFA);
	outp(0x60,SNDkeys);
	if(modeset)SetMode(0x03);
	textcolor (7); textbackground(0); clrscr();
	printf ("END OF EMULATION AT %d:%02d:%02d\n\n",t.hour,t.minute,t.second);
	a=VERMAJ+'0';
	b=VERMIN+'0';
	c=VERMINTWO+'0';
	if(allocated){
		printf (" Releasing allocated memory...");
		farfree(BasicPointer);farfree(KernalPointer);farfree(Virtualscreen);
		farfree(RAMPointer); farfree(CharPointer);printf ("Done\n");}
	/*printf (" Cleaning up LPT1...");
	outp(PPORT,0);delay(500);outp(PPORT,255); printf ("Done\n");*/
	printf (" Showing exit screen...\n\n"); clrscr ();
	printf ("Come Back 64 v%c.%c%c - Commodore 64 Emulator                               \n"
		"Copyright (C) 1998 JHF Software                                   \n"
		"Written by Johan Fiti and Brad Martin                                 \n"
		"All Rights Reserved                                                    \n"
		"Internal ROMs are copyright (C) Commodore Business Machines       \n"
		"                                                                         \n"
		"This is an *OFFICIAL* FairLight release                                       \n"
		"Visit FairLight at http://www.fairlight.to                          FREEWARE  \n"
		"                                                                  COMMODORE 64\n"
		"CB64 is freeware and may be freely distributed (unmodified)         EMULATOR  \n"
		"Visit the CB64 homepage at www.classicgaming.com/cb64                         \n",a,b,c);
	for (a=60;a<80;a++) {for (b=0;b<6;b++) {pokeb (0xb800,a*2+160*b+1,1);} }   // Blue
	for (a=72;a<80;a++) {for (b=3;b<5;b++) {pokeb (0xb800,a*2+160*b+1,4);} }   // Red
	for (a=60;a<80;a++) {for (b=7;b<10;b++) {pokeb (0xb800,a*2+160*b+1,15);} } // White
	if (message[0]!=0) printf ("\n\nERROR: '%s'\nFOR MORE INFORMATION PLEASE EMAIL TO JHF@FAIRLIGHT.TO\n",message);
	printf ("");
	exit(0);
}



/////////////////////////////////////////////////////////////////////////////



void AllocMem(void)

{
	
	if((BasicPointer=(char *)farmalloc(8192))==NULL) Cleanup ("Cannot allocate 8K for BASIC");
	
	if((KernalPointer=(char *)farmalloc(8192))==NULL) Cleanup ("Cannot allocate 8K for Kernal");
	
	if((RAMPointer=(char *)farmalloc(65536))==NULL) Cleanup ("Cannot allocate 64K for RAM");
	
	if((CharPointer=(char *)farmalloc(4096))==NULL) Cleanup ("Cannot allocate 4K for CHAR");
	
	if((ColorPointer=(char *)farmalloc(1000))==NULL) Cleanup ("Cannot allocate 4K for Color");
	
	if((Virtualscreen=(char *)farmalloc(65536))==NULL) Cleanup ("Cannot allocate 64K for virtual screen");
	
	allocated=1;
}



/////////////////////////////////////////////////////////////////////////////



void LoadROM(void)

{
	
#include "ROMS.H"
	FILE *infile;
	int index; unsigned char t,message[40];
	
	if ((infile=fopen("BASIC.ROM", "rb")) == NULL) {
		printf ("\n   Loading internal Basic V2 ROM...");
		for(index=0;index<8192;index++) {BasicPointer[index]=ORIGINAL64B[index];}
	} else { printf ("\n   Loading external BASIC.ROM...");
	for (index=0;index<8192;index++) { BasicPointer[index]=fgetc(infile);} fclose(infile);}
	
	if ((infile=fopen("KERNAL.ROM", "rb")) == NULL) {
		printf ("\n   Loading internal Kernal rev. 3 ROM...");
		for(index=0;index<8192;index++) {KernalPointer[index]=ORIGINAL64K[index];}
	} else { printf ("\n   Loading external KERNAL.ROM...");
	for (index=0;index<8192;index++) { KernalPointer[index]=fgetc(infile);} fclose(infile);}
	
	if ((infile=fopen("CHAR.ROM", "rb")) == NULL) {
		printf ("\n   Loading internal character ROM...");
		for(index=0;index<4096;index++) {CharPointer[index]=ORIGINAL64C[index];}
	} else { printf ("\n   Loading external CHAR.ROM...");
	for (index=0;index<4096;index++) { CharPointer[index]=fgetc(infile);} fclose(infile);}
}



/////////////////////////////////////////////////////////////////////////////



void Message (unsigned char text[41],unsigned int delayed)

{
	
	int x,y; unsigned char col,xpos;
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	
	xpos=20-strlen(text)/2; for (x=-1;x<201;x++) {
		
		for (y=7;y<43;y++) { col=100; if ((x==2||x==3)&&(y>9&&y<40)) {col=101;}
		
		if ((y==10||y==11)&&(x>1&&x<198)) {col=101;} if ((x==196||x==197)&&(y>9&&y<40)) {col=101;}
		
		if ((y==38||y==39)&&(x>1&&x<198)) {col=101;} Virtualscreen[(x+60)+320*(y+75)]=col;
		
		} } for (x=0;x<strlen(text);x++) {col=text[x]; if (col>64&&col<91) col=col-64;
		
		putcbmchar (col,xpos+x,12,7,0);} flip(); delay (delayed);
		
}



/////////////////////////////////////////////////////////////////////////////



void LoadMonitor (void)

{
	
	unsigned char MONITOR[4452]={
		1,8,11,8,'',7,'','2','4','5','6',0,0,0,0,0,0,'',6,'','','','','',
			0,30,'0','`','`','`','f','<',0,'',6,'','','','','',0,'',0,'','',
			'','','|',0,'',0,'','','','','`',0,'|','','','','','','|',
			0,'',6,'','','','','f',0,'',0,'0','0','0','0','|',0,'~',0,24,24,
			'','','p',0,'',12,'','','','','F',0,'',0,'','','','','',0,
			'&','p','','','','','f',0,'f','','','','','','f',0,'|','','',
			'','','','|',0,'',6,'','','','','`',0,'|','','','','','',
			'v',0,'',6,'','','','','f',0,'|','','','|',6,'','|',0,'',0,'8',
			'8','8','8',28,0,'','','','','','n','>',0,'','','','','f','6',
			28,0,'f','','','','','v','2',0,'f','','|',24,'|','','f',0,'','',
			'','l','8','8','8',0,'~','F',12,24,'0','f','|',0,'U','','',255,255,
			'','','U','','','','','','','','','b','f',12,24,'0','f','F',
			0,'<','f','<','8','g','f','?',0,6,12,24,0,0,0,0,0,0,0,0,0,0,0,0,0,'<',
			'<','<',24,0,24,24,0,0,0,0,0,0,24,24,'0',0,0,0,'~',0,0,0,0,0,0,0,0,0,24,
			24,0,24,'0','0','`','`','0','0',24,'8','`',24,24,24,24,28,0,'<','`',6,
			28,'0','f','|',0,'|',0,6,'<',6,'f','<',0,28,' ','l','','',12,14,0,'',
			0,'','',6,'','|',0,'<','f','','','','','|',0,'',0,12,12,24,24,
			24,0,'|','','','|','','','|',0,'|','','','~',6,'','|',0,0,0,24,
			0,0,24,0,0,'<','f',6,12,24,0,24,0,24,12,12,6,6,12,12,24,'>','`','','',
			'','','f',0,' ','[',255,'x','',1,'','','','','',24,'','','',
			0,'','','','',9,'','','','','',9,'','','','',19,'','',255,
			'','','',255,255,'','',9,'',3,'','',9,'L','',9,'','/','',1,
			'',20,3,'',13,'',21,3,'','','',13,'','','','',2,'','K','',
			'',11,'',6,'','',24,'','','B','','','',11,'','-','','','',
			11,'','O','','','',11,'','Z','','','x','','','','','','',
			11,'','s','','','',11,'','','','',26,12,'','','','','#',12,
			'','','','','','','','8',255,'','0',12,'','$',255,'','H',255,
			'','D',12,'','','','','M',12,'',24,255,'','Y',12,'','V',255,'',
			'',12,'',0,'','',0,'','',3,'',8,'',17,'','[','','',255,'',
			1,'','T','','m',11,'','d','',0,'','','s',11,'',0,'','','0',3,
			'L','',9,'','X','','@','','V','','W',' ','&',13,'','',2,'','',
			'',9,'',0,'','',' ','','',1,'','@','','',0,'','',0,'','@',
			'','','','','',5,'','t',11,'',' ','','','',10,'','','','',
			'','',16,'','','','U','','+','','',12,'','',2,'','',2,'',
			'','','','',20,13,'','',3,'',29,13,'','',3,'','',12,'','',
			'',15,'','',7,'','',8,'','','',1,' ',14,11,'',6,'','',12,'',
			'',0,'',16,'',' ',14,11,'',1,'','^','','','m','','',4,'','',
			'','','S',255,'',1,'X','','','','',10,'',8,'','',12,'',255,
			'',1,11,'',255,'*','',255,'`',' ','',10,'','','',9,' ','',10,'',
			'','',2,'','','','','','','','',16,'','','',24,'e','','i',
			1,'','','',2,'','','','','','','`','x','',1,'',0,'',0,'',
			'@',18,'',1,8,'','',10,'','','','','',6,'',11,'','','','E',
			3,'','H',3,'','','','','','','','','-','',15,'','','','.',
			'',1,'X','L','','','W','',6,'','W','',24,1,'H',15,'x',12,0,11,'',
			1,'',15,8,12,'8',11,'',27,1,0,0,255,'',0,18,1,1,0,255,255,0,0,0,0,2,
			10,0,5,1,13,13,13,13,13,13,13,13,0,0,3,'',6,3,'',4,6,',',5,3,'',5,3,
			'',5,6,'',6,3,'',6,2,'',6,1,10,13,6,',',5,3,'',5,2,'',4,1,'',5,
			6,'',6,'',4,6,'B',3,0,0,0,'`',0,0,3,')','4',1,'',':',1,8,'>',1,')',
			'4',4,'','E',2,8,'>',1,'',':',1,8,'>',4,'',':',6,')','4','','E',6,
			39,'N',3,39,'N',1,'','R',1,39,'N',1,'','R',4,39,'N',2,'','E',1,8,'>',
			1,'','E',4,'',':',6,')','4',2,'',':',2,'x','.',6,')','4',2,10,13,2,
			10,13,1,'',14,1,'',15,2,'',20,2,'',19,2,'h',17,2,'',15,2,'',14,2,
			'',15,6,'',15,3,'',15,1,'h',17,2,'',14,'',9,2,10,13,2,'',14,2,'',
			15,2,1,'',15,6,10,13,6,10,13,9,'',15,3,'',14,6,10,13,6,19,39,9,'',
			34,3,4,31,6,20,26,3,20,26,2,20,26,1,19,39,6,'f',')',3,'',34,2,4,31,1,
			'F',29,6,20,26,3,20,26,3,'',19,6,'',20,4,4,31,5,'',34,3,20,26,'2','2',
			'2','3','4','5','6','8','9',';','=','?','A','C','F','H','K','N','P','S',
			'U','W','Y','\\','_','a','d','f','i','k','m','o','q','s','u','v','x','y',
			'z','z','{','{','{',' ',28,27,'x',4,'',0,'',255,'U','',3,21,2,255,255,
			255,255,'','','',255,255,'',4,'J','','Q','$',0,0,'z','','','',
			'z',0,0,34,'T','','','','','%','H','o',0,0,0,8,16,'.','N',0,0,0,8,
			'@','',10,0,0,0,7,'@',10,10,0,'}','',31,2,10,10,1,1,1,10,10,2,6,14,14,
			1,1,1,14,14,6,'','','','9','',15,'',':','`','',1,'',25,'','',
			1,'','','','',24,'x',' ',21,'',' ','','',' ','[',255,'','@','',
			'7',11,'',';',3,'','','','L','<',3,'','5','',1,'','T','',3,'L',
			'',13,'',10,'','T','',2,'','X','','U','','','',10,'H',10,10,'8',
			'','','','','U','',4,'','h','','','d',0,'','',24,'i',3,'','d',
			0,'','e',0,'','','i',0,'','e',0,'',2,'','','','#','','^','',
			'','','','[','',1,'','a','','','','','X','',22,'',10,'','',
			0,'','','d',0,'',1,'','','e',0,'','','','',0,'','','',16,'',
			'','',')',7,24,'i',4,'',10,'','','[','',0,'','','^','',1,'',
			'','\\','',7,'','','_','',8,'','',']','',14,'','','`','',15,
			'','','U',5,'a','',4,'','','V',5,'b','',11,'','','W',5,'c','',
			18,'','','7','',1,'',2,'','','V','',2,'',0,'',2,'','',2,'',
			14,'',1,'','','',16,'','','','{','',5,'','2','',4,'','',27,
			'','','','',0,'',18,'','','','','',3,'','',18,'','',18,'',
			'','','','!','','','','*','','','',18,'','','','','','',
			9,'',22,'','','d','','','','','','',22,'','',9,'',9,16,39,
			'',7,'',9,'','!',7,'',' ',7,'','',39,'','','',0,'',1,'','9',
			'',5,' ','&',13,'','','','G',7,'',1,'','9','',2,'',':','',' ',
			'','',0,'','!','','',' ','','','',39,'','','','G','','L','1',
			'',255,255,'',5,0,2,0,0,12,0,0,'T',0,0,1,0,0,3,16,'<','<','','','',
			14,':',':',' ',' ','(','@','@','P',2,0,0,'','!',17,0,1,0,'','','',
			'A',0,'',0,'B',' ','','','',8,0,'A',0,'',0,'','(','',17,'',8,0,
			'A',16,'',0,'','.','','!',22,'&',16,'',5,0,17,0,'',0,'',' ','',
			'!','',8,0,'','',1,1,1,3,3,'','','',1,1,1,3,3,'',255,'','',5,
			'','','',5,'',255,'','',1,1,1,3,3,'','','',1,1,1,3,3,'',255,
			'','',2,'','','',2,'','',4,6,'',2,'','','',2,'','',4,7,8,
			8,9,'',10,'',4,6,255,19,22,26,'%',',','W','B','j','','','','',11,
			22,'',0,255,'','',24,255,'','','C','A','C','F','H','F','C','A',255,
			'',22,24,'',24,'',255,'','','H','F','C','','F','','H','','','',
			'C','A','C','','F','','C','','',255,'','H','F','C','','F','','H',
			'','','','K','H','K','','O','','T','','',255,'','','0',0,'0',
			0,',','0',0,'0',0,',','0',0,'3',0,'0',0,255,'','H','F','C','F','H','F',
			'H','','H','','','','K','H','F','H','','T','','R','','T','','',
			255,'','W','','T','','R','','T','','',255,'','W','T','R','T','',
			'W','','R','','T','','',255,'','W','T',255,0,'',0,0,0,8,5,25,' ',
			4,21,4,5,19,' ','2',14,4,' ',23,5,12,3,15,13,5,' ',20,15,' ',10,8,6,31,
			19,' ',6,9,18,19,20,' ',6,'2',9,18,12,9,7,8,20,' ',16,18,15,4,21,3,20,
			'/',' ',3,15,13,5,' ',2,'2',3,11,' ','+',')',34,' ',3,15,13,13,15,4,15,
			18,5,' ','+',')',' ',5,13,21,12,'2',20,15,18,'$',' ',8,15,16,5,' ',25,
			15,21,' ',12,9,11,5,' ',9,20,' ',2,5,3,'2',21,19,5,' ',2,21,20,3,8,'2',
			' ','2',14,4,' ',9,' ',19,16,5,14,20,' ','2',' ',12,15,20,' ',15,6,' ',
			20,9,13,5,' ',3,18,5,'2',20,9,14,7,' ',9,20,' ','%','2',14,4,' ',23,5,
			31,18,5,' ',19,20,9,12,12,' ',2,21,19,25,' ',23,9,20,8,' ',9,20,'!','1',
			'$',' ',25,15,21,' ',3,'2',14,' ',4,15,23,14,12,15,'2',4,' ',20,8,5,' ',
			12,'2',20,5,19,20,' ',22,5,18,19,9,15,14,' ','2',14,4,' ',19,15,21,18,
			3,5,3,15,4,5,' ',6,18,15,13,' ',13,25,' ',23,5,2,16,'2',7,5,' ','2',20,
			' ',8,20,20,16,'/',31,31,13,5,13,2,5,18,19,'$',24,15,15,13,'$',3,15,13,
			31,10,6,9,20,9,5,'$',' ',9,' ','2',12,23,'2',25,19,' ',12,9,11,5,' ',20,
			15,' ',8,5,'2',18,' ',23,8,'2',20,' ',25,15,21,' ',20,8,9,14,11,' ',15,
			6,' ',9,20,34,' ',5,13,'2',9,12,' ',13,5,' ','2',20,' ',10,8,6,' ','%',
			'2',20,'1',' ',6,'2',9,18,12,9,7,8,20,'$',20,15,'$',' ',23,5,12,12,' ',
			14,15,23,' ',6,15,18,' ',19,15,13,5,' ',17,21,9,3,11,' ',7,18,5,5,20,26,
			'/',' ',2,'2',3,3,8,21,19,' ','#',' ',22,4,11,' ','#',' ',4,25,16,5,18,
			' ','#',' ',20,5,18,18,'#',5,' ','#',' ',22,15,25,'2',7,5,18,' ','#',' ',
			8,15,12,12,9,5,' ','#',' ',18,9,3,11,' ','#',' ',10,15,5,' ','#',' ',19,
			20,'2',' ','#',' ',19,8,4,' ','#',' ','2',14,4,' ',20,8,5,' ',3,15,13,
			16,12,5,20,5,' ',6,'2',9,18,12,9,7,8,20,' ',3,18,5,23,'$',' ',19,12,5,
			5,16,' ',20,9,7,8,20,' ','2',14,4,' ',8,'2',16,16,25,' ',4,18,5,'2',13,
			9,14,7,'!',' ',10,8,6,' ',15,6,' ',6,'2',9,18,12,9,7,8,20,' ',19,9,7,14,
			9,14,7,' ',15,21,20,'$','$','$',' ',' ',' ',' ',' ',' ',' ',' ','#','#',
			23,18,'2',16,'#','#',' ',' ',' ',' ',' ',' ',' ',' ',0,22,8,20,'','',
			' ','2','0','7','2',' ','F','L','T','P','A','C','K','E','R',0,0,0,'',
			'x','','0','',1,'','w','','S',8,']',3,8,'',0,1,'',16,'','',8,'',
			24,'',22,'','',15,'I',0,'','',22,'','',255,'','','','4',8,'',
			'9',8,'','','','','','',15,'','-','','.','L',0,1,'','','/',13,
			'','','','{','','','a','','t','','','','h',26,'','','h','P',
			'',7,'','~','','','o','','~','','p','',10,'{','.','','','u','Z',
			39,'','`','','F','','i',5,'','','-','3','G',7,'','0','','V',']',
			'',25,'','a','','','','U','','j','>','','','',',','-','(','',
			0,'','',19,'','','','+','','','',17,'','t','',13,'$','*','',
			'','','-','i','','K','','','','','$','A','','^','','','','9',
			'','b','%','u','',0,1,8,'0','',13,8,10,0,'',' ','7','8','0',',','0',
			0,22,8,20,0,'',34,'',34,0,'!',8,30,0,'',' ','4','0','9','6',0,'/',8,
			'#',0,'',' ','X','','1','','5',':','',0,':',8,'(',0,'',' ','4','0',
			'9','9',0,'F',8,'2',0,'',34,19,'','','',34,0,'R',8,'<',0,'',34,19,
			'','','',1,'',34,0,'[',8,'F',0,'',' ','3','5','',255,0,'',255,0,
			'',255,0,'',255,0,'',255,0,'',255,0,'','',0,'',0,' ',0,16,'','p',
			'',18,'','','','',' ','',' ',3,16,'',' ','','L',5,15,'','',0,
			'L','`',16,'L','',16,0,0,'',21,0,24,'',0,4,8,'',21,'',21,'',21,1,
			0,'',21,'',21,'',21,2,0,'T','U','N','E','D',' ','I','N','!','.','.',
			'.','M','A','D','E',' ','B','Y',' ','J','C','H',' ','2','5','/','0','7',
			'-','8','8','J','C','H',' ','N','E','W','P','L','A','Y','E','R',' ','V',
			'0','1','.','0','0',' ','B','Y',' ','J','.','C','.','H','U','U','S',10,
			10,10,'','',0,'',16,16,'','',20,'','',20,'',17,16,'','',20,'',
			'',20,'','','','',3,'','','',16,16,'',15,21,'',0,'','',',',
			21,'','',18,'','','',0,'','',0,'','','',25,'','','','','',
			4,'','',11,'','',18,'','',3,'',3,'','',1,'',10,'','',17,'',
			'',15,'',24,'','',1,'',20,21,'',0,'',21,21,'',255,'',22,21,'',
			'D',21,'','E',21,'','F',21,'',1,'','>',21,'',2,'','?',21,'',3,'',
			'@',21,'',17,21,'',18,21,'',19,21,'`','','','H','','','H','',2,
			'','',20,'','','','',20,'','','',12,21,'',20,21,'0',3,'L',')',
			18,'',17,21,'',20,21,'','/',21,'',3,'L','',17,'',0,'','','','',
			16,27,'','','','',0,21,'','','',3,21,'','',21,'','','',8,22,
			'','','','/',21,'L','',17,'H',')','','','','',24,'h',')',15,'',
			'A',21,'','',24,'i',1,'',6,21,'','','i',0,'',9,21,'L','f',17,')',
			'','','','',19,'h',')',31,'8','',12,10,'',',',21,'','','','',
			'','','L',20,17,'h','','','',18,'','A',21,'0','','',6,21,'','',
			'',9,21,'','','L',20,17,'','',20,'','','','',20,'','','L',6,
			17,'',0,'','','','',16,';','','','','/',10,'','$',24,'}',10,16,
			24,'}',',',21,'','','4',20,24,'}',13,16,'',23,21,'','5',20,'i',0,'',
			26,21,'','2',21,'',';',21,'L','',17,'','','','#',21,'L',24,18,'',
			255,'','#',21,'L',24,18,'H',')','','','','',17,'h',')',15,10,10,24,
			'i',3,'',20,21,'',17,21,'L',15,18,')','','','','',11,'h','',4,10,
			'','8',21,'L',15,18,'h','',0,'','/',21,'',0,21,'','','',3,21,'',
			'','','','',2,'','','L',12,17,'','','',2,'','','','>',21,'',
			'5',21,'',3,'L',8,19,'','5',21,'',8,'','5',21,'',3,'L',8,19,'','#',
			21,'','&',21,'',';',21,'',3,'L','',18,'',0,'',';',21,'',23,21,'',
			29,21,'',26,21,'',' ',21,'','8',21,'','t',21,'',')',21,'','u',21,
			'',12,21,'',5,'','','8',21,'','v',21,'',12,21,'',6,'','','8',
			21,'','x',21,'H',')',15,'','h',21,'h',')','','J','J','','_',21,'',
			'Y',21,'',0,'','e',21,'8','','Y',21,'','\\',21,'','y',21,'','b',
			21,'','z',21,'H',')','','','q',21,'h',')',15,'','n',21,'','{',21,
			'','k',21,'','|',21,'H',')','','',16,'','2','h',')',15,10,'','D',
			21,'','}',21,'H',')','','',4,'J','','J',21,24,'i',2,'','G',21,'',
			0,'','V',21,'','S',21,'h',')',15,10,'','M',21,'','~',21,'','P',21,
			'L','',18,'h','',255,'','D',21,'','2',21,'',16,'',0,'','2',21,'',
			12,21,'',')',21,')','','',4,'','','b',21,'',':','','_',21,'','_',
			21,16,11,'','\\',21,'',27,'','Y',21,'','_',21,'','e',21,24,'}','b',
			21,'','e',21,'','h',21,'i',0,'','h',21,'L','G',19,'','e',21,'8','',
			'b',21,'','e',21,'','h',21,'',0,'','h',21,'','n',21,'','7','','n',
			21,'','k',21,'',12,21,'=','&',21,'',4,'','','q',21,'','','',3,
			'L',255,19,'','4',20,24,'}',13,16,'',12,21,'',0,'','','q',21,'',
			'5',20,'i',0,'',12,21,'',1,'','L',14,20,'','D',21,'',8,'0','i','',
			'D',21,'L','',19,'','J',21,'',34,'','G',21,'0','3','','V',21,'',
			2,'',22,'',29,21,24,'}','P',21,'',29,21,'',' ',21,'}','S',21,'',' ',
			21,'L','',19,'',29,21,'8','','P',21,'',29,21,'',' ',21,'','S',21,
			'',' ',21,'L','',19,'','V',21,24,'i',1,')',3,'','V',21,'','J',21,
			'','G',21,'','P',21,24,'}','M',21,'','P',21,'','S',21,'i',0,'','S',
			21,'L','',19,'',12,21,'',')',21,'=','&',21,'',4,'','',12,21,'',
			29,21,'',0,'','',' ',21,'',1,'','','e',21,'',2,'','','h',21,'',
			3,'','','','','',20,'','','','',20,'',20,21,'','0',3,'L','',
			16,'h','','','h','','','`',22,1,39,1,'8',1,'K',1,'_',1,'s',1,'',1,
			'',1,'',1,'',1,'',1,14,2,'-',2,'N',2,'q',2,'',2,'',2,'',2,19,3,
			'B',3,'t',3,'',3,'',3,27,4,'Z',4,'',4,'',4,',',5,'{',5,'',5,39,6,
			'',6,'',6,'Q',7,'',7,'7',8,'',8,'7',9,'',9,'W',10,'',10,'',11,'N',
			12,9,13,'',13,'',14,'',15,'n',16,'h',17,'n',18,'',19,'',20,'',21,
			'9',23,'',24,19,26,'',27,'F',29,4,31,'',' ','',34,'','$',16,39,'^',
			')','','+','r','.','8','1','&','4','B','7','',':',8,'>','','A','',
			'E','','I',' ','N','','R','','W','','\\','p','b','L','h','','n',24,
			'u',16,'|','p','','@','','p','','@','','x','','X','','','','',
			'','','',8,'','0','',' ','','.','',25,'\\',34,22,22,22,'','',
			'',21,21,21,'','','',21,21,21,'','','',21,21,21,0,7,14,1,0,15,7,
			3,12,3,2,'Z','',12,4,34,31,'Z','','',4,34,34,'',6,255,'A',17,'A',0,
			0,0,1,1,1,0,0,1,0,0,3,0,'0',16,0,0,1,1,2,3,0,2,3,255,24,6,16,18,5,19,5,
			14,20,19,'/',255,'C',5,'$','$','$',20,8,5,' ',8,15,13,5,' ',15,6,' ',20,
			8,5,' ',18,5,'2',12,' ',3,18,'2',3,11,5,18,19,255,'b',6,'#','#','#',' ',
			3,15,13,5,' ',2,'2',3,11,' ','+',')',' ','#','#','#',255,'',6,2,25,' ',
			10,8,6,' ',15,6,' ',6,'2',9,18,12,9,7,8,20,' ','2',14,4,' ',2,21,20,3,
			8,'2',255,'',7,8,20,20,16,'/',31,31,13,5,13,2,5,18,19,'$',24,15,15,13,
			'$',3,15,13,31,10,6,9,20,9,5,0,0};
			
			unsigned int index,loadat;
			
			loadat=MONITOR[0]+256*MONITOR[1];
			
			for (index=2;index<4452;index++) {RAMPointer[index+loadat-2]=MONITOR[index];}
			
}



/////////////////////////////////////////////////////////////////////////////



void setcolors (void)

{
	
	unsigned int cbmcolor[16*3]={
		
		0x10,0x10,0x10,         // Black
			0xff,0xff,0xff,         // White
			0xe0,0x40,0x40,         // Red
			0x60,0xff,0xff,         // Cyan
			0xe0,0x60,0xe0,         // Purple
			0x40,0xe0,0x40,         // Green
			0x40,0x40,0xe0,         // Blue
			0xff,0xff,0x40,         // Yellow
			0xe0,0xa0,0x40,         // Orange
			0x9c,0x74,0x48,         // Brown
			0xff,0xa0,0xa0,         // Lt.Red
			0x54,0x54,0x54,         // Dk.Gray
			0x88,0x88,0x88,         // Gray
			0xa0,0xff,0xa0,         // Lt.Green
			0xa0,0xa0,0xff,         // Lt.Blue
			0xc0,0xc0,0xc0          // Lt.Gray
			
	};
	
	int x,y;
	
	for (x=0;x<16*3;x++) {cbmcolor[x]=(cbmcolor[x]/4)*gamma; if (cbmcolor[x]>63) cbmcolor[x]=63;}
	
	if (grayscale==1) {for (x=0;x<16;x++) {y=cbmcolor[x*3]+cbmcolor[x*3+1]+cbmcolor[x*3+2];
	
    y=y/3; cbmcolor[x*3]=y; cbmcolor[x*3+1]=y; cbmcolor[x*3+2]=y;
	
    } }
	
	for (x=0;x<16;x++) {outportb (0x3c8,100+x); outportb (0x3c9,cbmcolor[x*3+0]);
	
	outportb (0x3c9,cbmcolor[x*3+1]); outportb (0x3c9,cbmcolor[x*3+2]);
	
	outportb (0x3c8,200+x);
	y=cbmcolor[x*3+0]+5; if (y>63) y=63; outportb (0x3c9,y);
	y=cbmcolor[x*3+1]+5; if (y>63) y=63; outportb (0x3c9,y);
	y=cbmcolor[x*3+2]+5; if (y>63) y=63; outportb (0x3c9,y);
	
	outportb (0x3c8,150+x); outportb (0x3c9,cbmcolor[x*3+0]/4);
	
	outportb (0x3c9,cbmcolor[x*3+1]/4); outportb (0x3c9,cbmcolor[x*3+2]/4);}
	
	outportb(0x3c8,0);outportb(0x3c9,0);outportb(0x3c9,0);outportb(0x3c9,0);
}



/////////////////////////////////////////////////////////////////////////////



void loadprg (unsigned char filename[80])

{
	
	FILE *infile; unsigned int loadat; unsigned char data,quit=0;
	
	if ((infile=fopen(filename, "rb")) == NULL) {} else {
		
		if (filename[strlen(filename)-1]=='0') {fseek(infile,0x1a,0);}
		
		data=fgetc(infile); loadat=data; data=fgetc(infile); loadat=loadat+data*256;
		
		do 
		{
			data= fgetc(infile); RAMPointer[loadat]=data; loadat++;
			if (feof(infile)) quit=1;
			if (loadat==0xffff) quit=1;
			
		} while (quit==0);
	}
	
	RAMPointer[0x2e]=RAMPointer[0x30]=RAMPointer[0x32]=(unsigned char)((loadat-1)>>8);
	
	RAMPointer[0x2d]=loadat++-1; RAMPointer[0x2f]=loadat++-1; RAMPointer[0x31]=loadat++-1;
	
	RAMPointer[0x277]='R';RAMPointer[0x278]='u';RAMPointer[0xc6]=2;
	
}



/////////////////////////////////////////////////////////////////////////////



void resetkeyboard (void);
unsigned char dirprg (void)
{
	int done,x,y; struct ffblk ffblk;
	unsigned char text[40];FILE *infile; unsigned char ret=0;
	unsigned char file[201][15],col,numfiles=0,back,fore;
	int oldskipper=skipper;
	for (x=0;x<200;x++) {for (y=0;y<15;y++) { file[x][y]=0;} }
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	for (x=-1;x<281;x++) { for (y=15;y<135;y++) {
		col=100; if ((x==2||x==3)&&(y>17&&y<132)) {col=101;}
		if ((y==18||y==19)&&(x>1&&x<278)) {col=101;}
		if ((x==276||x==277)&&(y>17&&y<132)) {col=101;}
		if ((y==130||y==131)&&(x>1&&x<278)) {col=101;}
		Virtualscreen[(x+20)+320*(y+25)]=col; } } flip();
		done = findfirst("*.PRG",&ffblk,0);
		if (done==0) {while (!done&&numfiles<200) {
			strcpy (file[numfiles],ffblk.ff_name);done = findnext(&ffblk); numfiles++;}}
		done = findfirst("*.P00",&ffblk,0);
		if (done==0) {while (!done&&numfiles<200) {
			strcpy (file[numfiles],ffblk.ff_name);done = findnext(&ffblk); numfiles++;}} numfiles--;
			if (numfiles!=255) {
				strcpy (text," .PRG/.P00 FILES IN CURRENT DIR.: ");
				for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,3+x,6,7,0);}
				done=0; do {for (y=0;y<11;y++)
				{
					fore=1; back=0; if(y==g_nSelect) {back=2; fore=13;}
					strcpy (text,"................................");
					for (x=0;x<strlen(file[y+scroll]);x++) {text[x]=file[y+scroll][x];}
					if (y+scroll>numfiles) {strcpy(text,"                                ");}
					for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,8+y,fore,back);}
				} if (donone==0) flip();
				if (key[KB_escape]) done=1;
				if (key[KB_page_down]) {for (x=0;x<10;x++) {g_nSelect++; if (g_nSelect>10) {g_nSelect=10; scroll++;} if (scroll>numfiles-10) scroll=numfiles-10;} do{}while(key[KB_page_down]);
				for (x=0;x<10;x++) {if (g_nSelect>numfiles) {g_nSelect--; if (g_nSelect<0) {g_nSelect=0; scroll--;} if (scroll<0) scroll=0;}}}
				if (key[KB_page_up]) {for (x=0;x<10;x++) {g_nSelect--; if (g_nSelect<0) {g_nSelect=0; scroll--;} if (scroll<0) scroll=0;} do{}while(key[KB_page_up]);}
				if (key[KB_down]) {g_nSelect++; if (g_nSelect>10) {g_nSelect=10; scroll++;} if (scroll>numfiles-10) scroll=numfiles-10; do{}while(key[KB_down]);if (g_nSelect>numfiles) {g_nSelect--; if (g_nSelect<0) {g_nSelect=0; scroll--;} if (scroll<0) scroll=0;}}
				if (key[KB_up]) {g_nSelect--; if (g_nSelect<0) {g_nSelect=0; scroll--;} if (scroll<0) scroll=0; do{}while(key[KB_up]);}
				if (key[KB_enter]) {done=1; loadprg(file[g_nSelect+scroll]); ret=1;}
				if (numfiles<11) scroll=0;
				} while (done==0&&donone==0);
				resetkeyboard();
				skipper=oldskipper; return(ret); }
			if (numfiles==255&&donone==0) {Message ("NO PRG/P00 FILES FOUND",250);}
			skipper=oldskipper;
			return(0);
}



/////////////////////////////////////////////////////////////////////////////

unsigned char dircart (void)
{
	int done,x,y; struct ffblk ffblk;
	unsigned char text[40];FILE *infile; unsigned char ret=0;
	unsigned char file[201][15],col,numfiles=1,back,fore;
	unsigned char realname[201][30];
	int oldskipper=skipper;
	for (x=0;x<200;x++) {for (y=0;y<15;y++) { file[x][y]=0;} }
	for (x=0;x<200;x++) {for (y=0;y<30;y++) { realname[x][y]=0;} }
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	for (x=-1;x<281;x++) { for (y=15;y<135;y++) {
		col=100; if ((x==2||x==3)&&(y>17&&y<132)) {col=101;}
		if ((y==18||y==19)&&(x>1&&x<278)) {col=101;}
		if ((x==276||x==277)&&(y>17&&y<132)) {col=101;}
		if ((y==130||y==131)&&(x>1&&x<278)) {col=101;}
		Virtualscreen[(x+20)+320*(y+25)]=col; } } flip();
		done = findfirst("*.CRT",&ffblk,0);
		if (done==0) {while (!done&&numfiles<200) {
			strcpy (file[numfiles],ffblk.ff_name);done = findnext(&ffblk);
			infile=fopen(file[numfiles], "rb");
			fseek (infile,0x20,0);  for (x=0;x<29;x++)
			{
				realname[numfiles][x]=fgetc(infile);
				if (realname[numfiles][x]==0) realname[numfiles][x]='.';
				if (realname[numfiles][x]>=97&&realname[numfiles][x]<=122) realname[numfiles][x]-=32;
			}
			fclose (infile); numfiles++; }} numfiles--;
			if (numfiles!=255) {
				strcpy (file[0],"REMOVE CRTRDG");
				strcpy (realname[0],"REMOVE CARTRIDGE.");
				strcpy (text," .CRT FILES IN CURRENT DIR.: ");
				for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,6,7,0);}
				done=0; do {for (y=0;y<11;y++)
				{
					fore=1; back=0; if(y==g_nSelectcart) {back=2; fore=13;}
					strcpy (text,"................................");
					for (x=0;x<strlen(file[y+scrollcart]);x++) {text[x]=file[y+scrollcart][x];}
					for (x=15;x<32;x++)
					{
						text[x]=realname[y+scrollcart][x-15];
					}
					if (y+scrollcart>numfiles) {strcpy(text,"                                ");}
					for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,8+y,fore,back);}
				} flip();
				if (key[KB_escape]) done=1;
				if (key[KB_page_down]) {for (x=0;x<10;x++) {g_nSelectcart++; if (g_nSelectcart>10) {g_nSelectcart=10; scrollcart++;} if (scrollcart>numfiles-10) scrollcart=numfiles-10;} do{}while(key[KB_page_down]);
				for (x=0;x<10;x++) {if (g_nSelectcart>numfiles) {g_nSelectcart--; if (g_nSelectcart<0) {g_nSelectcart=0; scrollcart--;} if (scrollcart<0) scrollcart=0;}}}
				if (key[KB_page_up]) {for (x=0;x<10;x++) {g_nSelectcart--; if (g_nSelectcart<0) {g_nSelectcart=0; scrollcart--;} if (scrollcart<0) scrollcart=0;} do{}while(key[KB_page_up]);}
				if (key[KB_down]) {g_nSelectcart++; if (g_nSelectcart>10) {g_nSelectcart=10; scrollcart++;} if (scrollcart>numfiles-10) scrollcart=numfiles-10; do{}while(key[KB_down]);if (g_nSelectcart>numfiles) {g_nSelectcart--; if (g_nSelectcart<0) {g_nSelectcart=0; scrollcart--;} if (scrollcart<0) scrollcart=0;}}
				if (key[KB_up]) {g_nSelectcart--; if (g_nSelectcart<0) {g_nSelectcart=0; scrollcart--;} if (scrollcart<0) scrollcart=0; do{}while(key[KB_up]);}
				if (key[KB_enter]&&g_nSelectcart!=0) {done=1; strcpy(CurrentCrt,file[g_nSelectcart]); reset=1; Cartflg=1; ret=1;}
				if (key[KB_enter]&&g_nSelectcart==0) {done=1; reset=1; Cartflg=0; ret=1;}
				if (numfiles<11) scrollcart=0;
				} while (done==0);
				resetkeyboard();
				skipper=oldskipper; return(ret); }
			if (numfiles==255) {Message ("NO CARTRIDGES FOUND",250);}
			skipper=oldskipper;
			return(0);
}

/////////////////////////////////////////////////////////////////////////////


void generalvicinfo (void)

{
	
	int x,y; unsigned char text[45]; int r,g,b; unsigned int pos,col,cur;
	
	float clr; unsigned char ecm,bmm,mcm;
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	for (x=-1;x<281;x++) { for (y=15;y<135;y++) {
		
		col=100;  if ((x==2||x==3)&&(y>17&&y<132)) {col=101;}
		
		if ((y==18||y==19)&&(x>1&&x<278)) {col=101;}
		
		if ((x==276||x==277)&&(y>17&&y<132)) {col=101;}
		
		if ((y==130||y==131)&&(x>1&&x<278)) {col=101;}
		
		Virtualscreen[(x+20)+320*(y+25)]=col; } }
	
	strcpy (text,"VIC II BANK:.........$0000-$0FFF");
	
	if (vic_bank==0xC000) {text[22]='C';text[28]='F';}
	
	if (vic_bank==0x8000) {text[22]='8';text[28]='B';}
	
	if (vic_bank==0x4000) {text[22]='4';text[28]='7';}
	
	if (vic_bank==0x0000) {text[22]='0';text[28]='3';}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,7,1,0);}
	
	ecm=(Peek(0xD011)&64)/64; bmm=(Peek(0xD011)&32)/32; mcm=(Peek(0xD016)&16)/16;
	
	strcpy (text,"MODE OPTIONS:..ECM:  BMM:  MCM: ");
	
	text[19]='0'; if (ecm!=0) {text[19]='1';}
	
	text[25]='0'; if (bmm!=0) {text[25]='1';}
	
	text[31]='0'; if (mcm!=0) {text[31]='1';}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,9,1,0);}
	
	if (ecm==0&&bmm==0&&mcm==0) {strcpy (text,"MODE:.........STANDARD TEXT MODE");}
	
	if (ecm==1&&bmm==0&&mcm==0) {strcpy (text,"MODE:..............ECM TEXT MODE");}
	
	if (ecm==0&&bmm==1&&mcm==0) {strcpy (text,"MODE:.......STANDARD BITMAP MODE");}
	
	if (ecm==0&&bmm==0&&mcm==1) {strcpy (text,"MODE:.......MULTICOLOR TEXT MODE");}
	
	if (ecm==1&&bmm==1&&mcm==0) {strcpy (text,"MODE:......INVALID BITMAP MODE 1");}
	
	if (ecm==1&&bmm==0&&mcm==1) {strcpy (text,"MODE:..........INVALID TEXT MODE");}
	
	if (ecm==0&&bmm==1&&mcm==1) {strcpy (text,"MODE:.....MULTICOLOR BITMAP MODE");}
	
	if (ecm==1&&bmm==1&&mcm==1) {strcpy (text,"MODE:......INVALID BITMAP MODE 2");}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,11,1,0);}
	
	strcpy (text,"MEMORY $D000-DFFF:......CHAR ROM");
	
	if (charrom==0) {strcpy (text,"MEMORY $D000-DFFF:........4K RAM");}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,13,1,0);}
	
	strcpy (text,"38/40 COLUMN TEXT DISPLAY:....40");
	
	if (1-((Peek(0xD016)&8)/8)==1) {strcpy (text,"38/40 COLUMN TEXT DISPLAY:....38");}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,15,1,0);}
	
	strcpy (text,"24/25 ROW TEXT DISPLAY:.......25");
	
	if (1-((Peek(0xD011)&8)/8)==1) {strcpy (text,"24/25 ROW TEXT DISPLAY:.......24");}
	
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,17,1,0);}
	
	flip (); do {} while (key[KB_escape]!=1);do {} while (key[KB_escape]==1);
	rawkey=0; skipper=0;
	
}


/////////////////////////////////////////////////////////////////////////////

void sbgetinfo (void)
{
	int i;
	char *BLASTER=getenv("BLASTER");
	SBbase=0;
	if(BLASTER==NULL)
		if((BLASTER=getenv("blaster"))==NULL)
		{
			//                        Cleanup ("SET BLASTER not detected");
			return(1);
		}
		for(i=0;BLASTER[i]!=0;i++)
		{
			switch(BLASTER[i]) {
			case 'A':SBbase=(BLASTER[i+1]-'0')*0x100+
						 (BLASTER[i+2]-'0')*0x10+
						 (BLASTER[i+3]-'0');
				break;
			case 'I':SBint=atoi(&BLASTER[i+1]);
				break;
			case 'D':SBdma8=atoi(&BLASTER[i+1]);
				break;
			case 'H':SBdma16=atoi(&BLASTER[i+1]);
				break;
			default: break;
			}
		}
		return(0);
}

/////////////////////////////////////////////////////////////////////////////

unsigned char SB_ver (void)
{
	int vermaj,vermin;
	sbgetinfo();
	vermaj=0; if (SBbase!=0) {
		delay (20); outportb (SBbase+0xc,0xe1);
		delay (20); vermaj=inportb (SBbase+0xa);
		delay (20); vermin=inportb (SBbase+0xa);}
	return (vermaj);
}


/////////////////////////////////////////////////////////////////////////////

void sidinfo (void)

{
	int x,y; unsigned char text[45]; int r,g,b; unsigned int pos,col,cur;
	float clr; unsigned char ecm,bmm,mcm,vers;
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	for (x=-1;x<281;x++) { for (y=15;y<135;y++) {
		col=100;  if ((x==2||x==3)&&(y>17&&y<132)) {col=101;}
		if ((y==18||y==19)&&(x>1&&x<278)) {col=101;}
		if ((x==276||x==277)&&(y>17&&y<132)) {col=101;}
		if ((y==130||y==131)&&(x>1&&x<278)) {col=101;}
		Virtualscreen[(x+20)+320*(y+25)]=col; } }
	
	vers=SB_ver();
	if (vers<=4) strcpy (text,"SNDCARD DRIVER: SNDBLASTER 8 BIT");
	if (vers>=4) strcpy (text,"SNDCARD DRIVER: SOUNDBLASTER 16 ");
	if (vers==0) strcpy (text,"SNDCARD DRIVER: NO SOUNDCARD    ");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,7,1,0);}
	if (vers==0) strcpy (text,"DETECTED SNDCD: NO SOUNDCARD    ");
	if (vers==1) strcpy (text,"DETECTED SNDCD: SNDBLASTER 8 BIT");
	if (vers==2) strcpy (text,"DETECTED SNDCD: SOUNDBLASTER 2.0");
	if (vers==3) strcpy (text,"DETECTED SNDCD: SOUNDBLASTER PRO");
	if (vers==4) strcpy (text,"DETECTED SNDCD: SB16/AWE32/AWE64");
	if (vers>=5) strcpy (text,"DETECTED SNDCD: VERY NEW V5+ SB ");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,4+x,8,1,0);}
	
	strcpy (text,"SID FUNCTION KEYS:");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,11+x,10,1,0);}
	
	strcpy (text,"CTRL+F1:....VOICE 1 ON/OFF");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,7+x,12,1,0);}
	
	strcpy (text,"CTRL+F2:....VOICE 2 ON/OFF");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,7+x,13,1,0);}
	
	strcpy (text,"CTRL+F3:....VOICE 3 ON/OFF");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,7+x,14,1,0);}
	
	strcpy (text,"CTRL+[:.........VOL. LOWER");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<94) col=col-64; putcbmchar (col,7+x,16,1,0);}
	
	strcpy (text,"CTRL+]:........VOL. HIGHER");
	for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<94) col=col-64; putcbmchar (col,7+x,17,1,0);}
	
	
	flip (); do {} while (key[KB_escape]!=1);do {} while (key[KB_escape]==1);
	rawkey=0; skipper=0;
}

/////////////////////////////////////////////////////////////////////////////


void intro (void)

{
	
	unsigned char bitmap[3279]={
		
		'B','M','',12,0,0,0,0,0,0,'6',4,0,0,'(',0,0,0,'d',0,0,0,22,0,0,0,1,0,
			8,0,0,0,0,0,'',8,0,0,18,11,0,0,18,11,0,0,0,1,0,0,0,1,0,0,0,0,0,0,8,0,
			0,0,16,0,0,0,'!',8,0,0,')',8,0,0,8,16,0,0,')',16,0,0,'1',16,0,0,8,24,0,
			0,0,0,8,0,'1',16,8,0,'9',16,8,0,'9',24,8,0,'B',24,8,0,'J',24,8,0,'Z','!',
			8,0,0,0,16,0,0,16,16,0,'c','!',16,0,'s',')',16,0,'{',')',16,0,'{','1',
			16,0,'','1',16,0,')','s',16,0,'1','',16,0,0,16,24,0,'','1',24,0,'',
			'1',24,0,'','9',24,0,'','9',24,0,'','B',24,0,'','J',24,0,'9','',24,
			0,'B','',24,0,'','J','!',0,'','J','!',0,'','R','!',0,'','R','!',0,
			'','R','!',0,'','Z','!',0,0,0,')',0,'Z','!',')',0,'','Z',')',0,'Z',
			'',')',0,0,0,'1',0,8,')','1',0,8,8,'9',0,8,8,'B',0,16,'1','B',0,8,'B',
			'B',0,16,'9','J',0,8,'J','J',0,24,'J','Z',0,16,16,'c',0,24,'J','c',0,16,
			'c','c',0,24,'R','k',0,16,16,'s',0,16,'Z','s',0,24,'Z','s',0,16,16,'{',
			0,'!','c','{',0,16,'c','',0,'!','k','',0,24,24,'',0,24,24,'',0,'!',
			's','',0,24,'','',0,24,'s','',0,')','{','',0,24,'','',0,24,24,'',
			0,24,'','',0,24,'','',0,'!','!','',0,24,24,'',0,'!','!','',0,')',
			'','',0,')',')','',0,')','','',0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,
			255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
			2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,10,26,'#','*','*',
			'*','#',21,10,0,0,0,0,0,0,0,0,0,0,28,'*','*','*','*','*','*','*','*','*',
			'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
			'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',30,0,0,
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,29,'#',
			'*','*','*','*','*','*','*',21,0,0,0,0,0,0,0,0,0,0,28,'*','*','*','*',
			'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
			'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
			'*','*','*',30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,6,30,'*','*','*','*','*','*','*','*','*',22,0,0,0,0,0,0,0,0,
			0,0,21,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,
			34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,26,0,
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,30,'*',
			'*','*','*','*','*','*','*','*','*',22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,';','E','E','E','E','E','E','E','E','E',';',0,0,0,0,0,0,
			0,0,0,0,0,0,'4','E','E','E','8',2,29,'*','*','*','*','*','*','%','%','%',
			'&','*',22,0,0,0,0,0,0,0,0,0,0,23,'!','!','!','!','!','!','!','!','!',
			'!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
			'!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',24,0,0,
			'=','E','E','E','E','E','E','E','E','E','E','E','=',0,0,0,0,0,0,0,0,0,
			0,0,'4','E','E','E','8',12,'%','*','*','*','*','%',28,13,13,13,15,29,')',
			'/','/','/','/','/','/','/','/',0,0,' ','+','+','+','+','+','+','+','+',
			'+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+',
			
			'+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','!',
			
			0,0,'B','E','E','E','=','8','8','8','=','E','E','E','B',0,0,0,0,0,0,0,
			
			0,0,0,0,'4','E','E','E','8',30,'*','*','*','*','%',14,0,0,0,0,0,0,'5',
			
			'N','N','N','N','N','N','N','L',0,0,' ','+','+','+','+','+','+','+','+',
			
			'+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+',
			
			'+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','+','!',
			
			0,0,'B','E','E','E','-',0,0,0,'-','E','E','E','B',0,0,0,0,0,0,0,0,0,0,
			
			0,'4','E','E','E','8','$','*','*','*','*',22,0,0,0,0,0,0,0,'5','N','N',
			
			'N','N','N','N','L','/',0,0,5,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
			
			8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,0,0,'B','E','E','E','-',
			
			0,0,0,'-','E','E','E','B',0,0,0,0,0,0,0,0,0,0,0,'4','E','E','E','8','*',
			
			'*','*','*',34,6,0,0,0,0,0,0,0,'5','N','N','N','N','N','L','(',0,0,0,'1',
			
			'7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7',
			
			'7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7',
			
			'7','7','7','7','7','7','7','3',0,0,'B','E','E','E','6','0','0','0','6',
			
			'E','E','E','B',0,0,0,0,0,'0','0','0','0','0','0','=','E','E','E','8',
			
			'*','*','*','*',34,3,0,0,0,0,0,0,0,',','<','<','<','<','9','.',0,0,0,0,
			
			'C','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M',
			
			'M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M',
			
			'M','M','M','M','M','M','M','M','F',0,0,'B','E','E','E','E','E','E','E',
			
			'E','E','E','E','B',0,0,0,0,'B','E','E','E','E','E','E','E','E','E','E',
			
			'8','*','*','*','*',34,3,0,0,0,0,0,0,0,10,21,21,21,21,21,12,0,0,0,0,'C',
			
			'M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M',
			
			'M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M','M',
			
			'M','M','M','M','M','M','M','F',0,0,'B','E','E','E','E','E','E','E','E',
			
			'E','E','?',0,0,0,0,'E','E','E','E','E','E','E','E','E','E','E','E','8',
			
			'*','*','*','*',34,6,0,0,0,0,0,0,0,18,'*','*','*','*','*',34,6,0,0,0,'1',
			
			'7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7',
			
			'7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7','7',
			
			'7','7','7','7','7','7','7','3',0,0,'B','E','E','E','6','0','0','0','0',
			
			'0','0',0,0,0,0,0,'E','E','E','E','2','0','0','0','=','E','E','E','8',
			
			'$','*','*','*','*',22,0,0,0,0,0,0,0,18,'*','*','*','*','*','*','#',13,
			
			0,0,17,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,
			
			25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,17,0,
			
			0,'B','E','E','E','-',0,0,0,0,0,0,0,0,0,0,0,'E','E','E','E',0,0,0,0,'4',
			
			'E','E','E','8',30,'*','*','*','*','%',14,0,0,0,0,0,0,18,'*','*','*','*',
			
			'*','*','*','#',0,0,'D','O','O','O','O','O','O','O','O','O','O','O','O',
			
			'O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O',
			
			'O','O','O','O','O','O','O','O','O','O','O','O','O','H',0,0,'B','E','E',
			
			'E','-',0,0,0,0,0,0,0,0,0,0,0,'E','E','E','E',0,0,0,0,'4','E','E','E',
			
			'8',12,'%','*','*','*','*','%',28,13,13,13,15,29,21,14,14,14,14,14,14,
			
			14,14,0,0,'D','O','O','O','O','O','O','O','O','O','O','O','O','O','O',
			
			'O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O','O',
			
			'O','O','O','O','O','O','O','O','O','O','O','H',0,0,'B','E','E','E','=',
			
			'8','8','8','8','8','8','8','6',0,0,0,'E','E','E','E',0,0,0,0,'4','E',
			
			'E','E','8',2,29,'*','*','*','*','*','*','%','%','%','&','*',22,0,0,0,
			
			0,0,0,0,0,0,0,':','I','I','I','I','I','I','I','I','I','I','I','I','I',
			
			'I','I','I','I','I','I','I','I','I','I','I','I','I','I','I','I','I','I',
			
			'I','I','I','I','I','I','I','I','I','I','I','I','>',0,0,'=','E','E','E',
			
			'E','E','E','E','E','E','E','E','=',0,0,0,'E','E','E','E',0,0,0,0,'4',
			
			'E','E','E','8',0,2,30,'*','*','*','*','*','*','*','*','*','*',22,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,';','E','E','E','E','E','E',
			
			'E','E','E',';',0,0,0,0,'E','E','E','E',0,0,0,0,'4','E','E','E','8',0,
			
			0,6,30,'*','*','*','*','*','*','*','*','*',22,0,0,0,0,0,0,0,0,0,0,'<',
			
			'J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J',
			
			'J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J','J',
			
			'J','J','J','J','J','J','J','@',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,29,'#','*','*','*','*','*','*','*',21,
			
			0,0,0,0,0,0,0,0,0,0,'A','N','N','N','N','N','N','N','N','N','N','N','N',
			
			'N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N',
			
			'N','N','N','N','N','N','N','N','N','N','N','N','N','G',0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,10,26,'#','*',
			
			'*','*','#',21,10,0,0,0,0,0,0,0,0,0,0,'A','N','N','N','N','N','N','N',
			
			'N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N',
			
			'N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N',
			
			'G',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,16,16,16,16,16,16,16,16,
			
			16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
			
			16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
			
			unsigned char CBMSmall[10][10]= { 0,0,0,0,0,0,0,0,0,0, 0,0,0,2,2,1,0,0,0,0,
				
				0,0,2,1,1,1,0,0,0,0, 0,2,2,1,0,0,2,2,2,0, 2,2,0,0,0,0,2,1,0,0, 2,1,0,0,0,0,1,1,0,0,
				
				0,1,1,1,0,0,3,3,3,0, 0,0,1,1,3,3,0,0,0,0, 0,0,0,3,3,3,0,0,0,0, 0,0,0,0,0,0,0,0,0,0};
			
			int x,y; unsigned char text[45],cc; int r,g,b; unsigned int pos,filepos=0,col,cur; float clr;
			SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
			
			for (pos=0;pos<65535;pos++) {Virtualscreen[pos]=150;}
			
			pos=110-(95*320); filepos=0x36+256*0x04; for (y=0;y<22;y++) { for (x=0;x<100;x++) {
				
				col=bitmap[filepos]; filepos++; cur=(x)+320*(200-(y))+pos; Virtualscreen[cur]=col; } }
			
			outportb (0x3c8,150); outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
			
			outportb (0x3c8,100); outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
			
			outportb (0x3c8,101); outportb (0x3c9,63);outportb (0x3c9,63);outportb (0x3c9,63);
			
			outportb (0x3c8,102); outportb (0x3c9,63);outportb (0x3c9,63);outportb (0x3c9,0);
			
			outportb (0x3c8,103); outportb (0x3c9,20);outportb (0x3c9,20);outportb (0x3c9,60);
			
			outportb (0x3c8,151); outportb (0x3c9,6);outportb (0x3c9,7);outportb (0x3c9,15);
			
			outportb (0x3c8,152); outportb (0x3c9,9);outportb (0x3c9,10);outportb (0x3c9,18);
			
			outportb (0x3c8,153); outportb (0x3c9,4);outportb (0x3c9,5);outportb (0x3c9,13);
			
			strcpy (text,"COME BACK 64"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,14+x,5,1,0);}
			
			strcpy (text,"COMMODORE 64 EMULATOR"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,9+x,6,1,0);}
			
			strcpy (text,"VERSION x.xx");text[8]=VERMAJ+'0'; text[10]=VERMIN+'0'; text[11]=VERMINTWO+'0';
			
			for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,14+x,7,1,0);}
			
			strcpy (text,"FREEWARE, CREATED BY"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,10+x,16,1,0);}
			
			strcpy (text,"J. FITIE <JHF@FAIRLIGHT.TO>"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,6+x,17,1,0);}
			
			strcpy (text,"B. MARTIN <MARTIN@GVI.NET>"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,7+x,18,1,0);}
			
			strcpy (text,"- PRESS SPACE TO CONTINUE -"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,6+x,24,3,0);}
			
			strcpy (text,"1/3"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,37+x,0,1,0);}
			
			for (x=0;x<320;x++) {
				
				for (y=0;y<200;y++) {
					
					if (Virtualscreen[x+320*y]==150||Virtualscreen[x+320*y]==0||Virtualscreen[x+320*y]==100)
						
					{Virtualscreen[x+320*y]=CBMSmall[(y)%10][(x)%10]+150;}
					
			} }
			
			filepos=0x36; for (x=0;x<100;x++)  {outportb (0x3c8,x);
			
			r=bitmap[filepos]/4; filepos++; g=bitmap[filepos]/4; filepos++;
			
			b=bitmap[filepos]/4; filepos++; r=r*1.1; g=g*1.1; b=b*1.1;
			
			outportb (0x3c9,b); outportb (0x3c9,g);
			
			outportb (0x3c9,r); r=bitmap[filepos]/4; filepos++;
			
			} flip(); do{}while (rawkey!=KB_space);do{}while(rawkey==KB_space);
			
			for (pos=0;pos<65535;pos++) {Virtualscreen[pos]=150;}
			
			strcpy (text,"- PRESS SPACE TO CONTINUE -"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,6+x,24,3,0);}
			
			strcpy (text,"MAIN PROGRAMMERS:..................."); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,2+x,2,1,0);}
			
			strcpy (text,"JOHAN FITIE/JHF"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,23+x,4,2,0);}
			
			strcpy (text,"BRAD MARTIN/BUTCHA"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,20+x,5,2,0);}
			
			strcpy (text,"ORIGINAL COMMODORE 64 PALETTE:......"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,2+x,7,1,0);}
			
			strcpy (text,"PER HAKAN SUNDELL/CCS64"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,15+x,9,2,0);}
			
			strcpy (text,"DOCUMENTATION, ROUTINES AND SUPPORT:"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,2+x,11,1,0);}
			
			strcpy (text,"BACCHUS/FAIRLIGHT"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,21+x,13,2,0);}
			
			strcpy (text,"MARKO MAKELA"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,26+x,14,2,0);}
			
			strcpy (text,"PER HAKAN SUNDELL/CCS64"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,15+x,15,2,0);}
			
			strcpy (text,"MICHAEL SCHWENDT/SIDPLAY"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,14+x,16,2,0);}
			
			strcpy (text,"WOLFGANG LORENZ/PC64"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,18+x,17,2,0);}
			
			strcpy (text,"STEVEN H DON/SHD"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,22+x,18,2,0);}
			
			strcpy (text,"JOE FORSTER/STA"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,23+x,19,2,0);}
			
			strcpy (text,"MASSIMO AGOSTINELLI"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,19+x,20,2,0);}
			
			strcpy (text,"PAUL TOTH"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,29+x,21,2,0);}
			
			strcpy (text,"2/3"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,37+x,0,1,0);}
			
			for (x=0;x<320;x++) {
				
				for (y=0;y<200;y++) {
					
					if (Virtualscreen[x+320*y]==150||Virtualscreen[x+320*y]==0||Virtualscreen[x+320*y]==100)
						
					{Virtualscreen[x+320*y]=CBMSmall[(y)%10][(x)%10]+150;}
					
			} }
			
			flip(); do{}while (rawkey!=KB_space);do{}while(rawkey==KB_space);
			
			for (pos=0;pos<65535;pos++) {Virtualscreen[pos]=150;}
			
			strcpy (text,"- PRESS SPACE TO CONTINUE -"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,6+x,24,3,0);}
			
			strcpy (text,"UPDATES CAN BE FOUND ON"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,8+x,2+5,1,0);}
			
			strcpy (text,"WWW.CLASSICGAMING.COM/CB64"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,7+x,4+5,2,0);}
			
			strcpy (text,"CONTACT THE PROGRAMMERS"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,8+x,8+5,1,0);}
			
			strcpy (text,"<JHF@FAIRLIGHT.TO>"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,11+x,10+5,2,0);}
			
			strcpy (text,"<MARTIN@GVI.NET>"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,12+x,11+5,2,0);}
			
			strcpy (text,"3/3"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,37+x,0,1,0);}
			
			for (x=0;x<320;x++) {
				
				for (y=0;y<200;y++) {
					
					if (Virtualscreen[x+320*y]==150||Virtualscreen[x+320*y]==0||Virtualscreen[x+320*y]==100)
						
					{Virtualscreen[x+320*y]=CBMSmall[(y)%10][(x)%10]+150;}
					
			} }
			
			flip(); do{}while (rawkey!=KB_space);do{}while(rawkey==KB_space);
			
			rawkey=0; skipper=0;
			
}



/////////////////////////////////////////////////////////////////////////////



void resetkeyboard (void)

{
	
	unsigned int index;
	
	for(index=0;index<255;index++)key_pressed[index]=255; //Message ("KEYBOARD RESET",250);
	
	keysdown=0; for (index=0;index<0x80;index++) {key[index]=0;}
	
}



/////////////////////////////////////////////////////////////////////////////



void menu (void)

{
	
	unsigned char CBMSmall[10][10]= { 0,0,0,0,0,0,0,0,0,0, 0,0,0,2,2,1,0,0,0,0,
		
		0,0,2,1,1,1,0,0,0,0, 0,2,2,1,0,0,2,2,2,0, 2,2,0,0,0,0,2,1,0,0, 2,1,0,0,0,0,1,1,0,0,
		
		0,1,1,1,0,0,3,3,3,0, 0,0,1,1,3,3,0,0,0,0, 0,0,0,3,3,3,0,0,0,0, 0,0,0,0,0,0,0,0,0,0};
	
	unsigned int x,y,g_nSelect=1,back,fore,index;
	
	unsigned char text[40],col,exit=0,msg[40],oldsidon;
	int oldskipper=skipper;
	
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	
	oldsidon=sidon; sidon=0;RAMPointer[0xDFFC]=VERMAJ; RAMPointer[0xDFFD]=VERMIN;
	
	for (x=0;x<320;x++) {for (y=0;y<200;y++) { Virtualscreen[x+320*y]=100;} }
	
	do {
		
		outportb (0x3c8,0);outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
		outportb (0x3c8,90);outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
		outportb (0x3c8,91); outportb (0x3c9,6);outportb (0x3c9,7);outportb (0x3c9,15);
		outportb (0x3c8,92); outportb (0x3c9,9);outportb (0x3c9,10);outportb (0x3c9,18);
		outportb (0x3c8,93); outportb (0x3c9,4);outportb (0x3c9,5);outportb (0x3c9,13);
		
		strcpy (text,"** COME BACK 64 -- VER x.xx **"); text[23]=RAMPointer[0xDFFC]+'0'; text[25]=RAMPointer[0xDFFD]+'0';
		text[26]=VERMINTWO+'0';
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,1,7,0);}
		
		
		
		fore=1; back=0; if (g_nSelect==1) {back=2; fore=13;}
		
		strcpy (text,"MONITOR TYPE.......BLACK&WHITE");
		
		if (grayscale==0) strcpy (text,"MONITOR TYPE.............COLOR");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,3,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==2) {back=2; fore=13;}
		
		strcpy (text,"EMULATOR ID AT $DFA0.......YES");
		if (emuid==0) strcpy (text,"EMULATOR ID AT $DFA0........NO");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,4,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==3) {back=2; fore=13;}
		
		strcpy (text,"SUPPRESS 'ILLEGAL OPCODE'...NO");
		
		if (illopc==0) strcpy (text,"SUPPRESS 'ILLEGAL OPCODE'..YES");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,5,fore,back);}
		
		
		fore=1; back=0; if (g_nSelect==4) {back=2; fore=13;}
		
		strcpy (text,"FRAMESKIP.................NONE");
		if (autoskip==1) strcpy (text,"FRAMESKIP.................AUTO");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,6,fore,back);}
		
		
		fore=1; back=0; if (g_nSelect==5) {back=2; fore=13;}
		strcpy (text,"INTERLACE.................NONE");
		if (interl_on==1) strcpy (text,"INTERLACE...............ALWAYS");
		if (interl_on==2) strcpy (text,"INTERLACE.................AUTO");
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,7,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==6) {back=2; fore=13;}
		
		strcpy (text,"EMULATED JOYSTICK (8546+)....2");
		
		if (joytoemu==2) strcpy (text,"EMULATED JOYSTICK (8546+)....1");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,8,fore,back);}
		
		
		
		strcpy (text,"CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC"); for (x=0;x<strlen(text);x++){putcbmchar (text[x],3+x,9,11,0);}
		
		
		
		fore=1; back=0; if (g_nSelect==7) {back=2; fore=13;}
		
		strcpy (text,"RESET EMULATOR......CTRL/ALT/R");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,10,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==8) {back=2; fore=13;}
		
		strcpy (text,"SID FUNCTION KEYS...CTRL/ALT/K");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,11,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==9) {back=2; fore=13;}
		
		strcpy (text,"VIC II INFORMATION..CTRL/ALT/V");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,12,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==10) {back=2; fore=13;}
		
		strcpy (text,"CPU REGISTERS........CAPS LOCK");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,13,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==11) {back=2; fore=13;}
		
		strcpy (text,"RELATIVE SPEED.....SCROLL LOCK");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,14,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==12) {back=2; fore=13;}
		
		strcpy (text,"SPRITE INFO.........CTLR/ALT/I");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,15,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==13) {back=2; fore=13;}
		
		strcpy (text,"LOAD FAIRLIGHT INTRO..........");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,16,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==14) {back=2; fore=13;}
		
		strcpy (text,"LOAD .PRG/.P00 FILE.........F9");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,17,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==15) {back=2; fore=13;}
		strcpy (text,"LOAD/REMOVE CARTRIDGE......F10");
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,18,fore,back);}
		
		
		
		
		
		fore=1; back=0; if (g_nSelect==16) {back=2; fore=13;}
		
		strcpy (text,"GAMMA..........CTRL/ALT/+ OR -");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,19,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==18) {back=2; fore=13;}
		
		strcpy (text,"HELP ABOUT CB64.........ALT/F2");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,21,fore,back);}
		
		
		
		
		
		fore=1; back=0; if (g_nSelect==17) {back=2; fore=13;}
		
		strcpy (text,"ABOUT...................ALT/F1");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,20,fore,back);}
		
		
		fore=1; back=0; if (g_nSelect==19) {back=2; fore=13;}
		strcpy (text,"VIDEOMODE (320X200).....ALT/F3");
		if (vidmode==1) {strcpy (text,"VIDEOMODE (360X240).....ALT/F3");}
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,22,fore,back);}
		
		
		
		fore=1; back=0; if (g_nSelect==20) {back=2; fore=13;}
		
		strcpy (text,"QUIT COME BACK 64.......ALT/F4");
		
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,5+x,23,fore,back);}
		
		
		
		for (x=0;x<320;x++) {
			
			for (y=0;y<200;y++) {
				
				if (Virtualscreen[x+320*y]==150||Virtualscreen[x+320*y]==100)
					
				{Virtualscreen[x+320*y]=CBMSmall[(y)%10][(x)%10]+90;}
				
		} }
		
		
		
		flip ();
		
		if (key[KB_down]) {g_nSelect++; if (g_nSelect==21) g_nSelect=1; do {} while (key[KB_down]);}
		
		if (key[KB_up]) {g_nSelect--; if (g_nSelect==0) g_nSelect=20; do {} while (key[KB_up]);}
		
		if (key[KB_enter])
			
		{
			
			do {} while (key[KB_enter]);
			
			if (g_nSelect==1) {grayscale=1-grayscale; setcolors();}
			if (g_nSelect==2) {emuid=1-emuid;}
			if (g_nSelect==3) {illopc=1-illopc;}
			if (g_nSelect==4) {autoskip++; if (autoskip==2) autoskip=0;}
			if (g_nSelect==5) {interl_on++; if (interl_on==3) interl_on=0;}
			if (g_nSelect==6) {joytoemu=3-joytoemu;}
			if (g_nSelect==7) {reset=1; exit=1;}
			if (g_nSelect==8) {sidinfo();}
			if (g_nSelect==9) {generalvicinfo();}
			if (g_nSelect==10) {Message ("USE IN EMULATOR ONLY",1000);}
			if (g_nSelect==11) {Message ("USE IN EMULATOR ONLY",1000);}
			if (g_nSelect==12) {spriteinfo();}
			if (g_nSelect==13) {LoadMonitor(); reset=2; exit=1;/* Message ("LOADING FLT-INTRO",250);*/}
			if (g_nSelect==14) {exit=dirprg();}
			if (g_nSelect==15) {exit=dircart();}
			if (g_nSelect==16) {Message ("USE IN EMULATOR ONLY",1000);}
			if (g_nSelect==17) {intro(); setcolors(); exit=1;}
			if (g_nSelect==18) {help(); setcolors(); exit=1;}
			if (g_nSelect==19) {vidmode=1-vidmode; SetMode(0x13); setcolors(); do {} while (key[KB_f3]);}
			if (g_nSelect==20) {done=1; exit=1;}
			do {} while (key[KB_enter]);
			
			for (x=0;x<320;x++) {for (y=0;y<200;y++) { Virtualscreen[x+320*y]=100;} }
			
		}
		
		if (key[KB_escape]) exit=1;
		
 } while (exit==0); rawkey=0; sidon=oldsidon;
 skipper=oldskipper;
}



/////////////////////////////////////////////////////////////////////////////


void help (void)

{
	unsigned char textbar[250][42]={
		//1234567890123456789012345678901234567890
		"        WELCOME TO COME BACK 64",
			"        -----------------------",
			" COME BACK 64 IS MADE BY JOHAN FITIE AND",
			"BRAD MARTIN, AND IS SPREAD AS FREEWARE.",
			"",
			"",
			"              WHAT IS IT?",
			"              -----------",
			"",
			" COME BACK 64 (CB64) IS A SO CALLED",
			"'EMULATOR' - A PIECE OF SOFTWARE SIMU-",
			"LATING HARDWARE. IN THIS CASE CB64 IS",
			"EMULATING A COMMODORE 64. THE COMMODORE",
			"64 WAS A VERY POPULAR HOME COMPUTER IN",
			"THE 80'S AND EARLY 90'S.",
			"",
			"",
			"     SOUNDS COOL! HOW CAN I USE IT?",
			"     ------------------------------",
			"",
			" THE USAGE OF CB64 HAS BEEN KEPT AS EASY",
			"AS POSSIBLE. THE ONLY FILE YOU REALLY",
			"NEED IS THE CB64.EXE FILE. WHEN YOU",
			"START THIS FILE, YOU WILL FIRST SEE AN",
			"INTRO. SKIP THE INTRO BY PRESSING SPACE.",
			"NOW YOU WILL SEE THE WELLKNOWN COMMODORE",
			"64 SCREEN! YOU CAN USE YOUR PC NOW JUST",
			"AS IF IT WERE A REAL COMMODORE 64.",
			"",
			"",
			"        OK, BUT WHAT'S DIFFERENT",
			"        ------------------------",
			"",
			" WELL, SINCE SOME THINGS ABOUT THE PC",
			"ARE COMPLETELY DIFFERENT THAN ON A REAL",
			"C64, WE HAD TO CHANGE SOME THINGS. FOR",
			"EXAMPLE THE KEYBOARD LAYOUT. WE ALSO",
			"ADDED SOME FEATURES, WHICH ARE ALL",
			"AVAILABLE FROM WITHIN THE CB64 MENU",
			"(AVAILABLE BY PRESSING THE ESCAPE",
			"BUTTON).",
			"",
			"",
			"                THE MENU",
			"                --------",
			"",
			" HERE'S A SMALL DESCRIPTION OF ALL THE",
			"OPTIONS IN THE MENU:",
			"",
			"  MONITOR TYPE",
			" CHOOSE BETWEEN COLOR OR BLACK&WHITE",
			"DISPLAY. INCLUDED FOR NOSTALGIA!",
			"",
			"  KERNEL ROM",
			" SELECT THE KERNEL ROM YOU WANT. THE",
			"DEFAULT IS THE STANDARD C64 ROM, BUT",
			"SOME OTHER ROMS ARE INCLUDED TOO.",
			"",
			"  SUPPRESS ILLEGAL OPCODE",
			" ALTHOUGH A LOT OF THE C64 IS ALREADY",
			"EMULATED, A FEW OPCODES MAY STILL NOT",
			"EXIST. IF THE EMULATOR ENCOUNTERS ONE",
			"OF THESE OPCODES AND THIS OPTION IS SET",
			"TO 'NO', A WARNING MESSAGE APPEARS ON",
			"SCREEN.",
			"",
			"  FRAMESKIP",
			" BECAUSE THIS PROGRAM REQUIRES A REAL",
			"FAST COMPUTER, FRAMESKIPPING SKIPS",
			"FRAMES SO IT WILL WORK ON SLOWER CPU'S",
			"TOO. SET THIS TO 'NONE' IF YOU WANT TO",
			"SEE ALL FRAMES ('AUTO' ONLY WITH A SB).",
			"",
			"  EMULATED JOYSTICK",
			" YOU CAN PLAY MOST GAMES ON A REAL C64",
			"USING A JOYSTICK. COME BACK 64 EMULATES",
			"A JOYSTICK THROUGH THE KEYBOARD. THIS",
			"SELECTS WHICH JOYSTICK TO EMULATE: PORT",
			"1 OR PORT 2",
			"",
			"  RESET EMULATOR",
			" JUST AS IF YOU TURN THE C64 OFF AND",
			"THEN TURN IT ON AGAIN.",
			"",
			"  SID FUNCTION KEYS",
			" THE AUDIOCHIP OF THE COMMODORE 64 (SID)",
			"IS EMULATED THROUGH YOUR SOUNDBLASTER",
			"SOUNDCARD. USE THIS OPTION TO GET INFO",
			"ABOUT THE KEYS TO USE TO CONTROL SOUND.",
			"",
			"  VIC II INFORMATION",
			" THIS FUNCTION SHOWS SOME INFO ABOUT",
			"THE VIDEOCHIP OF THE C64 (VIC II).",
			"",
			"  CPU REGISTERS",
			" SELECTING THIS OPTION (CAPS LOCK) WHILE",
			"IN THE EMULATOR WILL CAUSE A CPU-INFO",
			"WINDOW TO APPEAR IN THE TOP OF YOUR",
			"SCREEN. IT SHOWS THE REGISTERS AND EVEN",
			"HAS AN OPCODE DISASSEMBLER.",
			"",
			"  RELATIVE SPEED",
			" USING THIS OPTION (NUM LOCK) IN THE",
			"EMULATOR WILL PUT SOME INFO NEAR THE",
			"LOWER RIGHT CORNER OF YOUR SCREEN. IT",
			"SHOWS THE RELATIVE SPEED TO A REAL C64,",
			"AS WELL AS THE FRAMESKIP.",
			"",
			"  SPRITE INFO",
			" LETS YOU VIEW THE SPRITES. IN THE",
			"WINDOW THAT APPEARS, USE CURSOR KEYS",
			"LEFT AND RIGHT TO SELECT SPRITE. USE",
			"KEYS 1, 2 AND 3 TO CHANGE COLORS.",
			"",
			"  LOAD FAIRLIGHT INTRO",
			" THIS IS THE INTRO YOU SEE WHEN YOU",
			"START CB 64. IT RUNS AUTOMATICALLY.",
			"",
			"  LOAD .PRG/.P00 FILE",
			" SCANS THE CURRENT DIRECTORY FOR .PRG",
			"AND .P00 FILES (COMMODORE 64 PROGRAMS).",
			"YOU CAN THEN SELECT ONE FROM THE LIST",
			"AND LOAD IT INTO THE EMULATOR. ONCE A",
			"PROGRAM HAS LOADED, YOU SHOULD TYPE",
			"'RUN' TO START THE PROGRAM. CB64 AUTO-",
			"MATICALLY TYPES THIS IN FOR YOU, SO YOU",
			"ONLY HAVE TO PRESS ENTER TO START IT.",
			"",
			"  LOAD/REMOVE CARTRIDGE",
			" SCANS THE CURRENT DIRECTORY FOR .CRT",
			"FILES (CARTRIDGES). THE FIRST IN THE",
			"LIST IS THE OPTION TO REMOVE THE CART-",
			"RIDGE. IF YOU SELECT A CARTRIDGE, THE",
			"EMULATOR WILL BE RESET AND THE CART-",
			"RIDGE WILL BE LOADED.",
			"",
			"  GAMMA",
			" IF CB64 LOOKS TOO DARK OR TOO LIGHT ON",
			"YOUR MONITOR, YOU CAN LIGHTEN OR DARKEN",
			"THE CB64 SCREEN WITH THIS OPTION.",
			"",
			"  ABOUT",
			" SOME INFO ABOUT CB64.",
			"",
			"  VIDEOMODE",
			" SELECTS WHETHER TO USE THE 320X200 OR",
			"A (SLOWER) 360X240 VIDEOMODE. CAN BE",
			"EASILY CHANGED WITH ALT+F3.",
			"",
			"  HELP ABOUT CB64",
			" THE HELP YOU'RE READING NOW.",
			"",
			"  QUIT COME BACK 64",
			" EXIT COME BACK 64 AND RETURN TO DOS",
			"(OR WINDOWS).",
			"",
			"",
			"  WOW! BUT WHY'S THE SOURCE INCLUDED?",
			"  -----------------------------------",
			"",
			" BECAUSE A LOT OF PEOPLE ASKED FOR IT!",
			"AND ALSO, THIS WAY I GET A LOT OF HELP:",
			"IF ANYBODY HAS AN IDEA AND MAILS IT TO",
			"ME, I CAN IMPLEMENT IT! I ALREADY GOT",
			"SOME HELP WITH SOUND (SHD), 6510 (PHS)",
			"AND CARTRIDGES (MA).",
			"",
			"",
			"     TELL ME ABOUT THE SYSTEM ROMS",
			"     -----------------------------",
			"",
			" THIS EMULATOR USES ROMS TO EMULATE THE",
			"COMMODORE 64. THE ORIGINAL C64 ROMS ARE",
			"INCLUDED IN THE CB64.EXE FILE. AFTER THE",
			"C64 WAS RELEASED, PEOPLE STARTING MAKING",
			"OTHER ROMS FOR THE C64, LIKE JIFFYDOS,",
			"DOLPHINDOS, EXOS AND SX-64. CB64 CAN",
			"USE THESE ROMS TOO. WHEN CB64 STARTS UP,",
			"IT CHECKS THE CURRENT DIRECTORY FOR",
			"ROMS. THEY SHOULD BE CALLED 'KERNAL.ROM'",
			", 'BASIC.ROM' AND 'CHAR.ROM'. WHEN CB64",
			"FINDS ONE OR MORE OF THESE ROM IMAGES,",
			"IT LOADS THEM AND WILL BOOT THE EMULATED",
			"C64 WITH THE NEW ROM.",
			"",
			"",
			"        I FOUND A WAY I CAN HELP",
			"         DEVELOP COME BACK 64!",
			"        ------------------------",
			"",
			" IF YOU DID SOMETHING -REALLY- USEFULL,",
			"AND THINK IT'S WORTH SENDING (OR IF YOU",
			"NEED HELP), YOU CAN CONTACT THE AUTHORS:",
			"             ,",
			"   JOHAN FITIE         BRAD MARTIN",
			"   -----------         -----------",
			"",
			"JHF@FAIRLIGHT.TO    MARTIN@GVI.NET",
			"HTTP://MEMBERS.XOO  HTTP://HOME.GVI.NE",
			" M.COM/JFITIE        T/[TILDE]MARTIN",
			"",
			"",
			"      DISCLAIMER (YEP, IT'S HERE)",
			"      ---------------------------",
			"",
			" THIS SOFTWARE IS RELEASED WITH NO",
			"WARRENTY OF ANY KIND, EXPRESSED OR",
			"IMPLIED. WE WILL TRY TO HELP ANY-",
			"ONE THAT WE CAN, BUT THERE IS NO",
			"GUARANTEE OF SUPPORT. WE ALSO ARE NOT",
			"RESPONSIBLE FOR HARDWARE AND/OR SOFT-",
			"WARE DAMAGE.",
			" ALL PRODUCT NAMES ARE TRADEMARKS AND/",
			"OR COPYRIGHTS OF THEIR RESPECTIVE",
			"OWNERS. ANYONE WHO FEELS WE HAVE TREAD",
			"ON THE RIGHTS TO THEIR PRODUCT SHOULD",
			"CONTACT US AND WE WILL REMOVE REFERENCES",
			"TO YOUR PRODUCT.",
			" YOU MAY USE THIS PROGRAM IN ANY WAY YOU",
			"WANT, AS LONG AS YOU DON'T REDISTRIBUTE",
			"IT IN ANY OTHER THAN ITS ORIGINAL FORM.",
			"THIS INCLUDES ADDING/REMOVING FILES,",
			"HACKING/EDITING FILES, ETC.",
			"",
			"",
			"  OK,NOW WE ARE FINALLY DONE! HIT THE",
			"  SPACEBAR TO RETURN TO COME BACK 64!",
			"                               /JOHAN",
			"",
			"(BTW. CALLING THIS HELP FROM INSIDE A",
			" PROGRAM SOMETIMES CURRUPTS THE C64'S",
			" MEMORY, IF SO, TRY A CTRL+ALT+R)",
			"@"};
			//1234567890123456789012345678901234567890
			unsigned char CBMSmall[10][10]= { 0,0,0,0,0,0,0,0,0,0, 0,0,0,2,2,1,0,0,0,0,
				0,0,2,1,1,1,0,0,0,0, 0,2,2,1,0,0,2,2,2,0, 2,2,0,0,0,0,2,1,0,0, 2,1,0,0,0,0,1,1,0,0,
				0,1,1,1,0,0,3,3,3,0, 0,0,1,1,3,3,0,0,0,0, 0,0,0,3,3,3,0,0,0,0, 0,0,0,0,0,0,0,0,0,0};
			int x,x2,y; unsigned char text[45],cc,colr,quit=0; int r,g,b;
			unsigned int pos,filepos=0,col,cur,textpos=0,ypos=0; float clr;
			SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
			outportb (0x3c8,0); outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
			outportb (0x3c8,150); outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
			outportb (0x3c8,100); outportb (0x3c9,0);outportb (0x3c9,0);outportb (0x3c9,0);
			outportb (0x3c8,101); outportb (0x3c9,63);outportb (0x3c9,63);outportb (0x3c9,63);
			outportb (0x3c8,102); outportb (0x3c9,63);outportb (0x3c9,63);outportb (0x3c9,0);
			outportb (0x3c8,103); outportb (0x3c9,20);outportb (0x3c9,20);outportb (0x3c9,60);
			outportb (0x3c8,151); outportb (0x3c9,6);outportb (0x3c9,7);outportb (0x3c9,15);
			outportb (0x3c8,152); outportb (0x3c9,9);outportb (0x3c9,10);outportb (0x3c9,18);
			outportb (0x3c8,153); outportb (0x3c9,4);outportb (0x3c9,5);outportb (0x3c9,13);
			/*START OF MAIN*/
			
			x2=-1;do {
				for (pos=0;pos<65535;pos++) {Virtualscreen[pos]=150;}
				strcpy (text,"COME BACK 64      ONLINE DOCUMENTATION"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63&&col<91) col=col-64; putcbmchar (col,1+x,0,3,0);}
				strcpy (text,"CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC"); for (x=0;x<strlen(text);x++){putcbmchar (text[x],x,1,11,0);}
				strcpy (text,"CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC"); for (x=0;x<strlen(text);x++){putcbmchar (text[x],x,23,11,0);}
				strcpy (text,"-- HIT SPACE TO CONTINUE --"); for (x=0;x<strlen(text);x++){col=text[x]; if (col>63) col=col-64; putcbmchar (col,7+x,24,3,0);}
				y=0;x2++;
				do {
					strcpy (text,textbar[ypos]);
					colr=1; if (text[0]==32&&text[1]==32) colr=2;
					if (text[0]=='@') {quit=1; text[0]=0;}
					for (x=0;x<strlen(text);x++){col=text[x]; if (col>63) col=col-64; putcbmchar (col,x,y+3,colr,0);}
					ypos++; y++;// if (textbar[y+ypos][0]==0&&textbar[y+ypos+1][0]==0) y=19;
				} while (y<19&&quit==0);
				/*FLIP*/ for (x=0;x<320;x++) {for (y=0;y<200;y++) {if (Virtualscreen[x+320*y]==150||Virtualscreen[x+320*y]==0||Virtualscreen[x+320*y]==100){Virtualscreen[x+320*y]=CBMSmall[(y)%10][(x)%10]+150;}} } flip ();
				/*KEYBD*/ do{}while (rawkey!=KB_space);do{}while(rawkey==KB_space); rawkey=0; skipper=0;
			} while (quit==0);
			
}


/////////////////////////////////////////////////////////////////////////////



void getopcodestring (unsigned char opcode)

{
	
	if (opcode==0x00) strcpy (opcodestring,"BRK");
	
	if (opcode==0x01) strcpy (opcodestring,"ORA ($a,X)");
	
	if (opcode==0x02) strcpy (opcodestring,"???");
	
	if (opcode==0x03) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0x04) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x05) strcpy (opcodestring,"ORA $a");
	
	if (opcode==0x06) strcpy (opcodestring,"ASL $a");
	
	if (opcode==0x07) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x08) strcpy (opcodestring,"PHP");
	
	if (opcode==0x09) strcpy (opcodestring,"ORA #$a");
	
	if (opcode==0x0A) strcpy (opcodestring,"ASL");
	
	if (opcode==0x0B) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x0C) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x0D) strcpy (opcodestring,"ORA $ba");
	
	if (opcode==0x0E) strcpy (opcodestring,"ASL $ba");
	
	if (opcode==0x0F) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x10) strcpy (opcodestring,"BPL $*a");
	
	if (opcode==0x11) strcpy (opcodestring,"ORA ($a),Y");
	
	if (opcode==0x12) strcpy (opcodestring,"???");
	
	if (opcode==0x13) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0x14) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x15) strcpy (opcodestring,"ORA $a,X");
	
	if (opcode==0x16) strcpy (opcodestring,"ASL $a,X");
	
	if (opcode==0x17) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x18) strcpy (opcodestring,"CLC");
	
	if (opcode==0x19) strcpy (opcodestring,"ORA $ba,Y");
	
	if (opcode==0x1A) strcpy (opcodestring,"???");
	
	if (opcode==0x1B) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x1C) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x1D) strcpy (opcodestring,"ORA $ba,X");
	
	if (opcode==0x1E) strcpy (opcodestring,"ASL $ba,X");
	
	if (opcode==0x1F) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x20) strcpy (opcodestring,"JSR $ba");
	
	if (opcode==0x21) strcpy (opcodestring,"AND ($a,X)");
	
	if (opcode==0x22) strcpy (opcodestring,"NOP");
	
	if (opcode==0x23) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0x24) strcpy (opcodestring,"BIT $a");
	
	if (opcode==0x25) strcpy (opcodestring,"AND $a");
	
	if (opcode==0x26) strcpy (opcodestring,"ROL $a");
	
	if (opcode==0x27) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x28) strcpy (opcodestring,"PLP");
	
	if (opcode==0x29) strcpy (opcodestring,"AND #$a");
	
	if (opcode==0x2A) strcpy (opcodestring,"ROL");
	
	if (opcode==0x2B) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x2C) strcpy (opcodestring,"BIT $ba");
	
	if (opcode==0x2D) strcpy (opcodestring,"AND $ba");
	
	if (opcode==0x2E) strcpy (opcodestring,"ROL $ba");
	
	if (opcode==0x2F) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x30) strcpy (opcodestring,"BMI $*a");
	
	if (opcode==0x31) strcpy (opcodestring,"AND ($a),Y");
	
	if (opcode==0x32) strcpy (opcodestring,"???");
	
	if (opcode==0x33) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0x34) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x35) strcpy (opcodestring,"AND $a,X");
	
	if (opcode==0x36) strcpy (opcodestring,"ROL $a,X");
	
	if (opcode==0x37) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x38) strcpy (opcodestring,"SEC");
	
	if (opcode==0x39) strcpy (opcodestring,"AND $ba,Y");
	
	if (opcode==0x3A) strcpy (opcodestring,"???");
	
	if (opcode==0x3B) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x3C) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x3D) strcpy (opcodestring,"AND $ba,X");
	
	if (opcode==0x3E) strcpy (opcodestring,"ROL $ba,X");
	
	if (opcode==0x3F) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x40) strcpy (opcodestring,"RTI");
	
	if (opcode==0x41) strcpy (opcodestring,"EOR ($a,X)");
	
	if (opcode==0x42) strcpy (opcodestring,"???");
	
	if (opcode==0x43) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0x44) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x45) strcpy (opcodestring,"EOR $a");
	
	if (opcode==0x46) strcpy (opcodestring,"LSR $a");
	
	if (opcode==0x47) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x48) strcpy (opcodestring,"PHA");
	
	if (opcode==0x49) strcpy (opcodestring,"EOR #$a");
	
	if (opcode==0x4A) strcpy (opcodestring,"LSR");
	
	if (opcode==0x4B) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x4C) strcpy (opcodestring,"JMP $ba");
	
	if (opcode==0x4D) strcpy (opcodestring,"EOR $ba");
	
	if (opcode==0x4E) strcpy (opcodestring,"LSR $ba");
	
	if (opcode==0x4F) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x50) strcpy (opcodestring,"BVC $*a");
	
	if (opcode==0x51) strcpy (opcodestring,"EOR ($a),Y");
	
	if (opcode==0x52) strcpy (opcodestring,"???");
	
	if (opcode==0x53) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0x54) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x55) strcpy (opcodestring,"EOR $a,X");
	
	if (opcode==0x56) strcpy (opcodestring,"LSR $a,X");
	
	if (opcode==0x57) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x58) strcpy (opcodestring,"CLI");
	
	if (opcode==0x59) strcpy (opcodestring,"EOR $ba,Y");
	
	if (opcode==0x5A) strcpy (opcodestring,"???");
	
	if (opcode==0x5B) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x5C) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x5D) strcpy (opcodestring,"EOR $ba,X");
	
	if (opcode==0x5E) strcpy (opcodestring,"LSR $ba,X");
	
	if (opcode==0x5F) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x60) strcpy (opcodestring,"RTS");
	
	if (opcode==0x61) strcpy (opcodestring,"ADC ($a,X)");
	
	if (opcode==0x62) strcpy (opcodestring,"???");
	
	if (opcode==0x63) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0x64) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x65) strcpy (opcodestring,"ADC $a");
	
	if (opcode==0x66) strcpy (opcodestring,"ROR $a");
	
	if (opcode==0x67) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x68) strcpy (opcodestring,"PLA");
	
	if (opcode==0x69) strcpy (opcodestring,"ADC #$a");
	
	if (opcode==0x6A) strcpy (opcodestring,"ROR");
	
	if (opcode==0x6B) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x6C) strcpy (opcodestring,"JMP ($ba)");
	
	if (opcode==0x6D) strcpy (opcodestring,"ADC $ba");
	
	if (opcode==0x6E) strcpy (opcodestring,"ROR $ba");
	
	if (opcode==0x6F) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x70) strcpy (opcodestring,"BVS $*a");
	
	if (opcode==0x71) strcpy (opcodestring,"ADC ($a),Y");
	
	if (opcode==0x72) strcpy (opcodestring,"???");
	
	if (opcode==0x73) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0x74) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x75) strcpy (opcodestring,"ADC $a,X");
	
	if (opcode==0x76) strcpy (opcodestring,"ROR $a,X");
	
	if (opcode==0x77) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0x78) strcpy (opcodestring,"SEI");
	
	if (opcode==0x79) strcpy (opcodestring,"ADC $ba,Y");
	
	if (opcode==0x7A) strcpy (opcodestring,"???");
	
	if (opcode==0x7B) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x7C) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x7D) strcpy (opcodestring,"ADC $ba,X");
	
	if (opcode==0x7E) strcpy (opcodestring,"ROR $ba,X");
	
	if (opcode==0x7F) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x80) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x81) strcpy (opcodestring,"STA ($a,X)");
	
	if (opcode==0x82) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x83) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0x84) strcpy (opcodestring,"STY $a");
	
	if (opcode==0x85) strcpy (opcodestring,"STA $a");
	
	if (opcode==0x86) strcpy (opcodestring,"STX $a");
	
	if (opcode==0x87) strcpy (opcodestring,"??? $a");
	
	if (opcode==0x88) strcpy (opcodestring,"DEY");
	
	if (opcode==0x89) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x8A) strcpy (opcodestring,"TXA");
	
	if (opcode==0x8B) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0x8C) strcpy (opcodestring,"STY $ba");
	
	if (opcode==0x8D) strcpy (opcodestring,"STA $ba");
	
	if (opcode==0x8E) strcpy (opcodestring,"STX $ba");
	
	if (opcode==0x8F) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0x90) strcpy (opcodestring,"BCC $*a");
	
	if (opcode==0x91) strcpy (opcodestring,"STA ($a),Y");
	
	if (opcode==0x92) strcpy (opcodestring,"???");
	
	if (opcode==0x93) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0x94) strcpy (opcodestring,"STY $a,X");
	
	if (opcode==0x95) strcpy (opcodestring,"STA $a,X");
	
	if (opcode==0x96) strcpy (opcodestring,"STX $a,Y");
	
	if (opcode==0x97) strcpy (opcodestring,"??? $a,Y");
	
	if (opcode==0x98) strcpy (opcodestring,"TYA");
	
	if (opcode==0x99) strcpy (opcodestring,"STA $ba,Y");
	
	if (opcode==0x9A) strcpy (opcodestring,"TXS");
	
	if (opcode==0x9B) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x9C) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0x9D) strcpy (opcodestring,"STA $ba,X");
	
	if (opcode==0x9E) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0x9F) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0xA0) strcpy (opcodestring,"LDY #$a");
	
	if (opcode==0xA1) strcpy (opcodestring,"LDA ($a,X)");
	
	if (opcode==0xA2) strcpy (opcodestring,"LDX #$a");
	
	if (opcode==0xA3) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0xA4) strcpy (opcodestring,"LDY $a");
	
	if (opcode==0xA5) strcpy (opcodestring,"LDA $a");
	
	if (opcode==0xA6) strcpy (opcodestring,"LDX $a");
	
	if (opcode==0xA7) strcpy (opcodestring,"??? $a");
	
	if (opcode==0xA8) strcpy (opcodestring,"TAY");
	
	if (opcode==0xA9) strcpy (opcodestring,"LDA #$a");
	
	if (opcode==0xAA) strcpy (opcodestring,"TAX");
	
	if (opcode==0xAB) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0xAC) strcpy (opcodestring,"LDY $ba");
	
	if (opcode==0xAD) strcpy (opcodestring,"LDA $ba");
	
	if (opcode==0xAE) strcpy (opcodestring,"LDX $ba");
	
	if (opcode==0xAF) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0xB0) strcpy (opcodestring,"BCS $*a");
	
	if (opcode==0xB1) strcpy (opcodestring,"LDA ($a),Y");
	
	if (opcode==0xB2) strcpy (opcodestring,"???");
	
	if (opcode==0xB3) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0xB4) strcpy (opcodestring,"LDY $a,X");
	
	if (opcode==0xB5) strcpy (opcodestring,"LDA $a,X");
	
	if (opcode==0xB6) strcpy (opcodestring,"LDX $a,Y");
	
	if (opcode==0xB7) strcpy (opcodestring,"??? $a,Y");
	
	if (opcode==0xB8) strcpy (opcodestring,"CLV");
	
	if (opcode==0xB9) strcpy (opcodestring,"LDA $ba,Y");
	
	if (opcode==0xBA) strcpy (opcodestring,"TSX");
	
	if (opcode==0xBB) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0xBC) strcpy (opcodestring,"LDY $ba,X");
	
	if (opcode==0xBD) strcpy (opcodestring,"LDA $ba,X");
	
	if (opcode==0xBE) strcpy (opcodestring,"LDX $ba,Y");
	
	if (opcode==0xBF) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0xC0) strcpy (opcodestring,"CPY #$a");
	
	if (opcode==0xC1) strcpy (opcodestring,"CMP ($a,X)");
	
	if (opcode==0xC2) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0xC3) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0xC4) strcpy (opcodestring,"CPY $a");
	
	if (opcode==0xC5) strcpy (opcodestring,"CMP $a");
	
	if (opcode==0xC6) strcpy (opcodestring,"DEC $a");
	
	if (opcode==0xC7) strcpy (opcodestring,"??? $a");
	
	if (opcode==0xC8) strcpy (opcodestring,"INY");
	
	if (opcode==0xC9) strcpy (opcodestring,"CMP #$a");
	
	if (opcode==0xCA) strcpy (opcodestring,"DEX");
	
	if (opcode==0xCB) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0xCC) strcpy (opcodestring,"CPY $ba");
	
	if (opcode==0xCD) strcpy (opcodestring,"CMP $ba");
	
	if (opcode==0xCE) strcpy (opcodestring,"DEC $ba");
	
	if (opcode==0xCF) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0xD0) strcpy (opcodestring,"BNE $*a");
	
	if (opcode==0xD1) strcpy (opcodestring,"CMP ($a),Y");
	
	if (opcode==0xD2) strcpy (opcodestring,"???");
	
	if (opcode==0xD3) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0xD4) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0xD5) strcpy (opcodestring,"CMP $a,X");
	
	if (opcode==0xD6) strcpy (opcodestring,"DEC $a,X");
	
	if (opcode==0xD7) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0xD8) strcpy (opcodestring,"CLD");
	
	if (opcode==0xD9) strcpy (opcodestring,"CMP $ba,Y");
	
	if (opcode==0xDA) strcpy (opcodestring,"???");
	
	if (opcode==0xDB) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0xDC) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0xDD) strcpy (opcodestring,"CMP $ba,X");
	
	if (opcode==0xDE) strcpy (opcodestring,"DEC $ba,X");
	
	if (opcode==0xDF) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0xE0) strcpy (opcodestring,"CPX #$a");
	
	if (opcode==0xE1) strcpy (opcodestring,"SBC ($a,X)");
	
	if (opcode==0xE2) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0xE3) strcpy (opcodestring,"??? ($a,X)");
	
	if (opcode==0xE4) strcpy (opcodestring,"CPX $a");
	
	if (opcode==0xE5) strcpy (opcodestring,"SBC $a");
	
	if (opcode==0xE6) strcpy (opcodestring,"INC $a");
	
	if (opcode==0xE7) strcpy (opcodestring,"??? $a");
	
	if (opcode==0xE8) strcpy (opcodestring,"INX");
	
	if (opcode==0xE9) strcpy (opcodestring,"SBC #$a");
	
	if (opcode==0xEA) strcpy (opcodestring,"NOP");
	
	if (opcode==0xEB) strcpy (opcodestring,"??? #$a");
	
	if (opcode==0xEC) strcpy (opcodestring,"CPX $ba");
	
	if (opcode==0xED) strcpy (opcodestring,"SBC $ba");
	
	if (opcode==0xEE) strcpy (opcodestring,"INC $ba");
	
	if (opcode==0xEF) strcpy (opcodestring,"??? $ba");
	
	if (opcode==0xF0) strcpy (opcodestring,"BEQ $*a");
	
	if (opcode==0xF1) strcpy (opcodestring,"SBC ($a),Y");
	
	if (opcode==0xF2) strcpy (opcodestring,"???");
	
	if (opcode==0xF3) strcpy (opcodestring,"??? ($a),Y");
	
	if (opcode==0xF4) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0xF5) strcpy (opcodestring,"SBC $a,X");
	
	if (opcode==0xF6) strcpy (opcodestring,"INC $a,X");
	
	if (opcode==0xF7) strcpy (opcodestring,"??? $a,X");
	
	if (opcode==0xF8) strcpy (opcodestring,"SED");
	
	if (opcode==0xF9) strcpy (opcodestring,"SBC $ba,Y");
	
	if (opcode==0xFA) strcpy (opcodestring,"???");
	
	if (opcode==0xFB) strcpy (opcodestring,"??? $ba,Y");
	
	if (opcode==0xFC) strcpy (opcodestring,"??? $ba,X");
	
	if (opcode==0xFD) strcpy (opcodestring,"SBC $ba,X");
	
	if (opcode==0xFE) strcpy (opcodestring,"INC $ba,X");
	
	if (opcode==0xFF) strcpy (opcodestring,"??? $ba,X");
	
}



/////////////////////////////////////////////////////////////////////////////



void showpos (unsigned int curr_loc, unsigned char a_reg, unsigned char x_reg, unsigned char y_reg, unsigned char flags, unsigned int stack_ptr)

{
	
	unsigned char r1,r2,r3,r4,x; unsigned char hex[17],pos,d; unsigned int ps;
	
	int x1,y1; unsigned char afound=0,bfound=0;
	
	for (x=0;x<10;x++) {hex[x]='0'+x;} for (x=0;x<6;x++) {hex[10+x]=1+x;}
	
	ps=curr_loc; r2=ps/256; ps=ps-(r1*256); r4=ps;
	
	r1=r2/16; r2=r2-r1*16; r3=r4/16; r4=r4-r3*16;
	
	putcbmchar ('$',0,0,1,0);putcbmchar (hex[r1],1,0,1,0);
	
	putcbmchar (hex[r2],2,0,1,0);putcbmchar (hex[r3],3,0,1,0);
	
	putcbmchar (hex[r4],4,0,1,0);putcbmchar (':',5,0,7,0);
	
	putcbmchar (' ',6,0,1,0);putcbmchar ('$',7,0,1,0);
	
	x=Peek(curr_loc); putcbmchar (hex[x/16],8,0,1,0);putcbmchar (hex[x%16],9,0,1,0);
	
	for (x=10;x<18;x++) {putcbmchar(32,x,0,7,0);} pos=x;
	
	putcbmchar (':',pos++,0,7,0);putcbmchar (32,pos++,0,7,0);
	
	getopcodestring (Peek(curr_loc));
	
	for (x=0;x<strlen(opcodestring);x++) {
		
		d=opcodestring[x];if (d>63&&d<91) d-=64;if (d!='a'&&d!='b') {putcbmchar (d,pos,0,1,0);}
		
		if (d=='a') { d=Peek(curr_loc+1); putcbmchar (hex[d/16],pos,0,1,0); pos++;putcbmchar (hex[d%16],pos,0,1,0);
		
		putcbmchar ('$',11,0,1,0);putcbmchar (hex[d/16],12,0,1,0);putcbmchar (hex[d%16],13,0,1,0);afound=1;}
		
		if (d=='b') { d=Peek(curr_loc+2); putcbmchar (hex[d/16],pos,0,1,0); pos++;putcbmchar (hex[d%16],pos,0,1,0);
		
		putcbmchar ('$',15,0,1,0);putcbmchar (hex[d/16],16,0,1,0);putcbmchar (hex[d%16],17,0,1,0);bfound=1;}
		
		pos++;}
	
	for (x=pos;x<32;x++) {putcbmchar(32,x,0,1,0);}
	
	putcbmchar ('N'-64,32,0,7,0); putcbmchar ((flags&128)/128+'0',32,1,1,0);
	
	putcbmchar ('V'-64,33,0,7,0); putcbmchar ((flags&64)/64+'0',33,1,1,0);
	
	putcbmchar ('-',34,0,7,0);    putcbmchar ((flags&32)/32+'0',34,1,1,0);
	
	putcbmchar ('B'-64,35,0,7,0); putcbmchar ((flags&16)/16+'0',35,1,1,0);
	
	putcbmchar ('D'-64,36,0,7,0); putcbmchar ((flags&8)/8+'0',36,1,1,0);
	
	putcbmchar ('I'-64,37,0,7,0); putcbmchar ((flags&4)/4+'0',37,1,1,0);
	
	putcbmchar ('Z'-64,38,0,7,0); putcbmchar ((flags&2)/2+'0',38,1,1,0);
	
	putcbmchar ('C'-64,39,0,7,0); putcbmchar ((flags&1)/1+'0',39,1,1,0);
	
	strcpy (opcodestring,"STACKP: "); pos=0;
	
	for (x=0;x<strlen(opcodestring);x++){
		
		d=opcodestring[x];if (d>63&&d<91) d-=64;putcbmchar (d,pos,1,7,0);pos++;}
	
	ps=stack_ptr; r2=ps/256; ps=ps-(r1*256); r4=ps;putcbmchar ('$',pos++,1,1,0);
	
	r1=r2/16; r2=r2-r1*16; r3=r4/16; r4=r4-r3*16;
	
	putcbmchar (hex[r1],pos++,1,1,0);putcbmchar (hex[r2],pos++,1,1,0);
	
	putcbmchar (hex[r3],pos++,1,1,0);putcbmchar (hex[r4],pos++,1,1,0);
	
	putcbmchar (32,pos++,1,1,0);putcbmchar ('A'-64,pos++,1,7,0);putcbmchar (':',pos++,1,7,0);putcbmchar ('$',pos++,1,1,0);
	
	putcbmchar (hex[a_reg/16],pos++,1,1,0);putcbmchar (hex[a_reg%16],pos++,1,1,0);
	
	putcbmchar (32,pos++,1,1,0);putcbmchar ('X'-64,pos++,1,7,0);putcbmchar (':',pos++,1,7,0);putcbmchar ('$',pos++,1,1,0);
	
	putcbmchar (hex[x_reg/16],pos++,1,1,0);putcbmchar (hex[x_reg%16],pos++,1,1,0);
	
	putcbmchar (32,pos++,1,1,0);putcbmchar ('Y'-64,pos++,1,7,0);putcbmchar (':',pos++,1,7,0);putcbmchar ('$',pos++,1,1,0);
	
	putcbmchar (hex[y_reg/16],pos++,1,1,0);putcbmchar (hex[y_reg%16],pos++,1,1,0);
	
	putcbmchar (32,pos++,1,1,0);
	
	if (afound==0) {putcbmchar ('$',11,0,1,0);putcbmchar ('.',12,0,1,0);putcbmchar ('.',13,0,1,0);}
	
	if (bfound==0) {putcbmchar ('$',15,0,1,0);putcbmchar ('.',16,0,1,0);putcbmchar ('.',17,0,1,0);}
	
	flip();
	
}

/////////////////////////////////////////////////////////////////////////////

static int sbgetset(void)
{
	int i;
	char *BLASTER=getenv("BLASTER");
	if(BLASTER==NULL)
		if((BLASTER=getenv("blaster"))==NULL)
		{
			//                        Cleanup ("SET BLASTER not detected");
			return(1);
		}
		for(i=0;BLASTER[i]!=0;i++)
		{
			switch(BLASTER[i]) {
			case 'A':SBbase=(BLASTER[i+1]-'0')*0x100+
						 (BLASTER[i+2]-'0')*0x10+
						 (BLASTER[i+3]-'0');
				sbaddr=SBbase;
				break;
			default: break;
			}
		}
		return(0);
}

/////////////////////////////////////////////////////////////////////////////

void sbvol (unsigned char vol)
{
	outportb (sbaddr+4,4);
	outportb (sbaddr+5,(vol<<4)|vol);
}

/////////////////////////////////////////////////////////////////////////////


void Singlecolsprite (unsigned char primecol,unsigned int spriteloc,unsigned char dubx,unsigned char duby,unsigned char addx,int xpos,int ypos)
{
	unsigned char x1,x2,y,check,curr,col;
	unsigned int screenpos,rampos; int xnow,ynow;
	xpos+=addx*256;
	col=primecol+100;
	for (y=0;y<21;y++) {
		for (x1=0;x1<3;x1++) {curr=RAMPointer[spriteloc+x1+3*y]; check=128;
		for (x2=0;x2<8;x2++) {
			if (curr>=check) {curr=curr-check;
			screenpos=((x1*8+x2)*(dubx+1)+xpos)+320*(y*(duby+1)+ypos);
			xnow=(x1*8+x2)*(dubx+1)+xpos;
			ynow=(y*(duby+1)+ypos);
			if (xnow>=0&&xnow<=319&&ynow>=0&&ypos+y<=199) Virtualscreen[screenpos]=col;
			if (dubx==1&&xnow+1>=0&&xnow+1<=319&&ynow>=0&&ynow<=199) {Virtualscreen[screenpos+1]=col;}
			if (duby==1&&xnow>=0&&xnow<=319&&ynow+1>=0&&ynow+1<=199) {Virtualscreen[screenpos+320]=col;}
			if (dubx==1&&duby==1&&xnow+1>=0&&xnow+1<=319&&ynow+1>=0&&ynow+1<=199) {Virtualscreen[screenpos+321]=col;}
			}
			check=check/2;
	} } }
}

/////////////////////////////////////////////////////////////////////////////

void Multicolsprite (unsigned char primecol,unsigned char coltwo,unsigned char colthree,unsigned int spriteloc,unsigned char dubx,unsigned char duby,unsigned char addx,int xpos,int ypos)
{
	unsigned char x1,x2,y,check,curr,col,multicol,colors[4];
	unsigned int screenpos,rampos; int xnow,ynow;
	xpos+=addx*256;
	colors[1]=coltwo;//VICRegs[0x25];
	colors[3]=colthree;//VICRegs[0x26];
	colors[2]=primecol;
	col=colors[2];
	for (y=0;y<21;y++) {
		for (x1=0;x1<3;x1++) {curr=RAMPointer[spriteloc+x1+3*y]; check=128;
		for (x2=0;x2<4;x2++) {
			multicol=0;
			if (curr>=check) {curr=curr-check; multicol+=2;} check=check/2;
			if (curr>=check) {curr=curr-check; multicol+=1;} check=check/2;
			col=colors[multicol];
			if (multicol!=0) {
				screenpos=(x1*8+x2*2)*(dubx+1)+xpos+320*((y)*(duby+1)+ypos);
				xnow=(x1*8+x2*2)*(dubx+1)+xpos;
				ynow=((y)*(duby+1)+ypos);
				if (xnow>=0&&xnow<=319&&ynow>=0&&ypos+y<=199) Virtualscreen[screenpos]=col+100;
				if (xnow+1>=0&&xnow+1<=319&&ynow>=0&&ypos+y<=199) Virtualscreen[screenpos+1]=col+100;
				if (dubx==1) {
					if (xnow+2>=0&&xnow+2<=319&&ynow>=0&&ypos+y<=199) Virtualscreen[screenpos+2]=col+100;
					if (xnow+3>=0&&xnow+3<=319&&ynow>=0&&ypos+y<=199) Virtualscreen[screenpos+3]=col+100;
				}
				if (duby==1) {
					if (xnow>=0&&xnow<=319&&ynow+1>=0&&ypos+y+1<=199) Virtualscreen[screenpos+320]=col+100;
					if (xnow+1>=0&&xnow+1<=319&&ynow+1>=0&&ypos+y+1<=199) Virtualscreen[screenpos+321]=col+100;
				}
				if (dubx==1&&duby==1) {
					if (xnow+2>=0&&xnow+2<=319&&ynow+1>=0&&ypos+y+1<=199) Virtualscreen[screenpos+322]=col+100;
					if (xnow+3>=0&&xnow+3<=319&&ynow+1>=0&&ypos+y+1<=199) Virtualscreen[screenpos+323]=col+100;
				}
	} } } }
}

/////////////////////////////////////////////////////////////////////////////


void Sprite (void)

{
	
	unsigned char x,powtwo; int xpos,ypos; unsigned char hibyte;
	powtwo=128;
	for (x=0;x<8;x++)
	{
		if ((VICRegs[0x15]&powtwo)/powtwo==1) {
			hibyte=(VICRegs[0x10]&powtwo)/powtwo;
			xpos=VICRegs[0+(7-x)*2]-24;
			ypos=VICRegs[1+(7-x)*2]-50;
			if ((VICRegs[0x1C]&powtwo)/powtwo==1) {Multicolsprite(VICRegs[0x27+(7-x)],VICRegs[0x25],VICRegs[0x26],(RAMPointer[vic_vm+vic_bank+0x3f8+(7-x)])*64+vic_bank,(VICRegs[0x1D]&powtwo)/powtwo,(VICRegs[0x17]&powtwo)/powtwo,hibyte,xpos,ypos);}
			else {Singlecolsprite(VICRegs[0x27+(7-x)],(RAMPointer[vic_vm+vic_bank+0x3f8+(7-x)])*64+vic_bank,(VICRegs[0x1D]&powtwo)/powtwo,(VICRegs[0x17]&powtwo)/powtwo,hibyte,xpos,ypos);} }
		powtwo=powtwo/2;
	}
}

/////////////////////////////////////////////////////////////////////////////

void spriteinfo (void)
{
	unsigned char powtwo; int xpos,ypos; unsigned char hibyte;
	int x,y; unsigned char text[45]; int r,g,b; unsigned int pos,col,cur;
	float clr; unsigned char ecm,bmm,mcm,vers; 
	unsigned char col1,col2,col3;
	col1=1; col2=VICRegs[0x25]; col3=VICRegs[0x26];
	SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2); percent=100;skipper=0;frameskip=0;showvol=0;
	for (x=-1;x<281;x++) { for (y=15;y<135;y++) {
		col=100;  if ((x==2||x==3)&&(y>17&&y<132)) {col=101;}
		if ((y==18||y==19)&&(x>1&&x<278)) {col=101;}
		if ((x==276||x==277)&&(y>17&&y<132)) {col=101;}
		if ((y==130||y==131)&&(x>1&&x<278)) {col=101;}
		Virtualscreen[(x+20)+320*(y+25)]=col; } }
	
	do {
		
		strcpy (text,"CURRENT SPRITE: xxx");
		text[16]=currsprite/100; text[17]=currsprite/10-10*(currsprite/100); text[18]=currsprite%10;
		text[16]+='0';text[17]+='0';text[18]+='0';
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,10+x,7,1,0);}
		if (key[KB_left]) {currsprite--; do {} while (key[KB_left]); if (currsprite==-1) currsprite=255;}
		if (key[KB_right]) {currsprite++; do {} while (key[KB_right]); if (currsprite==256) currsprite=0;}
		if (key[KB_1]) {col1++; if (col1>=16) col1=0; do {} while (key[KB_1]);}
		if (key[KB_2]) {col2++; if (col2>=16) col2=0; do {} while (key[KB_2]);}
		if (key[KB_3]) {col3++; if (col3>=16) col3=0; do {} while (key[KB_3]);}
		
		for (x=66;x<248;x++) {
			for (y=74;y<123;y++) {
				Virtualscreen[x+320*y]=114;
		} }
		
		Singlecolsprite (col1,(currsprite)*64+vic_bank,0,0,0,68,88);
		Multicolsprite (col1,col2,col3,(currsprite)*64+vic_bank,0,0,0,222,88);
		Singlecolsprite (col1,(currsprite)*64+vic_bank,1,1,0,103,77);
		Multicolsprite (col1,col2,col3,(currsprite)*64+vic_bank,1,1,0,163,77);
		for (x=0;x<25;x++) {
			for (y=0;y<22;y++) {
				Virtualscreen[x*2+320*y*2+(103+77*320)]=106;
				if (x<24) Virtualscreen[x*2+320*y*2+1+(103+77*320)]=106;
				if (y<21) Virtualscreen[x*2+320*y*2+320+(103+77*320)]=106;
		} }
		for (x=0;x<13;x++) {
			for (y=0;y<22;y++) {
				Virtualscreen[x*4+320*y*2+(163+77*320)]=106;
				if (x<12) {
					Virtualscreen[x*4+320*y*2+1+(163+77*320)]=106;
					Virtualscreen[x*4+320*y*2+2+(163+77*320)]=106;
					Virtualscreen[x*4+320*y*2+3+(163+77*320)]=106;}
				if (y<21) Virtualscreen[x*4+320*y*2+320+(163+77*320)]=106;
		} }
		
		strcpy (text," COL1 "); y=0; if (col1==0) y=1;
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,9+x,17,y,col1);}
		
		strcpy (text," COL2 "); y=0; if (col2==0) y=1;
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,17+x,17,y,col2);}
		
		strcpy (text," COL3 "); y=0; if (col3==0) y=1;
		for (x=0;x<strlen(text);x++){col=text[x]; if (col>64&&col<91) col=col-64; putcbmchar (col,25+x,17,y,col3);}
		
		flip (); } while (key[KB_escape]!=1);do {} while (key[KB_escape]==1);
		rawkey=0; skipper=0;
}

/////////////////////////////////////////////////////////////////////////////

void CIA (void)

{
	
	unsigned int index; unsigned char messy[40];
	FILE *f;
	
	
	if (key[KB_left_control]&key[KB_sqropen]&volume>0&showvol<44) {volume--; sbvol (volume);  showvol=45;}
	if (key[KB_left_control]&key[KB_sqrcls]&volume<15&showvol<44) {volume++; sbvol (volume); showvol=45;}
	if (key[KB_left_alt]&key[KB_f3]) {vidmode=1-vidmode; SetMode(0x13); setcolors(); do {} while (key[KB_f3]);}
	
	if (key[KB_f1]&&key[KB_left_control]) {v2on=1-v2on; showsid=25; do {} while (key[KB_f1]);}
	if (key[KB_f2]&&key[KB_left_control]) {v3on=1-v3on; showsid=25; do {} while (key[KB_f2]);}
	if (key[KB_f3]&&key[KB_left_control]) {v1on=1-v1on; showsid=25; do {} while (key[KB_f3]);}
	
	if (showsid>0)
	{
		putcbmchar ('S'-64,0,0,1,0);
		putcbmchar ('I'-64,1,0,1,0);
		putcbmchar ('D'-64,2,0,1,0);
		putcbmchar (':',3,0,1,0);
		putcbmchar (' ',4,0,1,0);
		putcbmchar ('V'-64,5,0,1,0);
		putcbmchar ('1',6,0,1,0);
		putcbmchar ('-',7,0,1,0);
		putcbmchar ('0'+v2on,8,0,1,0);
		putcbmchar (' ',9,0,1,0);
		putcbmchar ('V'-64,10,0,1,0);
		putcbmchar ('2',11,0,1,0);
		putcbmchar ('-',12,0,1,0);
		putcbmchar ('0'+v3on,13,0,1,0);
		putcbmchar (' ',14,0,1,0);
		putcbmchar ('V'-64,15,0,1,0);
		putcbmchar ('3',16,0,1,0);
		putcbmchar ('-',17,0,1,0);
		putcbmchar ('0'+v1on,18,0,1,0);
		showsid--;
	}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_r]) {/*Message("HARD RESET",250);*/ reset=1;}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_i]) {spriteinfo();}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_k]) {sidinfo();}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_v]) {generalvicinfo();}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_plus]) {if (gamma<=1.8) {gamma=gamma+0.05; setcolors();}do{}while(key[KB_plus]);}
	
	if (key[KB_left_control]&key[KB_left_alt]&key[KB_min]) {if (gamma>=.05) {gamma=gamma-0.05; setcolors();}do{}while(key[KB_min]);}
	
	if (key[KB_left_alt]&key[KB_f4]) {done=1;}
	
	if (key[KB_left_alt]&key[KB_f1]) {intro(); setcolors();}
	if (key[KB_left_alt]&key[KB_f2]) {help(); setcolors();}
	
	if (key[KB_f9]) {dirprg(); rawkey=0;}
	
	// ADD BY MAX
	/////////////////////////////////////////////
	if (key[KB_f10]) {dircart(); rawkey=0;}
	/////////////////////////////////////////////
	
	if (key[KB_insert]) NMI=1;
	
	if (rawkey>0) {if(rawkey==KB_escape) {do {} while (key[KB_escape]); menu();}
	
	if (rawkey<0x80) { key_pressed[key_table[rawkey][0]]&=255-key_table[rawkey][1]; rawkey=0;
	
	} else { rawkey&=0x7f;	key_pressed[key_table[rawkey][0]]|=key_table[rawkey][1];
	
	rawkey=0;}} RAMPointer[0xDC01]=key_pressed[255-(oldkeycolumn=RAMPointer[0xDC00])];
	
	if (RAMPointer[0xdc01]<255&&RAMPointer[0xdc01]>0&&keysdown==0) {for(index=0;index<255;index++)key_pressed[index]=255;}
	
}





/////////////////////////////////////////////////////////////////////////////



char *data;

static void VICDrawLine(void)
{
	int scrn_x,scrn_y,i;
	unsigned int temp,line;
	unsigned char *scrn,*chr,*clrp,*result;
	unsigned char bits;
	unsigned char clr;
	bcolor[vic_y]=vic_ec;
	scrn_y=vic_y-50;
	if((scrn_y<0)||(scrn_y>200));
	else if(!vic_den||(!vic_rsel&&((scrn_y<4)||(scrn_y>=196))))
		_fmemset(Virtualscreen+(scrn_y<<8)+(scrn_y<<6),vic_ec+100,320);
	else
	{
		_fmemset(data,-1,320);
		//		if(vic_bmm)
		//		{//Bitmap modes
		//		}
		//		else if(vic_ecm)
		//		{//Extended bg mode
		//		}
		//		else
		{
			line=(scrn_y-vic_yscrl+3)&0xFFF8;
			line+=line<<2;
			temp=vic_vm+line+vic_bank;
			if((temp&0x7000)==0x1000)
				scrn=&CharPointer[temp&0xFFF];
			else	scrn=&RAMPointer[temp];
			temp=vic_bank+vic_cb+((scrn_y-vic_yscrl+3)&7);
			if((temp&0x7000)==0x1000)
				chr=&CharPointer[temp&0xFFF];
			else	chr=&RAMPointer[temp];
			clrp=&ColorPointer[line];
			result=&data[vic_xscrl];
			//ASM Version:
			if(vic_mcm)
			{
				asm push ds
					asm push si
					asm push es
					asm push di
					asm mov cx,0x0028
					asm les di,scrn
					asm mov bx,es
					asm db 0x66
					asm shl bx,16
					asm mov bx,di	//EBX now contains scrn ptr
					asm les di,chr
					asm mov dx,es
					asm db 0x66
					asm shl dx,16
					asm mov dx,di	//EDX now contains chr ptr
					asm mov ah,vic_b2c
					asm mov al,vic_b1c
					asm db 0x66
					asm shl ax,16
					asm les di,clrp
					asm lds si,result
mcloop:				asm push es
					asm push di
					asm mov di,bx
					asm db 0x66
					asm shr bx,16
					asm mov es,bx
					asm db 0x66
					asm shl bx,16
					asm mov bx,di
					asm inc bx
					asm mov al,[es:di]
					asm xor ah,ah
					asm shl ax,3
					asm add ax,dx
					asm mov di,ax
					asm mov ax,dx
					asm db 0x66
					asm shr dx,16
					asm mov es,dx
					asm db 0x66
					asm shl dx,16
					asm mov dx,ax
					asm mov al,[es:di]
					asm pop di
					asm pop es
					asm mov ah,[es:di]
					asm inc di
					asm test ah,0x08
					asm jne mc_text
					asm shl al,1
					asm jnc b0
					asm mov [ds:si],ah
b0:				asm inc si
				asm shl al,1
				asm jnc b1
				asm mov [ds:si],ah
b1:				asm inc si
				asm shl al,1
				asm jnc b2
				asm mov [ds:si],ah
b2:				asm inc si
				asm shl al,1
				asm jnc b3
				asm mov [ds:si],ah
b3:				asm inc si
				asm shl al,1
				asm jnc b4
				asm mov [ds:si],ah
b4:				asm inc si
				asm shl al,1
				asm jnc b5
				asm mov [ds:si],ah
b5:				asm inc si
				asm shl al,1
				asm jnc b6
				asm mov [ds:si],ah
b6:				asm inc si
				asm shl al,1
				asm jnc b7
				asm mov [ds:si],ah
b7:				asm inc si
				asm loop mcloop
				asm jmp end_mctext
mc_text:			asm and ah,0x07
					asm shl al,1
					asm jnc mca0x
					asm shl al,1
					asm jnc mca10
					asm mov [ds:si],ah
					asm inc si
					asm mov [ds:si],ah
					asm jmp mcbxx
mca10:                          asm push ax
								asm db 0x66
								asm shr ax,16
								asm mov [ds:si],ah
								asm inc si
								asm mov [ds:si],ah
								asm db 0x66
								asm shl ax,16
								asm pop ax
								asm jmp mcbxx
mca0x:				asm shl al,1
					asm jnc mca00
					asm push ax
					asm db 0x66
					asm shr ax,16
					asm mov [ds:si],al
					asm inc si
					asm mov [ds:si],al
					asm db 0x66
					asm shl ax,16
					asm pop ax
					asm jmp mcbxx
mca00:				asm inc si
mcbxx:				asm inc si
					asm shl al,1
					asm jnc mcb0x
					asm shl al,1
					asm jnc mcb10
					asm mov [ds:si],ah
					asm inc si
					asm mov [ds:si],ah
					asm jmp mccxx
mcb10:                          asm push ax
								asm db 0x66
								asm shr ax,16
								asm mov [ds:si],ah
								asm inc si
								asm mov [ds:si],ah
								asm db 0x66
								asm shl ax,16
								asm pop ax
								asm jmp mccxx
mcb0x:				asm shl al,1
					asm jnc mcb00
					asm push ax
					asm db 0x66
					asm shr ax,16
					asm mov [ds:si],al
					asm inc si
					asm mov [ds:si],al
					asm db 0x66
					asm shl ax,16
					asm pop ax
					asm jmp mccxx
mcb00:				asm inc si
mccxx:				asm inc si
					asm shl al,1
					asm jnc mcc0x
					asm shl al,1
					asm jnc mcc10
					asm mov [ds:si],ah
					asm inc si
					asm mov [ds:si],ah
					asm jmp mcdxx
mcc10:                          asm push ax
								asm db 0x66
								asm shr ax,16
								asm mov [ds:si],ah
								asm inc si
								asm mov [ds:si],ah
								asm db 0x66
								asm shl ax,16
								asm pop ax
								asm jmp mcdxx
mcc0x:				asm shl al,1
					asm jnc mcc00
					asm push ax
					asm db 0x66
					asm shr ax,16
					asm mov [ds:si],al
					asm inc si
					asm mov [ds:si],al
					asm db 0x66
					asm shl ax,16
					asm pop ax
					asm jmp mcdxx
mcc00:                          asm inc si
mcdxx:				asm inc si
					asm shl al,1
					asm jnc mcd0x
					asm shl al,1
					asm jnc mcd10
					asm mov [ds:si],ah
					asm inc si
					asm mov [ds:si],ah
					asm jmp b7
mcd10:                          asm push ax
								asm db 0x66
								asm shr ax,16
								asm mov [ds:si],ah
								asm inc si
								asm mov [ds:si],ah
								asm db 0x66
								asm shl ax,16
								asm pop ax
								asm jmp b7
mcd0x:				asm shl al,1
					asm jnc mcd00
					asm push ax
					asm db 0x66
					asm shr ax,16
					asm mov [ds:si],al
					asm inc si
					asm mov [ds:si],al
					asm db 0x66
					asm shl ax,16
					asm pop ax
					asm jmp b7
mcd00:                          asm inc si
								asm jmp b7
end_mctext:			asm pop di
					asm pop es
					asm pop si
					asm pop ds
			}
			else
			{
				asm push ds
					asm mov cx,0x0028
					asm les di,scrn
					asm mov bx,es
					asm db 0x66
					asm shl bx,16
					asm mov bx,di	//EBX now contains scrn ptr
					asm les di,chr
					asm mov dx,es
					asm db 0x66
					asm shl dx,16
					asm mov dx,di	//EDX now contains chr ptr
					asm les di,clrp
					asm lds si,result
loop:				asm push es
					asm push di
					asm mov di,bx
					asm db 0x66
					asm shr bx,16
					asm mov es,bx
					asm db 0x66
					asm shl bx,16
					asm mov bx,di
					asm inc bx
					asm mov al,[es:di]
					asm xor ah,ah
					asm shl ax,3
					asm add ax,dx
					asm mov di,ax
					asm mov ax,dx
					asm db 0x66
					asm shr dx,16
					asm mov es,dx
					asm db 0x66
					asm shl dx,16
					asm mov dx,ax
					asm mov al,[es:di]
					asm pop di
					asm pop es
					asm mov ah,[es:di]
					asm inc di
					asm shl al,1
					asm jnc a0
					asm mov [ds:si],ah
a0:				asm inc si
				asm shl al,1
				asm jnc a1
				asm mov [ds:si],ah
a1:				asm inc si
				asm shl al,1
				asm jnc a2
				asm mov [ds:si],ah
a2:				asm inc si
				asm shl al,1
				asm jnc a3
				asm mov [ds:si],ah
a3:				asm inc si
				asm shl al,1
				asm jnc a4
				asm mov [ds:si],ah
a4:				asm inc si
				asm shl al,1
				asm jnc a5
				asm mov [ds:si],ah
a5:				asm inc si
				asm shl al,1
				asm jnc a6
				asm mov [ds:si],ah
a6:				asm inc si
				asm shl al,1
				asm jnc a7
				asm mov [ds:si],ah
a7:				asm inc si
				asm loop loop
				asm pop ds
			}
		}       		//Add sprites and compare priorities here
		line=(scrn_y<<8)+(scrn_y<<6);
		if(vic_csel)
		{
			asm push ds
				asm mov bl,vic_b0c
				asm les di,data
				asm lds si,Virtualscreen
				asm add si,line
				asm mov cx,0x140
j0:			asm mov al,[es:di]
			asm cmp al,0xFF
			asm jne j1
			asm mov al,bl
j1:			asm add al,0x64
			asm mov [ds:si],al
			asm inc si
			asm inc di
			asm loop j0
			asm pop ds
		}
		else
		{
			asm push ds
				asm mov bl,vic_b0c
				asm les di,data
				asm mov al,vic_ec
				asm add al,0x64
				asm mov ah,al
				asm push ax
				asm lds si,Virtualscreen
				asm add si,line
				asm mov [ds:si],ax
				asm add si,2
				asm mov [ds:si],ax
				asm add si,2
				asm mov [ds:si],ax
				asm add si,2
				asm mov [ds:si],al
				asm inc si
				asm mov cx,0x130
				asm add di,7
k0:			asm mov al,[es:di]
			asm cmp al,0xFF
			asm jne k1
			asm mov al,bl
k1:			asm add al,0x64
			asm mov [ds:si],al
			asm inc si
			asm inc di
			asm loop k0
			asm pop ax
			asm mov [ds:si],ax
			asm add si,2
			asm mov [ds:si],ax
			asm add si,2
			asm mov [ds:si],ax
			asm add si,2
			asm mov [ds:si],ax
			asm add si,2
			asm mov [ds:si],al
			asm pop ds
		}
	}
}


/////////////////////////////////////////////////////////////////////////////

void MainLoop(void)
{
	unsigned int address,jmp_from;
	unsigned char curr_inst=0x80;
	unsigned char error[40];
	unsigned int curr_loc=(KernalPointer[0x1FFD]<<8)+KernalPointer[0x1FFC];
	unsigned char stack_ptr=0xFF;
	unsigned char a_reg=0,x_reg=0,y_reg=0,flags=0x30,curr_cycle,gen1;
	pair K;
	done=reset=vic_x=vic_y=0;
	vic_rasirq=0xFFFF;
	data=farmalloc(327); //7 dummy bytes
	for(;;)
	{
		// VIC
		// We need to draw 8 dots in the time it takes the CPU to
		// execute one cycle (dot clock=8.1818 Mhz,
		// CPU_clock=dot_clock/8)
		vic_x+=8;
		if(vic_x>=512)
		{
			if(!frameskip||!autoskip)
				if (vic_y+interlaceline&1||!interlaced) {VICDrawLine();}
				vic_x=0;
#ifdef PAL
				if(++vic_y==312)
#else
					if(++vic_y==262)
#endif
					{
						if(!frameskip||!autoskip)
						{
							CIA();
							/*	if (!key[KB_f10]) */Sprite();
							if(key[KB_scrolllock])showpercent();
							/*if (!key[KB_f10]) */{
							if (interl_on==0) interlaced=0;
							if (interl_on==1) interlaced=1;
							if (interl_on==2) {interlaced=0; if (skipper>7) interlaced=1;}
							flip(); interlaceline=1-interlaceline;
							Klight(leds);}
							frameskip=skipper;
						}
						else frameskip--;
						vic_y=0;
					}
					if(vic_y==vic_rasirq)
					{
						VICRegs[0x19]|=1;
						if(VICRegs[0x1A]&0x1)
						{
							IRQ=1;
							VICRegs[0x19]|=0x80;
						}
					}
		}
		// 6510
		switch(curr_inst) {
		case 0x80:
			if(done)
				return;
			if(reset==1)
			{
				curr_loc=((unsigned int)KernalPointer[0x1FFD]<<8)+(unsigned int)KernalPointer[0x1FFC];
				stack_ptr=0xFF;
				flags=0x30;
				clearmem();
				IRQ=NMI=reset=0;
				Klight(SNDkeys=0); leds=0;
				
			}
			else if(reset==2)
			{
				RAMPointer[1]=55;
				curr_inst=0x80;
				curr_loc=2456;
				IRQ=NMI=reset=0;
				Klight(SNDkeys=0); leds=0;
			}
			if(key[KB_capslock])
			{
				showpos(curr_loc,a_reg,x_reg,y_reg,flags,stack_ptr);
				//				while(key[KB_capslock]&&!key[KB_space]);
				//				while(key[KB_capslock]&&key[KB_space]);
				delay (100);
			}
			if(IRQ)
			{
				if(flags&INT)goto NOIRQ;
				Poke(0x100+stack_ptr--,curr_loc>>8);
				Poke(0x100+stack_ptr--,curr_loc&255);
				Poke(0x100+stack_ptr--,flags&BRK_OFF);
				curr_loc=Deek(0xFFFE);
				flags|=INT;
			}
			
			/*flt intro*/			else {if (dointro==1) {if (curr_loc==0xe5cd) {dointro=0; LoadMonitor(); reset=2;}}}
			
			/*on reset sound off*/		if (curr_loc==0xfce2) {SNDkeys&=~(1<<0);SNDkeys&=~(1<<1);SNDkeys&=~(1<<2);}
			/*load program*/		if (curr_loc==0xf4b8) {if (Peek(186)==8) {
			curr_loc=Basic2_ProgLoad();
			if (curr_loc==0xf5d2) flags|=CARRY-CARRY;
			} }
			
			if(NMI)
			{
				NMI=0;
				Poke(0x100+stack_ptr--,(curr_loc)>>8);
				Poke(0x100+stack_ptr--,(curr_loc)&255);
				Poke(0x100+stack_ptr--,flags);
				curr_loc=Deek(0xFFFA);
			}
NOIRQ:                  if((curr_inst=Peek(curr_loc))==0x80)
							curr_inst=0x82;
						curr_cycle=1;
						break;
						
		case 0x00: //BRK();
			if(curr_cycle==1)
			{
				Poke(0x100+stack_ptr--,(curr_loc+2)>>8);
				Poke(0x100+stack_ptr--,(curr_loc+2)&255);
				Poke(0x100+stack_ptr--,flags);
				flags|=INT;
				curr_loc=Deek(0xFFFE);
			}
			if(curr_cycle++==6)	curr_inst=0x80;
			break;
		case 0x01: //ORA_IndX();
			if(curr_cycle==1)
			{
				IndX();
				ORA();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x05: //ORA_Zero();
			if(curr_cycle==1)
			{
				Zero();
				ORA();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x06: //ASL_Zero();
			if(curr_cycle==1)
			{
				Zero();
				ASL();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x08: //PHP();
			if(curr_cycle==1)
			{
				Poke(0x100+stack_ptr--,flags);
				curr_loc+=1;
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x09: //ORA_Imm();
			Imm();
			ORA();
			curr_inst=0x80;
			break;
		case 0x0A: //ASL_Acc();
			if(a_reg&0x80)flags|=CARRY;else flags&=(CRRY_OFF);
			a_reg<<=1;
			setflags(a_reg);
			curr_inst=0x80;
			curr_loc++;
			break;
		case 0x0D: //ORA_Abs();
			if(curr_cycle==1)
			{
				Abs();
				ORA();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x0E: //ASL_Abs();
			if(curr_cycle==1)
			{
				Abs();
				ASL();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x10: //BPL();
			if(curr_cycle==1)curr_loc+=2;
			if((flags&NEGATIVE)==0)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)
					curr_inst=0x80;
			}
			else
				curr_inst=0x80;
			break;
		case 0x11: //ORA_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				ORA();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x15: //ORA_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				ORA();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x16: //ASL_Zero_X();
			if(curr_cycle++==1)
			{
				Zero_X();
				ASL();
			}
			if(curr_cycle==5)curr_inst=0x80;
			break;
		case 0x18: //CLC();
			flags&=(CRRY_OFF);
			curr_inst=0x80;
			curr_loc++;
			break;
		case 0x19: //ORA_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				ORA();
			}
			if(((address-y_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x1D: //ORA_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				ORA();
			}
			if(((address-x_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x1E: //ASL_Abs_X();
			if(curr_cycle++==1)
			{
				Abs_X();
				ASL();
			}
			if(curr_cycle==6)curr_inst=0x80;
			break;
		case 0x20: //JSR();
			
			curr_loc+=2;
			jmp_from=curr_loc;
			Poke(0x100+stack_ptr--,curr_loc>>8);Poke(0x100+stack_ptr--,curr_loc&255);
			curr_loc=Deek(curr_loc-1);
			curr_inst=0x80;
			break;
		case 0x21: //AND_IndX();
			if(curr_cycle==1)
			{
				IndX();
				AND();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x24: //BIT_Zero();
			if(curr_cycle==1)
			{
				Zero();
				BIT();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x25: //AND_Zero();
			if(curr_cycle==1)
			{
				Zero();
				AND();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x26: //ROL_Zero();
			if(curr_cycle==1)
			{
				Zero();
				ROL();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x28: //PLP();
			if(curr_cycle==1)
			{
				flags=Peek(0x100+(++stack_ptr))|0x30;
			}
			if(curr_cycle++==3)
			{
				curr_inst=0x80;curr_loc++;
			}
			break;
		case 0x29: //AND_Imm();
			Imm();
			AND();
			curr_inst=0x80;
			break;
		case 0x2A: //ROL_Acc();
			gen1=a_reg<<1;
			if(flags&CARRY)gen1|=1;
			if(a_reg&0x80)
				flags|=CARRY;
			else
				flags&=CRRY_OFF;
			setflags(gen1);
			a_reg=gen1;
			curr_inst=0x80;curr_loc++;
			break;
		case 0x2C: //BIT_Abs();
			if(curr_cycle==1)
			{
				Abs();
				BIT();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x2D: //AND_Abs();
			if(curr_cycle==1)
			{
				Abs();
				AND();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x2E: //ROL_Abs();
			if(curr_cycle==1)
			{
				Abs();
				ROL();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x30: //BMI();
			if(curr_cycle==1)curr_loc+=2;
			if(flags&NEGATIVE)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else{curr_inst=0x80;}
			break;
		case 0x31: //AND_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				AND();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x35: //AND_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				AND();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x36: //ROL_Zero_X();
			if(curr_cycle++==1)
			{
				Zero_X();
				ROL();
			}
			if(curr_cycle==5)curr_inst=0x80;
			break;
		case 0x38: //SEC();
			flags|=CARRY;
			curr_inst=0x80;
			curr_loc++;
			break;
		case 0x39: //AND_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				AND();
			}
			if(((address-y_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x3D: //AND_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				AND();
			}
			if(((address-x_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x3E: //ROL_Abs_X();
			if(curr_cycle++==1)
			{
				Abs_X();
				ROL();
			}
			if(curr_cycle==6)curr_inst=0x80;
			break;
		case 0x40: //RTI();
			if(curr_cycle==1)
			{
				flags=Peek(0x100+(++stack_ptr))|0x30;
				K.B.l=Peek(0x100+(++stack_ptr));
				K.B.h=Peek(0x100+(++stack_ptr));
				curr_loc=K.W;
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0x41: //EOR_IndX();
			if(curr_cycle==1)
			{
				IndX();
				EOR();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x45: //EOR_Zero();
			if(curr_cycle==1)
			{
				Zero();
				EOR();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x46: //LSR_Zero();
			if(curr_cycle==1)
			{
				Zero();
				LSR();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x48: //PHA();
			if(curr_cycle==1)
			{
				Poke(0x100+stack_ptr--,a_reg);
				curr_loc++;
			}
			if(curr_cycle++==2)
			{
				curr_inst=0x80;
			}
			break;
		case 0x49: //EOR_Imm();
			Imm();
			EOR();
			curr_inst=0x80;
			break;
		case 0x4A: //LSR_Acc();
			if(a_reg&1)flags|=CARRY;else flags&=(CRRY_OFF);
			a_reg>>=1;
			setflags(a_reg);
			curr_inst=0x80;curr_loc++;
			break;
		case 0x4C: //JMP_Abs();
			if(curr_cycle==1)
			{
                jmp_from=curr_loc;
				curr_loc++;
				curr_loc=Deek(curr_loc);
			}
			if(curr_cycle++==2)	curr_inst=0x80;
			break;
		case 0x4D: //EOR_Abs();
			if(curr_cycle==1)
			{
				Abs();
				EOR();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x4E: //LSR_Abs();
			if(curr_cycle==1)
			{
				Abs();
				LSR();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x50: //BVC();
			if(curr_cycle==1)curr_loc+=2;
			if((flags&F_OVERFLOW)==0)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0x51: //EOR_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				EOR();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x55: //EOR_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				EOR();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x56: //LSR_Zero_X();
			if(curr_cycle++==1)
			{
				Zero_X();
				LSR();
			}
			if(curr_cycle==5)curr_inst=0x80;
			break;
		case 0x58: //CLI();
			flags&=(INT_OFF);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x59: //EOR_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				EOR();
			}
			if(((address-y_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x5D: //EOR_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				EOR();
			}
			if(((address-x_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x5E: //LSR_Abs_X();
			if(curr_cycle++==1)
			{
				Abs_X();
				LSR();
			}
			if(curr_cycle==6)curr_inst=0x80;
			break;
		case 0x60: //RTS();
			if(curr_cycle==1)
			{
				K.B.l=Peek(0x100+(++stack_ptr));
				K.B.h=Peek(0x100+(++stack_ptr));
				curr_loc=K.W+1;
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0x61: //ADC_IndX();
			if(curr_cycle==1)
			{
				IndX();
				ADC();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x65: //ADC_Zero();
			if(curr_cycle==1)
			{
				Zero();
				ADC();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0x66: //ROR_Zero();
			if(curr_cycle==1)
			{
				Zero();
#ifdef DEBUG
				if(address==0x66)
				{
					Message("CPU IS LIKELY HUNG!",500);
					Processor_hung(curr_loc,curr_inst,jmp_from);
				}
#endif
				ROR();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x68: //PLA();
			if(curr_cycle==1)
			{
				a_reg=Peek(0x100+(++stack_ptr));
				setflags(a_reg);
			}
			if(curr_cycle++==3)
			{
				curr_inst=0x80;curr_loc+=1;
			}
			break;
		case 0x69: //ADC_Imm();
			Imm();
			ADC();
			curr_inst=0x80;
			break;
		case 0x6A: //ROR_Acc();
			gen1=a_reg>>1;
			if(flags&CARRY)gen1|=0x80;
			if(a_reg&1)
				flags|=CARRY;
			else
				flags&=CRRY_OFF;
			setflags(gen1);
			a_reg=gen1;
			curr_inst=0x80;curr_loc++;
			break;
		case 0x6C: //JMP_Ind();
			if(curr_cycle==1)
			{
				jmp_from=curr_loc;
				address=Deek(curr_loc+1);
				K.W=address;
				curr_loc=Peek(K.W);
				K.B.l++;
				curr_loc+=Peek(K.W)<<8;
			}
			if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0x6D: //ADC_Abs();
			if(curr_cycle==1)
			{
				Abs();
				ADC();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x6E: //ROR_Abs();
			if(curr_cycle==1)
			{
				Abs();
				ROR();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x70: //BVS();
			if(curr_cycle==1)curr_loc+=2;
			if(flags&F_OVERFLOW)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0x71: //ADC_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				ADC();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0x75: //ADC_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				ADC();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0x76: //ROR_Zero_X();
			if(curr_cycle++==1)
			{
				Zero_X();
				ROR();
			}
			if(curr_cycle==5)curr_inst=0x80;
			break;
		case 0x78: //SEI();
			flags|=INT;
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x79: //ADC_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				ADC();
			}
			if(((address-y_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x7D: //ADC_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				ADC();
			}
			if(((address-x_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0x7E: //ROR_Abs_X();
			if(curr_cycle++==1)
			{
				Abs_X();
				ROR();
			}
			if(curr_cycle==6)curr_inst=0x80;
			break;
		case 0x81: //STA_IndX();
			if(curr_cycle==1)
			{
				IndX();
				Poke(address,a_reg);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0x84: //STY_Zero();
			if(curr_cycle==1)
			{
				Zero();
				Poke(address,y_reg);
			}
			if(curr_cycle++==2) curr_inst=0x80;
			break;
		case 0x85: //STA_Zero();
			if(curr_cycle==1)
			{
				Zero();
				Poke(address,a_reg);
			}
			if(curr_cycle++==2) curr_inst=0x80;
			break;
		case 0x86: //STX_Zero();
			if(curr_cycle==1)
			{
				Zero();
				Poke(address,x_reg);
			}
			if(curr_cycle++==2) curr_inst=0x80;
			break;
		case 0x88: //DEY();
			y_reg--;
			setflags(y_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x8A: //TXA();
			a_reg=x_reg;
			setflags(a_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x8C: //STY_Abs();
			if(curr_cycle==1)
			{
				Abs();
				Poke(address,y_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x8D: //STA_Abs();
			if(curr_cycle==1)
			{
				Abs();
				Poke(address,a_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x8E: //STX_Abs();
			if(curr_cycle==1)
			{
				Abs();
				Poke(address,x_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x90: //BCC();
			if(curr_cycle==1)curr_loc+=2;
			if((flags&CARRY)==0)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0x91: //STA_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				Poke(address,a_reg);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0x94: //STY_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				Poke(address,y_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x95: //STA_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				Poke(address,a_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x96: //STX_Zero_Y();
			if(curr_cycle==1)
			{
				Zero_Y();
				Poke(address,x_reg);
			}
			if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0x98: //TYA();
			a_reg=y_reg;
			setflags(a_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x99: //STA_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
#ifdef DEBUG
				if((address-y_reg)==0x9999)
				{
					Message("CPU IS LIKELY HUNG!",500);
					Processor_hung(curr_loc,curr_inst,jmp_from);
				}
#endif
				Poke(address,a_reg);
			}
			if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0x9A: //TXS();
			stack_ptr=x_reg;
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0x9D: //STA_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				Poke(address,a_reg);
			}
			if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xA0: //LDY_Imm();
			Imm();
			y_reg=Peek(address);
			setflags(y_reg);
			curr_inst=0x80;
			break;
		case 0xA1: //LDA_IndX();
			if(curr_cycle==1)
			{
				IndX();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(curr_cycle++==5)
				curr_inst=0x80;
			break;
		case 0xA2: //LDX_Imm();
			Imm();
			x_reg=Peek(address);
			setflags(x_reg);
			curr_inst=0x80;
			break;
		case 0xA4: //LDY_Zero();
			if(curr_cycle==1)
			{
				Zero();
				y_reg=Peek(address);
				setflags(y_reg);
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xA5: //LDA_Zero();
			if(curr_cycle==1)
			{
				Zero();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xA6: //LDX_Zero();
			if(curr_cycle==1)
			{
				Zero();
				x_reg=Peek(address);
				setflags(x_reg);
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xA8: //TAY();
			y_reg=a_reg;
			setflags(y_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xA9: //LDA_Imm();
			Imm();
			a_reg=Peek(address);
			setflags(a_reg);
			curr_inst=0x80;
			break;
		case 0xAA: //TAX();
			x_reg=a_reg;
			setflags(x_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xAC: //LDY_Abs();
			if(curr_cycle==1)
			{
				Abs();
				y_reg=Peek(address);
				setflags(y_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xAD: //LDA_Abs();
			if(curr_cycle==1)
			{
				Abs();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xAE: //LDX_Abs();
			if(curr_cycle==1)
			{
				Abs();
				x_reg=Peek(address);
				setflags(x_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xB0: //BCS();
			if(curr_cycle==1)curr_loc+=2;
			if(flags&CARRY)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0xB1: //LDA_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(((address-y_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xB4: //LDY_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				y_reg=Peek(address);
				setflags(y_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xB5: //LDA_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xB6: //LDX_Zero_Y();
			if(curr_cycle==1)
			{
				Zero_Y();
				x_reg=Peek(address);
				setflags(x_reg);
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xB8: //CLV();
			flags&=(OVER_OFF);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xB9: //LDA_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(((address-y_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xBA: //TSX();
			x_reg=stack_ptr;
			setflags(x_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xBC: //LDY_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				y_reg=Peek(address);
				setflags(y_reg);
			}
			if(((address-x_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xBD: //LDA_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				a_reg=Peek(address);
				setflags(a_reg);
			}
			if(((address-x_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xBE: //LDX_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				x_reg=Peek(address);
				setflags(x_reg);
			}
			if(((address-y_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xC0: //CPY_Imm();
			Imm();
			CPY();
			curr_inst=0x80;
			break;
		case 0xC1: //CMP_IndX();
			if(curr_cycle==1)
			{
				IndX();
				CMP();
			}
			if(curr_cycle++==5)
				curr_inst=0x80;
			break;
		case 0xC4: //CPY_Zero();
			if(curr_cycle==1)
			{
				Zero();
				CPY();
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xC5: //CMP_Zero();
			if(curr_cycle==1)
			{
				Zero();
				CMP();
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xC6: //DEC_Zero();
			if(curr_cycle==1)
			{
				Zero();
				Poke(address,gen1=Peek(address)-1);
				setflags(gen1);
			}
			if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xC8: //INY();
			y_reg++;
			setflags(y_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xC9: //CMP_Imm();
			Imm();
			CMP();
			curr_inst=0x80;
			break;
		case 0xCA: //DEX();
			x_reg--;
			setflags(x_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xCC: //CPY_Abs();
			if(curr_cycle==1)
			{
				Abs();
				CPY();
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xCD: //CMP_Abs();
			if(curr_cycle==1)
			{
				Abs();
				CMP();
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xCE: //DEC_Abs();
			if(curr_cycle==1)
			{
				Abs();
				Poke(address,gen1=Peek(address)-1);
				setflags(gen1);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0xD0: //BNE();
			if(curr_cycle==1)curr_loc+=2;
			if((flags&ZERO)==0)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
					
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0xD1: //CMP_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				CMP();
			}
			if(((address-y_reg)/256)!=(address/256))
			{
				if(curr_cycle++==5) curr_inst=0x80;
			}
			else if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xD5: //CMP_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				CMP();
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xD6: //DEC_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				Poke(address,gen1=Peek(address)-1);
				setflags(gen1);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0xD8: //CLD();
			flags&=(DEC_OFF);
			curr_inst=0x80;
			curr_loc++;
			break;
		case 0xD9: //CMP_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				CMP();
			}
			if(((address-y_reg)/256)!=(address/256))
			{
				if(curr_cycle++==4) curr_inst=0x80;
			}
			else if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0xDD: //CMP_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				CMP();
			}
			if(((address-x_reg)/256)!=(address/256))
			{
				if(curr_cycle++==4) curr_inst=0x80;
			}
			else if(curr_cycle++==3) curr_inst=0x80;
			break;
		case 0xDE: //DEC_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				Poke(address,gen1=Peek(address)-1);
				setflags(gen1);
			}
			if(curr_cycle++==6) curr_inst=0x80;
			break;
			
		case 0xE0: //CPX_Imm();
			Imm();
			CPX();
			curr_inst=0x80;
			break;
		case 0xE1: //SBC_IndX();
			if(curr_cycle==1)
			{
				IndX();
				SBC();
			}
			if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0xE4: //CPX_Zero();
			if(curr_cycle==1)
			{
				Zero();
				CPX();
			}
			if(curr_cycle++==2)
				curr_inst=0x80;
			break;
		case 0xE5: //SBC_Zero();
			if(curr_cycle==1)
			{
				Zero();
				SBC();
			}
			if(curr_cycle++==2)curr_inst=0x80;
			break;
		case 0xE6: //INC_Zero();
			if(curr_cycle==1)
			{
				Zero();
				Poke(address,gen1=Peek(address)+1);
				setflags(gen1);
			}
			if(curr_cycle++==4) curr_inst=0x80;
			break;
		case 0xE8: //INX();
			x_reg++;
			setflags(x_reg);
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xE9: //SBC_Imm();
			Imm();
			SBC();
			curr_inst=0x80;
			break;
			
			// UNDOC'D
		case 0x1A:
		case 0x3A:
		case 0x5A:
		case 0x7A:
		case 0xDA:
		case 0xFA:
		case 0xEA: //NOP();
			curr_loc++;
			curr_inst=0x80;
			break;
		case 0xEC: //CPX_Abs();
			if(curr_cycle==1)
			{
				Abs();
				CPX();
			}
			if(curr_cycle++==3)
				curr_inst=0x80;
			break;
		case 0xED: //SBC_Abs();
			if(curr_cycle==1)
			{
				Abs();
				SBC();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0xEE: //INC_Abs();
			if(curr_cycle==1)
			{
				Abs();
				Poke(address,gen1=Peek(address)+1);
				setflags(gen1);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0xF0: //BEQ();
			if(curr_cycle==1)curr_loc+=2;
			if(flags&ZERO)
			{
				if(curr_cycle==2)
				{
					
					curr_loc+=(signed char)(gen1=Peek(curr_loc-1));
					if((curr_loc/256)==((curr_loc+(signed char)gen1)/256));
					{
						curr_inst=0x80;
					}
				}
				if(curr_cycle++==3)curr_inst=0x80;
			}
			else {curr_inst=0x80;}
			break;
		case 0xF1: //SBC_Ind_Y();
			if(curr_cycle==1)
			{
				Ind_Y();
				SBC();
			}
			if(curr_cycle++==4)curr_inst=0x80;
			break;
		case 0xF5: //SBC_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				SBC();
			}
			if(curr_cycle++==3)curr_inst=0x80;
			break;
		case 0xF6: //INC_Zero_X();
			if(curr_cycle==1)
			{
				Zero_X();
				Poke(address,gen1=Peek(address)+1);
				setflags(gen1);
			}
			if(curr_cycle++==5) curr_inst=0x80;
			break;
		case 0xF8: //SED();
			flags&=DECIMAL;
			curr_inst=0x80;
			curr_loc++;
			break;
		case 0xF9: //SBC_Abs_Y();
			if(curr_cycle==1)
			{
				Abs_Y();
				SBC();
			}
			if(((address-y_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0xFD: //SBC_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				SBC();
			}
			if(((address-x_reg)/256)==(address/256))
			{
				if(curr_cycle++==4)curr_inst=0x80;
			}
			else if(curr_cycle++==5)curr_inst=0x80;
			break;
		case 0xFE: //INC_Abs_X();
			if(curr_cycle==1)
			{
				Abs_X();
				Poke(address,gen1=Peek(address)+1);
				setflags(gen1);
			}
			if(curr_cycle++==6) curr_inst=0x80;
			break;
			
			
			// UNDOC'D INSTRUCTIONS ///////////
		case 0x82:	// SKB
		case 0xc2:
		case 0xe2:
		case 0x04:
		case 0x14:
		case 0x34:
		case 0x44:
		case 0x54:
		case 0x64:
		case 0x74:
		case 0x89: // op tests call it NOP #imm ??
		case 0xD4:
		case 0xf4:	curr_loc+=2;	curr_inst=0x80;	break;
		case 0x03: //ASO_Ind_X
			if(curr_cycle==1)
			{
				IndX();
				ASO();
			}
			if(curr_cycle++==8)
				curr_inst=0x80;
			break;
		case 0x07: //ASO_Zero
			if(curr_cycle==1)
			{
				Zero();
				ASO();
			}
			if(curr_cycle++==5)
				curr_inst=0x80;
			break;
		case 0x0B:	//ASO_Imm
			if(curr_cycle==1)
			{
				Imm();
				gen1=Peek(address);
				if(gen1&0x80)
					flags|=CARRY;
				gen1<<=1;
				a_reg|=gen1;
				setflags(a_reg);
			}
			if(curr_cycle++==4)
				curr_inst=0x80;
			break;
		case 0x0F:	Abs(); ASO();	break;
		case 0x13:	Ind_Y(); ASO();	break;
		case 0x17:	//ASO_Zero_X
			if(curr_cycle==1)
			{
				Zero_X();
				ASO();
			}
			if(curr_cycle++==6)
				curr_inst=0x80;
			break;
		case 0x1B:	Abs_Y();	ASO();	break;
		case 0x1F:	Abs_X();	ASO();	break;//
		case 0x23:	IndX();	RLA();	break;
		case 0x27:	Zero();	RLA();	break;
			//case 0x2B:	Imm();	RLA();	break;
			//case 0x2F:	Abs();	RLA();	break;
			//case 0x33:	Ind_Y();	RLA();	break;
			//case 0x37:	Zero_X();	RLA();	break;
			//case 0x3B:	Abs_Y();	RLA();	break;
			//case 0x3F:	Abs_X();	RLA();	break;//
			//case 0x43:	IndX();	LSE();	break;
			//case 0x47:	Zero();	LSE();	break;
			//case 0x4B:	Imm();	ALR();	break;//
			//case 0x4F:	Abs();	LSE();	break;
			//case 0x53:	Ind_Y();	LSE();	break;
			//case 0x57:	Zero_X();	LSE();	break;
			//case 0x5B:	Abs_Y();LSE();	break;
			//case 0x5F:	Abs_X();	LSE();	break; //
			//case 0x63:	IndX();	RRA();	break;
			//case 0x67:	Zero();	RRA();	break;
			//case 0x6B:	Imm();	ARR();	break; //
			//case 0x6F:	Abs();	RRA();	break;
			//case 0x73:	Ind_Y();	RRA();	break;
			//case 0x77:	Zero_X();	RRA();	break;
			//case 0x7B:	Abs_Y();	RRA();	break;
			//case 0x7F:	Abs_X();	RRA();	break;
			//case 0x83:	IndX();	AXS();	break;
		case 0x87:	Zero();	AXS();	break;
		case 0x8F:	Abs();	AXS();	break;
			//case 0x97:	Zero_Y();	AXS();	break;
			//case 0xA3:	IndX();	LAX();	break;
		case 0xA7:	Zero();	LAX();	break;
			//case 0xAB:	Imm();	OAL();	break;
		case 0xAF:	Abs();	LAX();	break;
			//case 0xB3:	Ind_Y();	LAX();	break;
			//case 0xB7:	Zero_X();	LAX();	break;
			//case 0xBF:	Abs_Y();	LAX();	break;
			//case 0xC3:	IndX();		DCM();	break;
			//case 0xC7:	Zero();		DCM();	break;
			//case 0xCB:	Imm();		SAX();	break;
			//case 0xCF:	Abs();		DCM();	break;
			//case 0xD3:	Ind_Y();	DCM();	break;
			//case 0xD7:	Zero_X();	DCM();	break;
			//case 0xDB:	Abs_Y();	DCM();	break;
			//case 0xDF:	Abs_X();	DCM();	break;
			//case 0xE3:	IndX();		INS();	break;
			//case 0xE7:	Zero();		INS();	break;
			//case 0xEF:	Abs();		INS();	break;
			//case 0xF3:	Ind_Y();	INS();	break;
			//case 0xF7:	Zero_X();	INS();	break;
			//case 0xFB:	Abs_Y();	INS();	break;
		case 0xFF:	Abs_X();INS();break;
		case 0x0C:	// SKW
		case 0x1C:
		case 0x3C:
		case 0x5C:
		case 0x7C:
		case 0xDC:
		case 0xFC:	curr_loc+=3;	curr_inst=0x80;	break;
			
		default:if(illopc)
					Processor_hung(curr_loc,curr_inst,jmp_from);
			curr_loc++;
			curr_inst=0x80;
		}// end switch
		
		// end 6510
		// CIA 1
		
		if(enable1a)
		{
			if(t1a==0)
			{
				t1a=*(unsigned int *)&CIA1Regs[4]=latch1a;
				if(CIA1Regs[0xE]&0x08) CIA1Regs[0xE]&=254;
				if(ICR1set&0x01)
				{
					IRQ=1;
					CIA1Regs[0xD]=0x80;
				}
				CIA1Regs[0xD]|=1;
				if((CIA1Regs[0xF]&0x60)==0x40)CIA1Regs[6]=--t1b;
			}
			CIA1Regs[4]=--t1a;
		}
		if(enable1b)
		{
			if(t1b==0)
			{
				t1b=*(unsigned int *)&CIA1Regs[6]=latch1b;
				if(CIA1Regs[0xF]&0x08) CIA1Regs[0xF]&=254;
				if(ICR1set&0x02)
				{
					IRQ=1;
					CIA1Regs[0xD]=0x80;
				}
				CIA1Regs[0xD]|=2;
			}
			else
			{
				if((CIA1Regs[0xF]&0x60)==0)
				{
					CIA1Regs[6]=--t1b;
				}
			}
		}
		
		// end CIA 1
		// CIA 2
		
		if(enable2a)
		{
			if(t2a==0)
			{
				t2a=*(unsigned int *)&CIA2Regs[4]=latch2a;
				if(CIA2Regs[0xE]&0x08) CIA2Regs[0xE]&=254;
				if(ICR2set&0x01)
				{
					NMI=1;
					CIA2Regs[0xD]=0x80;
				}
				CIA2Regs[0xD]|=1;
				if((CIA2Regs[0xF]&0x60)==0x40)CIA2Regs[0x6]=--t2b;
			}
			CIA2Regs[0x4]=--t2a;
		}
		if(enable2b)
		{
			if(t2b==0)
			{
				t2b=*(unsigned int *)&CIA2Regs[6]=latch2b;
				if(CIA2Regs[0xF]&0x08) CIA2Regs[0xF]&=254;
				if(ICR2set&0x02)
				{
					NMI=1;
					CIA2Regs[0xD]=0x80;
				}
				CIA2Regs[0xD]|=2;
			}
			else if((CIA2Regs[0xF]&0x60)==0) CIA2Regs[0x6]=--t2b;
		}
		
		// end CIA 2
		
		cycles++;
	}
	
}



/////////////////////////////////////////////////////////////////////////////



void interrupt New_Key_Int(void)

{
	
	int x;
	asm cli;
	scan = inp(0x60);
	if(scan > 0x7F) {if(key[scan ^ 0x80]) {keysdown--; key[scan ^ 0x80] = 0;}}
	else  { if(!key[scan]) {keysdown++; key[scan] = 1;} }
	rawkey=scan;
	if(rawkey&0x80)
		key_pressed[key_table[rawkey&0x7f][0]]|=key_table[rawkey&0x7f][1];
	else
		key_pressed[key_table[rawkey][0]]&=~key_table[rawkey][1];
	_asm { mov al, 0x20; out 0x20, al; }
	asm sti;
}



/////////////////////////////////////////////////////////////////////////////

//#include "CB64.NTR"  <-- OK, Joe Forster, it's gone now :)
//                         you were right, it starts much faster now
//			   (and 6K smaller too!).


// PATCH #include  "FLTNTR.C"

void main(void)
{
	unsigned char KEYTABLEDAT[257]={
		
		0,0,'','',2,2,4,4,8,8,16,16,' ','@',1,'','',2,2,4,4,8,8,16,16,' ',
			
			' ','@',1,'',2,2,4,4,8,8,16,16,' ',' ','@','',2,' ',2,4,4,8,8,16,16,
			
			' ',' ','@','@',0,'','',0,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
			
			1,0,0,0,0,0,0,'@','@',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,8,1,8,1,8,1,8,1,8,8,' ',1,'','@',
			
			2,'@',2,'@',2,'@',2,'@',2,'@',2,2,4,4,' ',4,' ',4,' ',4,' ',4,' ',4,2,
			
			'',1,16,'',16,'',16,'',16,'',16,'',16,0,' ',16,0,16,0,' ',0,'@',
			
			0,8,0,0,0,0,0,0,0,0,0,0,0,4,0,0,'',0,0,0,0,0,0,8,'@',0,0,0,0,0,0,0,0,
			
			0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		
		long int temp; unsigned int index;
		struct dostime_t t; _dos_gettime(&t);
		
		
		printf ("Come Back 64 version %i.%i%i\n\n",VERMAJ,VERMIN,VERMINTWO);
		printf ("By J. Fiti and B. Martin\n");
		printf ("www.classicgaming.com/cb64\n");
		printf ("jhf@fairlight.to\nmartin@gvi.net\n");
		printf ("---\n\n");
		
		printf (" Allocating memory..."); AllocMem(); printf ("Done\n");
		printf (" Loading ROM's..."); LoadROM(); printf ("Done\n");
		
		// mainintro();
		
		printf (" Setting up C64 keyboard emulation...");
		for(index=0;index<128;index++)key_table[index][0]=KEYTABLEDAT[index];
		
		for(index=0;index<128;index++)key_table[index][1]=KEYTABLEDAT[index+128];
		
		for(index=0;index<255;index++){key_pressed[index]=255;}
		printf ("Done\n");
		
		printf (" Clearing emulator memory...");
		clearmem (); printf ("Done\n");
		
#ifdef SOUND
		printf (" Allocating memory for sound...");
		if(SNDInit(22727,75)) // <- sample frequency, updates/second
			Cleanup("Error allocating memory for sound");
		printf ("Done\n");
#endif
		
		/*printf (" Getting LPT1 for parallel 1541..."); PPORT=peek(0x40,8)+2;
		outp(PPORT,0); delay (500); outp(PPORT,255);
		printf ("Done\n");*/
		
#ifdef SOUND
		printf (" Checking Soundblaster..."); sbgetset();
		SNDStart(0); printf ("Done\n");
		printf (" Setting sound volume..."); sbvol (volume); printf ("Done\n");
#endif
		printf ("\nSTARTING EMULATION AT %d:%02d:%02d\n...\n",t.hour,t.minute,t.second);
		coolintro();
		SetMode(0x13); modeset=1;
		setcolors ();
		MainLoop();
#ifdef SOUND
		SNDClose(0);
#endif
		// Message ("SHUTTING DOWN...",250);
		
		Cleanup("");
		
}

// ADD BY MAX
///////////////////////////////////////////////////////////////////
void loadcrt (unsigned char fname[80])
{
	int hfile,nread,ret;
	unsigned int cont;
	unsigned int ret_read;
	unsigned char CRT_HEADER[64];
	unsigned char CRT_CHIP[16];
	char *CRT_BUFFER;
	
	hfile=open(fname,O_RDONLY | O_BINARY);
	if (hfile<=0)
		Cleanup ("Error opening cartridge file");
	if((CRT_BUFFER=(char *)malloc(8200))==NULL)
	{
		Cleanup ("Error loading cartridge file");
	}
	nread=read(hfile,(char *)CRT_HEADER,64);
	cart.hardtype=CRT_HEADER[21];
	
	// Now loading Normal Cartrifge only, and Simons Basic
	if (cart.hardtype!=4 && cart.hardtype!=0)
		return;
	while (nread>0)
	{
		nread=read(hfile,(char *)CRT_CHIP,16);
		if (nread<=0) break;
		cart.address=(CRT_CHIP[0x0C]<<8)+CRT_CHIP[0x0D];
		cart.length=(CRT_CHIP[0x0E]<<8)+CRT_CHIP[0x0F];
		cart.bank=CRT_CHIP[0x0B];
		
		nread=read (hfile,(char *)CRT_BUFFER,cart.length);
		if (nread<=0) break;
		for (cont=0;cont<cart.length;cont++)
			RAMPointer[cart.address+cont]=CRT_BUFFER[cont];
	}
	close(hfile);
	free(CRT_BUFFER);
	reset=2;
}
///////////////////////////////////////////////////////////////////
